/*******************************************************************************
**
** The source file for the Jahshaka Core jahfile module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"
#include <qfiledialog.h>

////////////////////////////////////////////////
// 3d object loaders

//////////////////////////////////////////////////////////////
// popup object loaders

void motionPath::loadObjObject(void) {

    QString format = "obj";

    QString filename = QFileDialog::getOpenFileName( JahBasePath+"/models",  QString( "*.%1" ).arg( format.lower() )  );
    if ( !filename.isEmpty() ) {
        QString temp; int i; temp = filename;
        i = temp.length();	i -= 4;   //get rid of 4 char extension
	
        objfilename = temp.left(i);
        objextension = "."+format;

         loadOBJ(objfilename+objextension);       //backdrop  was ships
    }

}

void motionPath::loadMaxObject(void) {

    QString format = "3ds";

    QString filename = QFileDialog::getOpenFileName( JahBasePath+"/models",  QString( "*.%1" ).arg( format.lower() )  );
    if ( !filename.isEmpty() ) {
        QString temp; int i; temp = filename;
        i = temp.length();	i -= 4;   //get rid of 4 char extension

        objfilename = temp.left(i);
        objextension = "."+format;

         loadMaxOBJ(objfilename+objextension);       //backdrop  was ships
    }

}



//should be bool so we know if it worked
bool motionPath::loadOBJ(const QString filename) {

  if (model) glmDelete(model);

  const char* text1= filename;
  int   text1len =  filename.length();
  char* rere = new char[text1len];
  strcpy(rere,text1);

  model = glmReadOBJ(rere);   //was model_file

  scale = glmUnitize(model);
  glmFacetNormals(model);
  glmVertexNormals(model, smoothing_angle);

  if (model->nummaterials > 0) material_mode = 2;
                          else material_mode = 0;

  glmScale(model, 10);

  if (model) return true;

}

bool motionPath::loadMaxOBJ(const QString filename) {

  bool status;

  if (!scene) { scene = new L3DS; } else
  if (scene) { delete scene; scene = new L3DS; }

  debug("loading max object");
  debug(filename);
  debug("------------------");

  const char* text1= filename;
  int   text1len =  filename.length();
  char* rere = new char[text1len];
  strcpy(rere,text1);

  if (!scene->LoadFile(rere))//was scene2->
      {
          debug("Unable to open obj file");
          status = false;
      } else {

  debug("3ds max file loaded");
  status = true;
  }

  return status;
}


void motionPath::makeObj() {

 //just got to figure out texturing properly!

 glShadeModel( GL_SMOOTH );

 if (material_mode == 0) {
        if (facet_normal)
            glmDraw(model, GLM_FLAT);
        else
            glmDraw(model, GLM_SMOOTH);
    } else if (material_mode == 1) {
        if (facet_normal)
            glmDraw(model, GLM_FLAT | GLM_COLOR);
        else
            glmDraw(model, GLM_SMOOTH | GLM_COLOR);
    } else if (material_mode == 2) {
        if (facet_normal)
            glmDraw(model, GLM_FLAT | GLM_MATERIAL);
        else
            glmDraw(model, GLM_SMOOTH | GLM_MATERIAL);
    }

}

void motionPath::makeMaxObj() {

  glShadeModel( GL_SMOOTH );
  glEnable(GL_NORMALIZE);
  glEnable(GL_LIGHTING);

  //if textureing is on... need a flag for this
  glEnable(GL_TEXTURE_2D);
  //makeLayerTexture();

    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_TEXTURE_COORD_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);
    glEnableClientState(GL_COLOR_ARRAY);

  int a = scene->GetMeshCount();


  if (JAHDEBUG)	{	 printf("There are %d meshes in the 3ds file\n", a);
  				    debug("drawing the 3ds max object"); }

      for (uint i= 0; i<scene->GetMeshCount(); i++)
      {
        LMesh &mesh = scene->GetMesh(i);

        glVertexPointer(4, GL_FLOAT, 0, &mesh.GetVertex(0));
        glTexCoordPointer(4, GL_FLOAT, 0, &mesh.GetVertex(0));
        glNormalPointer(GL_FLOAT, 0, &mesh.GetNormal(0));
        glColorPointer(3, GL_FLOAT, 0, &mesh.GetBinormal(0));
        glDrawElements(GL_TRIANGLES, mesh.GetTriangleCount()*3,
        GL_UNSIGNED_SHORT, &mesh.GetTriangle(0));

      }

    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    glDisableClientState(GL_COLOR_ARRAY);

}


