/*******************************************************************************
**
** The source file for the Jahshaka Core jahfile module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"

////////////////////////////////////////////////
// avi texture routines taken from nehe lesson 36
/*
#ifdef WIN32

void motionPath::flipIt(void* buffer)										// Flips The Red And Blue Bytes (256x256)
{
	void* b = buffer;											// Pointer To The Buffer
	__asm														// Assembler Code To Follow
	{
		mov ecx, 256*256										// Counter Set To Dimensions Of Our Memory Block
		mov ebx, b												// Points ebx To Our Data (b)
		label:													// Label Used For Looping
			mov al,[ebx+0]										// Loads Value At ebx Into al
			mov ah,[ebx+2]										// Loads Value At ebx+2 Into ah
			mov [ebx+2],al										// Stores Value In al At ebx+2
			mov [ebx+0],ah										// Stores Value In ah At ebx
			
			add ebx,3											// Moves Through The Data By 3 Bytes
			dec ecx												// Decreases Our Loop Counter
			jnz label											// If Not Zero Jump Back To Label
	}
}

//void motionPath::OpenAVI(LPCSTR szFile)										// Opens An AVI File (szFile)
void motionPath::OpenAVI(QString szFile)										// Opens An AVI File (szFile)
{
	//TCHAR	title[100];											// Will Hold The Modified Window Title
	debug("AVI filename is"+szFile);
	AVIFileInit();												// Opens The AVIFile Library

	// Opens The AVI Stream
	if (AVIStreamOpenFromFile(&pavi, szFile, streamtypeVIDEO, 0, OF_READ, NULL) !=0)
	{
		debug("Failed to open The AVI file");
	}

	AVIStreamInfo(pavi, &psi, sizeof(psi));						// Reads Information About The Stream Into psi
	aviwidth=psi.rcFrame.right-psi.rcFrame.left;					// Width Is Right Side Of Frame Minus Left
	aviheight=psi.rcFrame.bottom-psi.rcFrame.top;					// Height Is Bottom Of Frame Minus Top

	avilastframe=AVIStreamLength(pavi);							// The Last Frame Of The Stream

	mpf=AVIStreamSampleToTime(pavi,avilastframe)/avilastframe;		// Calculate Rough Milliseconds Per Frame

	bmih.biSize = sizeof (BITMAPINFOHEADER);					// Size Of The BitmapInfoHeader
	bmih.biPlanes = 1;											// Bitplanes	
	bmih.biBitCount = 24;										// Bits Format We Want (24 Bit, 3 Bytes)
	bmih.biWidth = 256;											// Width We Want (256 Pixels)
	bmih.biHeight = 256;										// Height We Want (256 Pixels)
	bmih.biCompression = BI_RGB;								// Requested Mode = RGB

	hBitmap = CreateDIBSection (hdc, (BITMAPINFO*)(&bmih), DIB_RGB_COLORS, (void**)(&data), NULL, NULL);
	SelectObject (hdc, hBitmap);								// Select hBitmap Into Our Device Context (hdc)

	pgf=AVIStreamGetFrameOpen(pavi, NULL);						// Create The PGETFRAME	Using Our Request Mode
	if (pgf==NULL)
	{
		debug("An Error Occurred Opening The Frame");

	} else {
	QString temp;
	debug("Width is"+temp.setNum(aviwidth)); 
	debug("Height is"+temp.setNum(aviheight)); 
	//debug("LastFrame is"+temp.setNum(lastframe));


	}

}

////////////////////////////////////////////////////////////////
// cant figure out how to grab the avi into a QImage
// although we can grab it directly into a texture...
// but that requires rewriting all the video-texture routines

QImage motionPath::GrabAVIFrame(int frame)									// Grabs A Frame From The Stream
{
	debug("grabbing the frame");
	LPBITMAPINFOHEADER lpbi;												// Holds The Bitmap Header Information
	lpbi = (LPBITMAPINFOHEADER)AVIStreamGetFrame(pgf, frame);				// Grab Data From The AVI Stream **returns a DIB
	pdata=(char *)lpbi+lpbi->biSize+lpbi->biClrUsed * sizeof(RGBQUAD);		// Pointer To Data Returned By AVIStreamGetFrame

	// Convert Data To Requested Bitmap Format
	DrawDibDraw (hdd, hdc, 0, 0, 256, 256, lpbi, pdata, 0, 0, aviwidth, aviheight, 0);

	flipIt(data);												// Swap The Red And Blue Bytes (GL Compatability)

//	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, 256, 256, GL_RGB, GL_UNSIGNED_BYTE, data);
//	QImage thedata = QImage(data, aviwidth,aviheight,32,0,256,QImage::LittleEndian);
//	return thedata;

	QImage thedata; thedata = bitmapToImage( hdc, hBitmap );
	return thedata;


}

void motionPath:: CloseAVI(void)												// Properly Closes The Avi File
{
	debug("Closing AVI file");

	DeleteObject(hBitmap);										// Delete The Device Dependant Bitmap Object
	DrawDibClose(hdd);											// Closes The DrawDib Device Context
	AVIStreamGetFrameClose(pgf);								// Deallocates The GetFrame Resources
	AVIStreamRelease(pavi);										// Release The Stream
	AVIFileExit();												// Release The File
}

QImage motionPath::bitmapToImage(HDC chdc, HBITMAP chBitmap)
{
	debug("converting the frame");
	QImage res;
	BITMAP bmp;
    PBITMAPINFO pbmi;
    WORD    cClrBits;

    // Retrieve the bitmap color format, width, and height.
    if (!GetObject(chBitmap, sizeof(BITMAP), (LPSTR)&bmp))
        return res;

    // Convert the color format to a count of bits.
    cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel);
    if (cClrBits == 1)
        cClrBits = 1;
    else if (cClrBits <= 4)
        cClrBits = 4;
    else if (cClrBits <= 8)
        cClrBits = 8;
    else if (cClrBits <= 16)
        cClrBits = 16;
    else if (cClrBits <= 24)
        cClrBits = 24;
    else cClrBits = 32;

    // Allocate memory for the BITMAPINFO structure. (This structure
    // contains a BITMAPINFOHEADER structure and an array of RGBQUAD
    // data structures.)

	if (cClrBits != 24) {
		pbmi = (PBITMAPINFO) new unsigned char[sizeof(BITMAPINFOHEADER) +  sizeof(RGBQUAD) * (1<< cClrBits)]; }
     // There is no RGBQUAD array for the 24-bit-per-pixel format. 

	else {
		pbmi = (PBITMAPINFO) new unsigned char[sizeof(BITMAPINFOHEADER)]; }

    // Initialize the fields in the BITMAPINFO structure. 

    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
    pbmi->bmiHeader.biWidth = bmp.bmWidth; 
    pbmi->bmiHeader.biHeight = bmp.bmHeight; 
    pbmi->bmiHeader.biPlanes = bmp.bmPlanes; 
    pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel; 
    if (cClrBits < 24) 
        pbmi->bmiHeader.biClrUsed = (1<<cClrBits); 

    // If the bitmap is not compressed, set the BI_RGB flag. 
    pbmi->bmiHeader.biCompression = BI_RGB; 

    // Compute the number of bytes in the array of color 
    // indices and store the result in biSizeImage. 
    // For Windows NT, the width must be DWORD aligned unless 
    // the bitmap is RLE compressed. This example shows this. 
    // For Windows 95/98/Me, the width must be WORD aligned unless the 
    // bitmap is RLE compressed.
    pbmi->bmiHeader.biSizeImage = ((pbmi->bmiHeader.biWidth * cClrBits +31) & ~31) /8
                                  * pbmi->bmiHeader.biHeight; 
    // Set biClrImportant to 0, indicating that all of the 
    // device colors are important. 
     pbmi->bmiHeader.biClrImportant = 0;
	 
    BITMAPFILEHEADER hdr;       // bitmap file-header 
    PBITMAPINFOHEADER pbih;     // bitmap info-header 
    LPBYTE lpBits;              // memory pointer 
    DWORD dwTotal;              // total count of bytes 
    DWORD cb;                   // incremental count of bytes 
    BYTE *hp;                   // byte pointer 

    pbih = (PBITMAPINFOHEADER) pbmi; 
    lpBits = (LPBYTE) new unsigned char[pbih->biSizeImage];     

    // Retrieve the color table (RGBQUAD array) and the bits 
    // (array of palette indices) from the DIB. 
    if (!GetDIBits(chdc, chBitmap, 0, (WORD) pbih->biHeight, lpBits, pbmi, 
        DIB_RGB_COLORS)) 
    {
        delete[] pbmi; 
		delete[] lpBits;
		return res;
    }
    
    hdr.bfType = 0x4d42;        // 0x42 = "B" 0x4d = "M" 
    // Compute the size of the entire file. 
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
                 pbih->biSize + pbih->biClrUsed 
                 * sizeof(RGBQUAD) + pbih->biSizeImage); 
    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 

    // Compute the offset to the array of color indices. 
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
                    pbih->biSize + pbih->biClrUsed 
                    * sizeof (RGBQUAD); 

	dwTotal = cb = pbih->biSizeImage;
	hp = lpBits;
	
	long length1 = sizeof(BITMAPFILEHEADER);
	long length2 = sizeof(BITMAPINFOHEADER) + pbih->biClrUsed * sizeof (RGBQUAD);
	long length3 = dwTotal;
	long length = length1 + length2 + length3;

	unsigned char *finalBuffer = new unsigned char[length];

	memcpy(finalBuffer, &hdr, length1);
	memcpy(finalBuffer + length1, pbih, length2);
	memcpy(finalBuffer + length1 + length2, hp, length3);

	res.loadFromData((uchar *) finalBuffer, length);

	delete[] pbmi;
	delete[] lpBits;
	delete[] finalBuffer;

	return res;
}

#endif

*/

/*

  Note: this code was not cleaned or tested for memory leaks, but it worked
fine on my machine.
=================================================================
(1) Code portions to implent s fly-through (how to use to avi generation
functions):

void GLView::flying()
{
 InitRenderToAvi("F:\\_Projects\\Viewer\\QT 3D Viewer\\test.avi");
 timer->start( 20 );
 m_flying = true;
}

void GLView::fly()
{
 RenderToAvi();
}

void GLView::normal()
{
 timer->stop();
 EndRenderToAvi();
}

----------------------------------------------------------------------------
------
(2) The AVI generation functions
// AVI Generation
BOOL GLView::InitRenderToAvi(const char * szFile )
{
 double v_width  = width();
 double v_height = height();
 AviGen = new CAVIGen( szFile, 40, v_width, v_height );
 AviGen->InitEngine();
 return TRUE;
}

BOOL GLView::RenderToAvi()
{
 // Alloc pixel bytes
 BYTE *pPixelData = new BYTE[AviGen->m_bih.biSizeImage];
 // Make GL Context current
 makeCurrent();
 // Copy from OpenGL

glReadPixels(0,0,AviGen->m_bih.biWidth,AviGen->m_bih.biHeight,GL_BGR_EXT,GL_
UNSIGNED_BYTE,pPixelData);
 // send to avi engine
 AviGen->AddFrame(pPixelData);

 // Cleaning memory
 delete [] pPixelData;
 return TRUE;
}

BOOL GLView::EndRenderToAvi()
{
 // releasing engine and memory
 AviGen->ReleaseEngine();
 return TRUE;
}

(3) cavigen.h/cavigen.cpp
cavigen.h
=======

#ifndef CAVIGEN_H
#define CAVIGEN_H

#include <windows.h>
#include <memory.h>
#include <vfw.h>

class CAVIGen
{
public:

 // Inplace constructor with BITMAPINFOHEADER
 CAVIGen(const char* sFileName, DWORD dwRate, double win_width, double
win_height);
 ~CAVIGen();

 BOOL InitEngine();
 BOOL AddFrame(BYTE* bmBits);
 BOOL ReleaseEngine();

//protected:
 char m_sFile[2048];   // name of output file
 DWORD m_dwRate;    // Frame rate
 BITMAPINFOHEADER m_bih;  // structure contains information for a single
stream

private:
 long m_lFrame;    // frame counter
 PAVIFILE m_pAVIFile;  // file interface pointer
 PAVISTREAM m_pStream;  // Address of the stream interface
 PAVISTREAM m_pStreamCompressed; // Address of the compressed video stream
};

#endif

cavigen.cpp
========

#include "cavigen.h"


CAVIGen::CAVIGen(const char* sFileName, DWORD dwRate, double win_width,
double win_height)
{
 strcpy( m_sFile, sFileName );
 m_dwRate=dwRate;

 double m_width  = win_width;
 double m_height = win_height;

 m_width=(m_width/4)*4;
 m_height=(m_height/4)*4;

 // initialize m_bih
 memset(&m_bih,0, sizeof(BITMAPINFOHEADER));
 // filling bitmap info structure.
 m_bih.biSize=sizeof(BITMAPINFOHEADER);
 m_bih.biWidth=(long)m_width;
 m_bih.biHeight=(long)m_height;
 m_bih.biPlanes=1;
 m_bih.biBitCount=24;
// m_bih.biSizeImage= 3* m_bih.biWidth * m_bih.biHeight;
 m_bih.biSizeImage= ((m_bih.biWidth*m_bih.biBitCount+31)/32 *
4)*m_bih.biHeight;
 m_bih.biCompression=BI_RGB;  //BI_RGB means BRG in reality

 m_pAVIFile=NULL;
 m_pStream=NULL;
 m_pStreamCompressed=NULL;
}

CAVIGen::~CAVIGen()
{
}

BOOL CAVIGen::AddFrame(BYTE *bmBits)
{
 char sError[2048];
 HRESULT hr;

 // compress bitmap
 hr = AVIStreamWrite(
  m_pStreamCompressed, // stream pointer
  m_lFrame,    // time of this frame
  1,      // number to write
  bmBits,     // image buffer
  m_bih.biSizeImage,  // size of this frame
  AVIIF_KEYFRAME,   // flags....
  NULL,
  NULL);

 // updating frame counter
 m_lFrame++;

 if (hr != AVIERR_OK)
 {
  strcpy( sError, "Unable to write data to stream.");
  return FALSE;
 }

 return TRUE;
}



BOOL CAVIGen::InitEngine()
{

 AVISTREAMINFO strHdr; // information for a single stream
 AVICOMPRESSOPTIONS opts;
 AVICOMPRESSOPTIONS FAR * aopts[1] = {&opts};

 char sError[2048];

 HRESULT hr;

 // Step 0 : Let's make sure we are running on 1.1
 DWORD wVer = HIWORD(VideoForWindowsVersion());
 if (wVer < 0x010a)
 {
   // oops, we are too old, blow out of here
  strcpy( sError, "Version of Video for Windows too old. Come on, join the
21th century!");
  return FALSE;
 }

 // Step 1 : initialize AVI engine
 AVIFileInit();

 // Step 2 : Open the movie file for writing....
 hr = AVIFileOpen(&m_pAVIFile,   // Address to contain the new file
interface pointer
         (LPCSTR)m_sFile,    // Null-terminated string containing the name
of the file to open
         OF_WRITE | OF_CREATE,     // Access mode to use when opening the
file.
         NULL);      // use handler determined from file extension.
           // Name your file .avi -> very important

 if (hr != AVIERR_OK)
 {
  strcpy( sError, "AVI Engine failed to initialize.");
  return FALSE;
 }

 // Fill in the header for the video stream....
 memset(&strHdr, 0, sizeof(strHdr));
 strHdr.fccType                = streamtypeVIDEO; // video stream type
 strHdr.fccHandler             = 0;
 strHdr.dwScale                = 1;     // should be one for video
 strHdr.dwRate                 = m_dwRate;      // fps
 strHdr.dwSuggestedBufferSize  = m_bih.biSizeImage; // Recommended buffer
size, in bytes, for the stream.
 SetRect(&strHdr.rcFrame, 0, 0,      // rectangle for stream
     (int) m_bih.biWidth,
     (int) m_bih.biHeight);

 // Step 3 : Create the stream;
 hr = AVIFileCreateStream(m_pAVIFile,      // file pointer
            &m_pStream,      // returned stream pointer
            &strHdr);     // stream header

 // Check it succeded.
 if (hr != AVIERR_OK)
 {
  strcpy( sError, "AVI Stream creation failed. Check Bitmap info.");
  return FALSE;
 }


 // Step 4: Get codec and infos about codec
 memset(&opts, 0, sizeof(opts));
 // Poping codec dialog
 if (!AVISaveOptions(NULL, 0, 1, &m_pStream, (LPAVICOMPRESSOPTIONS FAR *)
&aopts))
 {
  AVISaveOptionsFree(1,(LPAVICOMPRESSOPTIONS FAR *) &aopts);
  return FALSE;
 }

 // Step 5:  Create a compressed stream using codec options.
 hr = AVIMakeCompressedStream(&m_pStreamCompressed,
    m_pStream,
    &opts,
    NULL);

 if (hr != AVIERR_OK)
 {
  strcpy( sError, "AVI Compressed Stream creation failed.");
  return FALSE;
 }

 // releasing memory allocated by AVISaveOptionFree
 hr=AVISaveOptionsFree(1,(LPAVICOMPRESSOPTIONS FAR *) &aopts);
 if (hr!=AVIERR_OK)
 {
  strcpy( sError, "Error releasing memory");
  return FALSE;
 }

 // Step 6 : sets the format of a stream at the specified position
 hr = AVIStreamSetFormat(m_pStreamCompressed,
     0,   // position
     &m_bih,     // stream format
     m_bih.biSize +   // format size
     m_bih.biClrUsed * sizeof(RGBQUAD));

 if (hr != AVIERR_OK)
 {
  strcpy( sError, "AVI Compressed Stream format setting failed.");
  return FALSE;
 }

 // Step 6 : Initialize step counter
 m_lFrame=0;

 return TRUE;
}

BOOL CAVIGen::ReleaseEngine()
{
 if (m_pStream)
 {
  AVIStreamRelease(m_pStream);
  m_pStream=NULL;
 }

 if (m_pStreamCompressed)
 {
  AVIStreamRelease(m_pStreamCompressed);
  m_pStreamCompressed=NULL;
 }

 if (m_pAVIFile)
 {
  AVIFileRelease(m_pAVIFile);
  m_pAVIFile=NULL;
 }

 // Close engine
 AVIFileExit();

 return TRUE;
}

*/

/*
To create an AVI from a bunch of files. The following code creates an AVI out of five bitmaps (1.bmp, 2.bmp, ... 5.bmp) and a WAV file (wav.wav).

  //http://www.wischik.com/lu/programmer/avi_utils.html

const char *fns[] = {"1.bmp","2.bmp","3.bmp","4.bmp","5.bmp"};
HAVI avi = CreateAvi("test.avi",1000,NULL); // 1000ms is the period between frames
for (int i=0; i<sizeof(fns)/sizeof(fns[0]); i++)
{ HBITMAP hbm=(HBITMAP)LoadImage(NULL,fns[i],IMAGE_BITMAP,0,0,LR_LOADFROMFILE|LR_CREATEDIBSECTION);
  AddAviFrame(avi,hbm);
  DeleteObject(hbm);
}
AddAviWav(avi,"wav.wav",SND_FILENAME);
CloseAvi(avi);

*/