/*******************************************************************************
**
** The source file for the Jahshaka Core jahfile module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"
#include <qfiledialog.h>

////////////////////////////////////////////////////////////////////////////
// our file loader can handle 24 or 32 bit images with alpha and they work!
// need to get a TGA QImageIO handler to do qimages!


bool motionPath::LoadGlImage( const QString loadfilename, VideoCategory imagetype ) {

    QImage buf;

	// this routine loads the image
	if ( loadintoimage( loadfilename, buf ) )
		{ layer = true; }  else { layer = false; }

    if (imagetype==IMAGE) {

      textureData =   buildGlTexture (buf);
      InitializeTexture(textureData); } //486; }

    if (imagetype==KEY) {               //make negative of key data
		if (invertKey) { buf.invertPixels(); }
	
	  textureKey =  buildGlTexture ( buf );
      InitializeTexture(textureKey); } //486; }
/*
#ifdef WIN32
    if (imagetype==AVI) {
		OpenAVI(filename);
		buf = GrabAVIFrame(1);
		CloseAVI();
      textureData =  buildGlTexture (buf);
      InitializeTexture(textureData); } //486; }
#endif
*/
    return layer;

}

bool motionPath::LoadLayerImage( VideoCategory imagetype ) {
    QImage buf;
	QString loadfilename;


	//using getsequencefilename here is cool as it adds things at the right place
	//but it has issues with layer creation
	//and if currentframe hasnt been updated yet

    if (imagetype==IMAGE) { if (videotex)	{ loadfilename = getsequencefilename(currentframe); }
    //if (imagetype==IMAGE) { if (videotex)	{ loadfilename = pathname + filename + videoext + extension; }
							else			{ loadfilename = pathname + filename + extension; } }

    if (imagetype==KEY)   { if (videotexkey){ loadfilename = getkeysequencefilename(currentframe); }
    //if (imagetype==KEY)   { if (videotexkey){ loadfilename = keypathname + keyfilename + videoextkey + keyextension; }
							else			{ loadfilename = keypathname + keyfilename + keyextension; } }


	//if (JAHDEBUG) debug("Loading image >>:"+ loadfilename);

	// this routine loads the image
	if ( loadintoimage( loadfilename, buf ) )
		{ layer = true; }  else { layer = false; }

	//we need to make this a funtion as well
    if (imagetype==IMAGE) {
      textureData =  buildGlTexture (buf);
      InitializeTexture(textureData); }

    if (imagetype==KEY) {               //make negative of key data
		if (invertKey) { buf.invertPixels(); }
	
	  textureKey =  buildGlTexture ( buf );
      InitializeTexture(textureKey); }

    return layer;

}
//////////////////////////////////////////////////
// used for series of frames
//called by updateVidTex

bool motionPath::LoadImage( const QString loadfilename ) {

    QImage buf;
    bool returnval = TRUE;

	// this routine loads the clip
	returnval = loadintoimage( loadfilename, buf );


    if (returnval) {
      textureData.objectImage = buf;
      InitializeTexture(textureData);
    }

    return returnval;
}

//////////////////////////////////////////////////
// used for series of frames
//called by updateVidTex

bool motionPath::LoadKey( const QString loadfilename ) {

    QImage buf;
    bool returnval;

	// this routine loads the key
	returnval = loadintoimage( loadfilename, buf );


    if (returnval) {  if (invertKey) buf.invertPixels();  //make negative of key data
      textureKey.objectImage = buf;
      InitializeTexture(textureKey);
    }

    return returnval;
}


// this is a generic load routine it loads <filename> into <image>

bool motionPath::loadintoimage( const QString loadfilename, QImage & image) {

    bool returnval = TRUE;

    QImageIO iio; iio.setFileName( loadfilename );
    if ( loadfilename.endsWith( ".tga" ) || loadfilename.endsWith( ".TGA" )) { iio.setFormat("TGA"); }

    if ( iio.read() ) {	image = iio.image(); /*thepic = iio.image(); image = thepic;*/ } else
    {

  		debug( "Unable to load file,"+loadfilename+" attempting default image" );
  		if ( !image.load( JahBasePath+"/images/sky.bmp" ) ) {	// Load first image from file
  			qWarning( "Could not read default image, using single-color instead." );
  			QImage dummy( 256, 256, 32 );
  			dummy.fill( Qt::blue.rgb() );
  			image = dummy;
  			returnval = FALSE;
  		}

    }

	return returnval;

}


// this only loads in BMP files...
// maybe we should just axe it
// and force everyone to use the desktop...
// at least we need to separate path from filename!!!

void motionPath::loadClip(void) {

    //should use the desktop file loader here for videosequences

    QString loadfilename = QFileDialog::getOpenFileName( JahBasePath+"/images",  "*.*"  );
    if ( !loadfilename.isEmpty() ) {

         LoadGlImage(loadfilename,IMAGE);       //backdrop  was ships
    }

    makeTexture();


}

void motionPath::loadKey(void) {

    //should use the desktop file loader here for videosequences

      QString loadfilename = QFileDialog::getOpenFileName( JahBasePath+"/images",  "*.*" );
      if ( !loadfilename.isEmpty() ) {
		  keyStatus=TRUE;
          LoadGlImage(loadfilename,KEY);       //backdrop  was ships
      }

    makeTexture();

}
































