#include "coreobject.h"

void motionPath::clear(void) {

    node->tx=0.0;    node->ty=0.0;    node->tz=0.0;
    node->rx=0.0;    node->ry=0.0;    node->rz=0.0;
    node->sx=1.0;    node->sy=1.0;    node->sz=1.0;  node->sc=1.0;    // we set the default sacle to 5->0 here
    node->Alpha = 100.0;
}

void motionPath::reset(void) {

    for (int i=0; i<numnodes; i++) {
      delete nodes[i];
    }

    numnodes = 0;

    delete node; node = new motionNode;   // node is always equal to the current node

    clear();

}

                                              //problem here with pointer?
void motionPath::addNodes(int currentFrame, motionNode * newNode) {
//need errorchecking if the keyframe already has a node
//also if this is the first keyframe

    //QString ndata;
    //debug("Node number is:"+ndata.setNum(numnodes));

    nodes[numnodes] = new motionNode;
    nodes[numnodes]->copy(newNode);
    nodes[numnodes]->nodenum = currentFrame;

    numnodes+= 1;

    sortNodes();

}

void motionPath::swap(int &x, int &y)
{
    int temp;

    temp = x;
    x = y;
    y = temp;
}


void motionPath::sortNodes(void) {
  //need errorchecking if the keyframe already has a node
  //also if this is the first keyframe

  if (numnodes<2) return;

    //first we need to get all the keyframes and sort them...
//    int a[numnodes];
    int * a = new int[numnodes];

    for (int x=0; x<numnodes; x++) { a[x] = nodes[x]->nodenum; }

    // This is where we do the sorting
    for (int i = 0; i < (numnodes - 1); i++)
    {
        int minIndex = i;

        // Find the index of the minimum element
        for (int j = i + 1; j < numnodes; j++)
        {
            if (a[j] < a[minIndex]) { minIndex = j; }
        }

        // Swap if i-th element not already smallest
        if (minIndex > i) { swap(a[i], a[minIndex]); }
    }

    //now we copy the nodes in order to the sortnodes object
    motionNode * sortnodes = new motionNode[numnodes];

    for (int totalnodes =0; totalnodes<numnodes; totalnodes++) {

       for (int aa=0; aa<=numnodes; aa++) {

           if(nodes[aa]->nodenum == a[totalnodes]) {
               sortnodes[totalnodes].copy(nodes[aa]);
               break;
           }
       }

    }

    //the we copy the snoted nodes back into the main nodes object
    for (int xx =0; xx<numnodes; xx++) { nodes[xx]->copy(&sortnodes[xx]); }

    delete [] sortnodes;

}

void motionPath::updateNodes(int currentFrame) {
  //updates node to value at current keyframe
  //we want to copy values here
  getNode( currentFrame, node);

}


void motionPath::getFirstLastFrame( int *firstFrame, int *lastFrame) {   //debug("fix keyframing here");
  //get current frame position from slider
  //find frame before and frrame after
  //set new frame in between

   *firstFrame = nodes[0]->nodenum;  //nodenum is the keyframe that node was set at
   *lastFrame  = nodes[numnodes-1]->nodenum;
}



int motionPath::getNode(int frameNumber, motionNode *mn) {

    int pn=0, nn=0, a = 0;
    float dist, mult, diff;

    int firstFrame; int lastFrame;
    getFirstLastFrame(&firstFrame, &lastFrame);

    if(frameNumber < firstFrame) frameNumber = firstFrame;
    if(frameNumber > lastFrame)  frameNumber = lastFrame;

    for (a=0; a<numnodes; a++) {
        if(nodes[a]->nodenum == frameNumber) {
            mn->copy(nodes[a]);
            return 0;
        }
    }

    a = 0;
    while(a < (numnodes -1 )) {
        pn = nodes[a]->nodenum;
        nn = nodes[a+1]->nodenum;
        if(pn < frameNumber && nn > frameNumber) break;
        a++;
    }

    if (a == (numnodes-1)) { mn->clear();
        return -1;
    }

    diff = nn - pn;
    mult = (float)(frameNumber - pn) / diff;

    dist = nodes[a + 1]->sx - nodes[a]->sx; mn->sx = nodes[a]->sx + dist * mult;
    dist = nodes[a + 1]->sy - nodes[a]->sy; mn->sy = nodes[a]->sy + dist * mult;
    dist = nodes[a + 1]->sz - nodes[a]->sz; mn->sz = nodes[a]->sz + dist * mult;
    dist = nodes[a + 1]->rx - nodes[a]->rx; mn->rx = nodes[a]->rx + dist * mult;
    dist = nodes[a + 1]->ry - nodes[a]->ry; mn->ry = nodes[a]->ry + dist * mult;
    dist = nodes[a + 1]->rz - nodes[a]->rz; mn->rz = nodes[a]->rz + dist * mult;
    dist = nodes[a + 1]->tx - nodes[a]->tx; mn->tx = nodes[a]->tx + dist * mult;
    dist = nodes[a + 1]->ty - nodes[a]->ty; mn->ty = nodes[a]->ty + dist * mult;
    dist = nodes[a + 1]->tz - nodes[a]->tz; mn->tz = nodes[a]->tz + dist * mult;
    dist = nodes[a + 1]->Alpha - nodes[a]->Alpha; mn->Alpha = nodes[a]->Alpha + dist * mult;

    mn->nodenum = frameNumber;

    return 0;
}

void motionNode::clear(void) {
    nodenum=0;

    tx=0.0;    ty=0.0;    tz=0.0;
    rx=0.0;    ry=0.0;    rz=0.0;
    sx=1.0;    sy=1.0;    sz=1.0;  sc=1.0;    // we set the default sacle to 5.0 here
    Alpha = 100.0;     // as in 100%          // as this is the layer default and will be most common
}

void motionNode::copy(motionNode * mn) {
    nodenum=mn->nodenum;
    tx=mn->tx;    ty=mn->ty;    tz=mn->tz;
    rx=mn->rx;    ry=mn->ry;    rz=mn->rz;
    sx=mn->sx;    sy=mn->sy;    sz=mn->sz;    sc=mn->sc;
    Alpha=mn->Alpha;
}






