/*******************************************************************************
**
** The source file for the Jahshaka Object code
** The Jahshaka Project
** Copyright (C) 2000-2003 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"

//////////////////////////////////////////////////////////
// Layer Control objects

void motionPath::makeLayer( void) {
  //debug("making textured layer");
  glShadeModel( GL_FLAT );   // was GL_SMOOTH
  glNormal3f( 0.0, 0.0, 0.0 );

  glBegin(GL_QUADS);		                // begin drawing a cube

  // Front Face (note that the texture's corners have to match the quad's corners)
  //need to calculate the height/2 and width/2 on texture creation so its not a calculation thats happening all the time
  //store in mapwidth and mapheight

  glTexCoord2f(0.0f,					textureData.texheight);           glVertex3f(-textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Left Of The Texture and Quad
  glTexCoord2f(textureData.texwidth,  textureData.texheight);   glVertex3f( textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Right Of The Texture and Quad
  glTexCoord2f(textureData.texwidth,  1.0f);                    glVertex3f( textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
  glTexCoord2f(0.0f,					1.0f);                            glVertex3f(-textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Left Of The Texture and Quad

  glEnd();

}



void motionPath::makeKeyLayer( void) {
    //debug("making textured layer");
    glShadeModel( GL_FLAT );   // was GL_SMOOTH
    glNormal3f( 0.0, 0.0, 0.0 );

    glBegin(GL_QUADS);		                // begin drawing a cube

    // Front Face (note that the texture's corners have to match the quad's corners)
    glTexCoord2f(0.0f,      textureKey.texheight);              glVertex3f(-textureKey.mapwidth, -textureKey.mapheight,  0.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureKey.texwidth,  textureKey.texheight);   glVertex3f( textureKey.mapwidth, -textureKey.mapheight,  0.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureKey.texwidth,  1.0f);                   glVertex3f( textureKey.mapwidth,  textureKey.mapheight,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
    glTexCoord2f(0.0f,      1.0f);                              glVertex3f(-textureKey.mapwidth,  textureKey.mapheight,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

}

// black background layer is the default black background with red trim

void motionPath::makeBlackBackground( void) {

    glShadeModel( GL_FLAT );
    glNormal3f( 0.0, 0.0, 0.0 );
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    glColor3f(0.0f, 0.0f, 0.0f);

    glBegin(GL_POLYGON);		                // begin drawing a cube

		glTexCoord2f(0.0f,                  textureData.texheight);   glVertex3f(-widthOffset, -heightOffset,  0.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(textureData.texwidth,  textureData.texheight);   glVertex3f( widthOffset, -heightOffset,  0.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(textureData.texwidth,  1.0f);                    glVertex3f( widthOffset,  heightOffset,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
		glTexCoord2f(0.0f,                  1.0f);                    glVertex3f(-widthOffset,  heightOffset,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

	//draw the red outline around the box

    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    glColor3f(1.0f, 0.0f, 0.0f );

    glBegin(GL_POLYGON);		                // begin drawing a line

		glVertex3f(-widthOffset, -heightOffset,  0.0f);	// Bottom Left Of The Texture and Quad
		glVertex3f( widthOffset, -heightOffset,  0.0f);	// Bottom Right Of The Texture and Quad
		glVertex3f( widthOffset,  heightOffset,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
		glVertex3f(-widthOffset,  heightOffset,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);


}

// backgound layer is the background with a texture map

void motionPath::makeBackground( void) {

    glShadeModel( GL_SMOOTH );   // was GL_SMOOTH
    glNormal3f( 0.0, 0.0, 0.0 );

    glBegin(GL_QUADS);		                // begin drawing a cube

    // Front Face (note that the texture's corners have to match the quad's corners)
    glTexCoord2f(0.0f,                  textureData.texheight);   glVertex3f(-widthOffset, -heightOffset,  0.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureData.texwidth,  textureData.texheight);   glVertex3f( widthOffset, -heightOffset,  0.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth,  1.0f);                    glVertex3f( widthOffset,  heightOffset,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
    glTexCoord2f(0.0f,                  1.0f);                    glVertex3f(-widthOffset,  heightOffset,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

}

void motionPath::makeTitleGrid() {

	//debug(">>drawing the new titlesafe");

    glShadeModel( GL_FLAT );
    glNormal3f( 0.0, 0.0, 0.0 );

    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    glBegin(GL_POLYGON);
	// begin drawing a line
    glColor3f(0.0f, 1.0f, 0.0f);

	GLfloat titleWidth  = widthOffset;// * (8/10);
	GLfloat titleHeight = heightOffset;// * (8/10);

    glVertex3f(-titleWidth, -titleHeight,  0.0f);	// Bottom Left Of The Texture and Quad
    glVertex3f( titleWidth, -titleHeight,  0.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f( titleWidth,  titleHeight,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
    glVertex3f(-titleWidth,  titleHeight,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

}

void motionPath::makeBackdropOutline() {

    glShadeModel( GL_FLAT );
    glNormal3f( 0.0, 0.0, 0.0 );
    glColor3f(0.0f, 0.0f, 0.70f);
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

    glBegin(GL_POLYGON);

		glVertex3f(-widthOffset, -heightOffset,  0.0f);	// Bottom Left Of The Texture and Quad
		glVertex3f( widthOffset, -heightOffset,  0.0f);	// Bottom Right Of The Texture and Quad
		glVertex3f( widthOffset,  heightOffset,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
		glVertex3f(-widthOffset,  heightOffset,  0.0f);	// Top Left Of The Texture and Quad

    glEnd();

    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

}


//////////////////////////////////////////////////////////
// Mesh Control objects

void motionPath::initializeMeshLayer( void) {

if (JAHDEBUG)	debug("initializing MESH NOW >>>>>>");

	MeshFirsttime = TRUE;

	GLfloat x, y;
 	x =-36.0;  y =-31.0;

		for (int i = 0; i <= 72; i++) {
		   for (int j = 0; j <= 48; j++)
			  {
				MeshXCoord[i][j] = x;
				MeshYCoord[i][j] = y;

				y += 1.25;
			  }

		x += 1.0;
	    y  =-31.0;
		}

}

void motionPath::setMeshCoord( int i, int j, GLfloat x, GLfloat y) {
	
	MeshXCoord[i][j] = x;
	MeshYCoord[i][j] = y;

}

void motionPath::makeMeshLayer( void) {

  if (JAHDEBUG) debug("making mesh textured layer");

  glShadeModel( GL_SMOOTH );   // was GL_SMOOTH
//  glShadeModel( GL_FLAT );   // was GL_SMOOTH

  glNormal3f( 0.0, 0.0, 0.0 );

	ObjectDisplayMode = false;

    if (ObjectDisplayMode) glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	//this is a cheat used to scale and position the meash...
	//the coords should be correct so we wouldnt have to do this
    glRotatef( 180.0, 1.0, 0.0, 0.0 );
    glScalef( 10.0, 8.3, 1.0 );
    glTranslatef( 0.0, 0.4, 0.0 );
//    glTranslatef( 0.0, -0.25, 0.0 );

	
  glBegin(GL_TRIANGLES);

  int jj,ii;

//we correct for this below
//textured.texheight     =  1- ( textured.height / textured.hresolution );

  for (GLfloat j=1; j<=48; j++) {
		jj = (int)j;

		for (GLfloat i=1; i<=72; i++) {   //should be i/72
        ii = (int)i;

//works when we have clean mapping ie texwidth=1

			// Draw the first triangle of the quad
			glTexCoord2f(  ( (i/73)     *  textureData.texwidth),  -( (j/49)      *   (1-textureData.texheight)) );   glVertex3f( MeshXCoord[ii-1][jj],   MeshYCoord[ii-1][jj],   0);
			glTexCoord2f(  ( ((i+1)/73) *  textureData.texwidth),  -( (j/49)      *   (1-textureData.texheight)) );   glVertex3f( MeshXCoord[ii][jj],     MeshYCoord[ii][jj],     0);
			glTexCoord2f(  ( ((i+1)/73) *  textureData.texwidth),  -( ((j+1)/49)  *   (1-textureData.texheight)) );   glVertex3f( MeshXCoord[ii][jj+1],   MeshYCoord[ii][jj+1],   0);

			// Draw the second triangle of the quad
			glTexCoord2f(  ( (i/73)     *  textureData.texwidth),  -( (j/ 49)     *   (1-textureData.texheight)) );   glVertex3f(MeshXCoord[ii-1][jj],   MeshYCoord[ii-1][jj],   0);
			glTexCoord2f(  ( (i/73)     *  textureData.texwidth),  -( ((j+1)/49)  *   (1-textureData.texheight)) );   glVertex3f(MeshXCoord[ii-1][jj+1], MeshYCoord[ii-1][jj+1], 0);
			glTexCoord2f(  ( ((i+1)/73) *  textureData.texwidth),  -( ((j+1)/49)  *   (1-textureData.texheight)) );   glVertex3f(MeshXCoord[ii][jj+1],   MeshYCoord[ii][jj+1],   0);

		}
  }


  glEnd();

      glScalef( 0.0, 0.0, 0.0 );

}


//////////////////////////////////////////////////////////
// Object interface Control objects

void motionPath::makeLayerTranslate( void) {

	glShadeModel( GL_FLAT );   // was gl_flat
	glNormal3f( 0.0, 0.0, 0.0 );

	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

    glLineWidth( 2.0 );

	glColor3f(0.0f, 0.0f, 0.7f);

    //glBegin (GL_LINE_STRIP);
	glBegin(GL_POLYGON); // begin drawing a cube

	//line setup data

	glVertex3f(-textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Left Of The Texture and Quad
	glVertex3f( textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Right Of The Texture and Quad
	glVertex3f( textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
	glVertex3f(-textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Left Of The Texture and Quad

	glEnd();

	//reset poly mode...
	glLineWidth( 0.5 );
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);



}

void motionPath::makeLayerScale( void) {

	glShadeModel( GL_FLAT );   // was gl_flat
	glNormal3f( 0.0, 0.0, 0.0 );

	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

    glLineWidth( 2.0 );

	glColor3f(0.0f, 0.0f, 0.7f);

    //glBegin (GL_LINE_STRIP);
	glBegin(GL_POLYGON); // begin drawing a cube

	//line setup data

	glVertex3f(-textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Left Of The Texture and Quad
	glVertex3f( textureData.mapwidth, -textureData.mapheight,  0.0f);	// Bottom Right Of The Texture and Quad
	glVertex3f( textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Right Of The Texture and Quad     1.0f 1.0f
	glVertex3f(-textureData.mapwidth,  textureData.mapheight,  0.0f);	// Top Left Of The Texture and Quad

	glEnd();

	//reset poly mode...
	glLineWidth( 0.5 );
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);


}

void motionPath::makeLayerRotate( void) {

	glShadeModel( GL_FLAT );   // was gl_flat
	glNormal3f( 0.0, 0.0, 0.0 );

	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);


	// the rotate object
    GLUquadricObj* q = gluNewQuadric();
	glLineWidth( 2.0 );

	glPushMatrix();

		glNormal3f( 0.0, 0.0, 0.0 );

		// cylinder
		gluQuadricNormals( q, GLU_SMOOTH );


		glColor3f(  0.7f, 0.0f, 0.0f);
		glRotatef( 90.0, 1.0, 0.0, 0.0 );
		gluDisk( q, 60.0, 60.0, 24, 1 );

		glColor3f(0.7f, 0.0f, 0.7f);
		glRotatef( 90.0, 0.0, 1.0, 0.0 );
		gluDisk( q, 60.0, 60.0, 24, 1 );

		glColor3f(0.0f, 0.0f, 0.7f);
		glRotatef( 90.0, 1.0, 0.0, 0.0 );
		gluDisk( q, 60.0, 60.0, 24, 1 );
		

    glPopMatrix();

	//reset poly mode...
	glLineWidth( 0.5 );
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);


}

//////////////////////////////////////////////////////////////
// Basic Objects

void motionPath::makeCube( void) {

    glShadeModel( GL_FLAT );

    glNormal3f( 0.0, 0.0, 0.0 );

    glBegin(GL_QUADS);		                // begin drawing a cube

    // Front Face (note that the texture's corners have to match the quad's corners)
    glNormal3f( 0.0f, 0.0f, 1.0f);                              // front face points out of the screen on z.
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f(-100.0f, -100.0f,  100.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f( 100.0f, -100.0f,  100.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f( 100.0f,  100.0f,  100.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f);									glVertex3f(-100.0f,  100.0f,  100.0f);	// Top Left Of The Texture and Quad

    // Back Face
    glNormal3f( 0.0f, 0.0f,-1.0f);                              // back face points into the screen on z.
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f(-100.0f, -100.0f, -100.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f(-100.0f,  100.0f, -100.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f);									glVertex3f( 100.0f,  100.0f, -100.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f( 100.0f, -100.0f, -100.0f);	// Bottom Left Of The Texture and Quad

    // Top Face
    glNormal3f( 0.0f, 1.0f, 0.0f);                              // top face points up on y.
    glTexCoord2f(0.0f, 1.0f);									glVertex3f(-100.0f,  100.0f, -100.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f(-100.0f,  100.0f,  100.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f( 100.0f,  100.0f,  100.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f( 100.0f,  100.0f, -100.0f);	// Top Right Of The Texture and Quad

    // Bottom Face
    glNormal3f( 0.0f, -1.0f, 0.0f);                             // bottom face points down on y.
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f(-100.0f, -100.0f, -100.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f);									glVertex3f( 100.0f, -100.0f, -100.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f( 100.0f, -100.0f,  100.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f(-100.0f, -100.0f,  100.0f);	// Bottom Right Of The Texture and Quad

    // Right face
    glNormal3f( 1.0f, 0.0f, 0.0f);                              // right face points right on x.
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f( 100.0f, -100.0f, -100.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f( 100.0f,  100.0f, -100.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f);									glVertex3f( 100.0f,  100.0f,  100.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f( 100.0f, -100.0f,  100.0f);	// Bottom Left Of The Texture and Quad

    // Left Face
    glNormal3f(-1.0f, 0.0f, 0.0f);                              // left face points left on x.
    glTexCoord2f(0.0f, textureData.texheight);					glVertex3f(-100.0f, -100.0f, -100.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, textureData.texheight);  glVertex3f(-100.0f, -100.0f,  100.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(textureData.texwidth, 1.0f);					glVertex3f(-100.0f,  100.0f,  100.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f);									glVertex3f(-100.0f,  100.0f, -100.0f);	// Top Left Of The Texture and Quad

    glEnd();                                    // done with the polygon.

}


void motionPath::makeCylinder( void ) {

    GLUquadricObj* q = gluNewQuadric();

    glPushMatrix();

      glTranslatef( 0.0, 0.0, -1.0 );
      glNormal3f( 0.0, 0.0, 0.0 );

      // cylinder
      gluQuadricNormals( q, GLU_SMOOTH );
      gluQuadricTexture( q, GL_TRUE );
      //gluQuadricDrawStyle( q, GLU_FILL );
      gluCylinder(q, 6.0, 6.0, 20.0, 24, 1);

      // end cap
      glTranslatef( 0.0, 0.0, 20.0 );
      gluDisk( q, 0.0, 6.0, 24, 1 );

      // other end cap
      glTranslatef( 0.0, 0.0, -20.0 );
      gluQuadricOrientation( q, (GLenum)GLU_INSIDE );
      gluDisk( q, 0.0, 6.0, 24, 1 );

    glPopMatrix();
}

void motionPath::makeSphere( void ) {

    GLUquadricObj* q = gluNewQuadric();
//    GLuint cylinderObj;

      glNormal3f( 0.0, 0.0, 0.0 );

      // cylinder
      gluQuadricNormals( q, GLU_SMOOTH );
      gluQuadricTexture( q, GL_TRUE );

      gluSphere(q,150.0f,32,32);

}


void motionPath::makeGrid() {

  // This is the old grid code, new code does it all in hardware
  // although we need to see if this covers older boards
  // Render grid over 0..rows, 0..columns.

	glLineWidth( 0.5 );
	glEnable( GL_LINE_SMOOTH);
	
	// Draw the bounding box
  glDisable( GL_LIGHTING);
  glDisable( GL_TEXTURE_2D);
  //glEnable( GL_LINE_SMOOTH);
  glEnable(GL_BLEND);     glEnable(GL_DEPTH);
  glBlendFunc( GL_SRC_ALPHA, GL_ONE); // GL_ONE_MINUS_SRC_ALPHA

  glColor3f( 0.7, 0.7, 0.7);



//	glLineWidth( 0.5 );
//	glPointSize( 0.5);

	//glEnable( GL_LINE_SMOOTH);

const GLfloat grid2x2[2][2][3] = {
    {{-800.0, -250.0, -800.0},
	  {  800.0, -250.0, -800.0}},
    {{-800.0, -250.0,  800.0},
	  {  800.0, -250.0,  800.0}}
  };

  glEnable(GL_MAP2_VERTEX_3);

  glMap2f( GL_MAP2_VERTEX_3,
    0.0, 1.0,  /* U ranges 0..1 */
    3,         /* U stride, 3 floats per coord */
    2,         /* U is 2nd order, ie. linear */
    0.0, 1.0,  /* V ranges 0..1 */
    2 * 3,     /* V stride, row is 2 coords, 3 floats per coord */
    2,         /* V is 2nd order, ie linear */
    **grid2x2);  /* control points */


  glMapGrid2f(
    60, 0.0, 1.0,
    60, 0.0, 1.0);


  glEvalMesh2(GL_LINE,
    0, 60,   /* Starting at 0 mesh 5 steps (rows). */
    0, 60);  /* Starting at 0 mesh 6 steps (columns). */


  //glDisable(GL_MAP2_VERTEX_3);
	glDisable( GL_LINE_SMOOTH);

}


void motionPath::makeBezier() {

GLfloat ctrlpoints[4][4][3] =
{
    {
        {-1.5, -1.5, 4.0},
        {-0.5, -1.5, 2.0},
        {0.5, -1.5, -1.0},
        {1.5, -1.5, 2.0}},
    {
        {-1.5, -0.5, 1.0},
        {-0.5, -0.5, 3.0},
        {0.5, -0.5, 0.0},
        {1.5, -0.5, -1.0}},
    {
        {-1.5, 0.5, 4.0},
        {-0.5, 0.5, 0.0},
        {0.5, 0.5, 3.0},
        {1.5, 0.5, 4.0}},
    {
        {-1.5, 1.5, -2.0},
        {-0.5, 1.5, -2.0},
        {0.5, 1.5, 0.0},
        {1.5, 1.5, -1.0}}
};

    glMap2f(GL_MAP2_VERTEX_3, 0, 1, 3, 4,
        0, 1, 12, 4, &ctrlpoints[0][0][0]);
    glEnable(GL_MAP2_VERTEX_3);
    glEnable(GL_AUTO_NORMAL);
    glEnable(GL_NORMALIZE);
    glMapGrid2f(100, 0.0, 1.0, 100, 0.0, 1.0);

    glEvalMesh2(GL_FILL, 0, 100, 0, 100);  //100 was 20

    glDisable(GL_MAP2_VERTEX_3);
    glDisable(GL_AUTO_NORMAL);
    glDisable(GL_NORMALIZE);



}

//#include "p_vector.h"




void motionPath::makeParticle() {

		glPushMatrix(); //first we correct the orientation

		glTranslatef( 0.0, 0.0, -5.0 );
		glRotatef( -90, 1.0, 0.0, 0.0 );
		glScalef ( 40, 40, 40 );

		glDisable(GL_TEXTURE_2D);
		bool ConstColor = ParticleColors;  //otherwise it roatates the colors

		switch(ParticleDraw)
		{
			case PARLINE:      pDrawGroupp(GL_LINES, true, ConstColor);          break;
			case PARPOINT:     pDrawGroupp(GL_POINTS, true, ConstColor);         break;

			case PARGAUSS:		{	glEnable(GL_TEXTURE_2D); MakeGaussianSpotTexture();
									pVector view = pVector(0, 0, 0) - pVector(0, -23.0, 10);
									view.normalize();
									pVector up(0, 0, 1);
									DrawGroupQuadSplat(view, up, 0.16, true, true, ConstColor); break; }

			case PARTEXTURE:	{	glEnable(GL_TEXTURE_2D);
									makeLayerTexture();
									pVector view = pVector(0, 0, 0) - pVector(0, -23.0, 10);
									view.normalize();
									pVector up(0, 0, 1);
									DrawGroupQuadSplat(view, up, 0.16, true, true, ConstColor); break; }
		}

		switch(ParticleStyle)
		{
			case ATOMIC:       Atom(ParticleFirsttime);          break;
			case JETSPRAY:     JetSpray(ParticleFirsttime);      break;
			case WATERFALL:    Waterfall(ParticleFirsttime);     break;
			case ROCKET:       { SteerShape = PDPlane; Rocket(ParticleFirsttime);        break; }
			case EXPLOSION:    Explosion(ParticleFirsttime);     break;
			case SWIRL:        Swirl(ParticleFirsttime);         break;
			case BALLOONS:     Balloons(ParticleFirsttime);      break;
			case SHAPE:        Shape(ParticleFirsttime);         break;
			case FIREFLIES:    FireFlies(ParticleFirsttime) ;    break;
			case SHOWER:       { SteerShape = PDPlane; Shower(ParticleFirsttime);        break; }
			case FOUNTAIN:     Fountain(ParticleFirsttime);      break;
		}

		glEnable(GL_TEXTURE_2D);

 ParticleFirsttime=FALSE;

 //pDrawGroupp(GL_LINES, true);

 glPopMatrix();

}

void motionPath::makeKeyFrames( ) {

  //we want to loop through array of nodes[]for object
  //and draw each keyframe connected by dots

  //numnodes=zero means no keyframe has been set so we can just draw
  //the dot without connecting or traversing the array

	glLineWidth( 0.5 );
	glEnable( GL_LINE_SMOOTH);
	
	// Draw the bounding box
	glDisable( GL_LIGHTING);
	glDisable( GL_TEXTURE_2D);
			//glEnable( GL_LINE_SMOOTH);
			glEnable(GL_BLEND);     glEnable(GL_DEPTH);
			glBlendFunc( GL_SRC_ALPHA, GL_ONE); // GL_ONE_MINUS_SRC_ALPHA

	glColor3f( 1.0, 0.0, 0.0);



  if (numnodes>0) {

    for (int x=0; x<numnodes; x++) {

      //we only draw the keyframe for the first frame
      if (x==0) {

        glBegin(GL_LINES);

          //horizontal line
          glVertex3f(nodes[x]->tx-1, nodes[x]->ty,   nodes[x]->tz);
          glVertex3f(nodes[x]->tx+1, nodes[x]->ty,   nodes[x]->tz);

          // Vertical lines.
          glVertex3f(nodes[x]->tx,   nodes[x]->ty-1, nodes[x]->tz);
          glVertex3f(nodes[x]->tx,   nodes[x]->ty+1, nodes[x]->tz);

          // depth lines.
          glVertex3f(nodes[x]->tx,   nodes[x]->ty,   nodes[x]->tz-1);
          glVertex3f(nodes[x]->tx,   nodes[x]->ty,   nodes[x]->tz+1);

        glEnd();
      }
      else
      {
        //for all keyframes after the first we draw the connecting line
        glBegin(GL_LINES);
          //horizontal line
          glVertex3f(nodes[x]->tx-1, nodes[x]->ty, nodes[x]->tz);
          glVertex3f(nodes[x]->tx+1, nodes[x]->ty, nodes[x]->tz);

          // Vertical lines.
          glVertex3f(nodes[x]->tx, nodes[x]->ty-1, nodes[x]->tz);
          glVertex3f(nodes[x]->tx, nodes[x]->ty+1, nodes[x]->tz);

          // depth lines.
          glVertex3f(nodes[x]->tx, nodes[x]->ty,   nodes[x]->tz-1);
          glVertex3f(nodes[x]->tx, nodes[x]->ty,   nodes[x]->tz+1);

        glEnd();

       glBegin(GL_LINES);
         //horizontal line
         glVertex3f(nodes[x-1]->tx, nodes[x-1]->ty, nodes[x-1]->tz);
         glVertex3f(nodes[x]->tx,   nodes[x]->ty,   nodes[x]->tz);

       glEnd();
     }

	  }//end keyframe loop
  }
  else
  {

    //this means its just the node for the layer so no keyfrane has been set
    glBegin(GL_LINES);
      //horizontal line
      glVertex3f(node->tx-1, node->ty,   node->tz);
      glVertex3f(node->tx+1, node->ty,   node->tz);

      // Vertical lines.
      glVertex3f(node->tx,   node->ty-1, node->tz);
      glVertex3f(node->tx,   node->ty+1, node->tz);

      // depth lines.
      glVertex3f(node->tx,   node->ty,   node->tz-1);
      glVertex3f(node->tx,   node->ty,   node->tz+1);
    glEnd();

  }
}


