/*******************************************************************************
**
** The source file for the Jahshaka Core jahtexture module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"




QString motionPath::getsequencefilename( int frame ) {


	//////////////////////////////////////////////
	// we really need to optimize this routine mon
	// as its important and accessed all the time

	//keyFlag false means not the key and true means the key we can fix this later

	//calculate the sequence template for sequences 
	//when support is added for avi and movie files need to update LoadLayerImage as well

	//first we need to map the frame to the associated frame number in the sequence
	frame = (inframe + frame)-1;

	//make sure we are in range, if we are out of range use the head or tail
	//we can add a flag here to hide clip if we want
    if ( frame> outframe)      { frame= outframe; }
    if ( frame< inframe)       { frame= inframe; }

	//first figure out length of current frame
	QString currentframe;  currentframe.setNum(frame); //was theblankframe
	int     length = currentframe.length();

	//then remove it from the blank template for the clip
	QString blank(videoext);
	blank          = blank.remove(0, length);

	//now we need to build the blank from scratch to account for sequences begining with 0001 etc
	int blanklength = blank.length();
	QString theblank;
	for (int i=0; i<blanklength; i++) {
		theblank +="0";
	}
 
	blank = theblank;

	//then create the sequence extension
	QString temp; temp = blank + currentframe;

	//now we set the image name
	QString imagefilepath; 
	
	imagefilepath = pathname+filename+temp+extension;

	//if (JAHDEBUG) debug("Loading >>:"+imagefilepath);

	return imagefilepath;

}




QString motionPath::getkeysequencefilename( int frame ) {


	//////////////////////////////////////////////
	// we really need to optimize this routine mon
	// as its important and accessed all the time

	//keyFlag false means not the key and true means the key we can fix this later

	//calculate the sequence template for sequences 
	//when support is added for avi and movie files need to update LoadLayerImage as well

	//first we need to map the frame to the associated frame number in the sequence
	frame = (keyinframe + frame)-1;

	//make sure we are in range, if we are out of range use the head or tail
	//we can add a flag here to hide clip if we want
    if ( frame> keyoutframe)      { frame= keyoutframe; }
    if ( frame< keyinframe)       { frame= keyinframe; }

	//first figure out length of current frame
	QString currentframe;  currentframe.setNum(frame); //was theblankframe
	int     length = currentframe.length();

	//then remove it from the blank template for the clip
	QString blank(videoextkey);
	blank          = blank.remove(0, length);

	//now we need to build the blank from scratch to account for sequences begining with 0001 etc
	int blanklength = blank.length();
	QString theblank;
	for (int i=0; i<blanklength; i++) {
		theblank +="0";
	}
 
	blank = theblank;

	//then create the sequence extension
	QString temp; temp = blank + currentframe;

	//now we set the image name
	QString imagefilepath;  
	
	imagefilepath = keypathname+keyfilename+temp+keyextension; 

	//if (JAHDEBUG) debug("Loading video key>>:"+imagefilepath);

	return imagefilepath;

}




















