/*******************************************************************************
**
** The header file for the Jahshaka widget module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#ifndef RENDER_H
#define RENDER_H


#include <coreobject.h>
#include "interfaceheaders.h"


extern int X_RESOLUTION;
extern int Y_RESOLUTION;
extern bool JAHDEBUG;

class motionPath;

class JahRender {
 // Q_OBJECT


public:
  JahRender(void);
  ~JahRender(void);

  MouseMode theToolMode;

  //opengl routines
  void initializeOpenGL();
  void resizeOpenGL( int w, int h, GLfloat & fAspect );

  //object drawing routines
  void positionObject( motionNode * node );
  void drawLayer(motionPath & layer);
  void drawNodes(motionPath & layer);

  void makeObject( motionPath & layer );
  void makeKey( motionPath & layer );
  void makeLayerOutline( motionPath & layer);

  //the current tool?
  void setToolMode(MouseMode);

  //set zoom up
  void setZoom(GLfloat zoom);

  //size of the render context
  int renderwidth;
  int renderheight;
  GLfloat fAspectval;

  //zoom for the main window
  GLfloat zoomVal;

};


#endif




