 /*******************************************************************************
**
** The source file for the Jahshaka glworld.cpp module
** The Jahshaka Project
** Copyright (C) 2000-2003 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"


////////////////////////////////////////////////
// Animation related

void GLWorld::updateVideoTexture(int thelayer, int theframe) {

	layers[thelayer].updateVidTex(theframe);
}

void GLWorld::toggleAnimation(bool value) {

    animation = value;

    if ( animation ) { updateGL(); if (JAHDEBUG) JahDebug ("GlWorld starting animation"); }
       else { if (JAHDEBUG) JahDebug("GlWorld stopping animation"); timer->stop(); }

}

void GLWorld::startanimation() {    if (animation) toggleAnimation(FALSE); else toggleAnimation(TRUE);   }

void GLWorld::stopanimation() {    toggleAnimation(FALSE);  }

void GLWorld::updateanimframe(int Frame) { //if (JAHDEBUG) debug("GlWorld we are in update anim frame");

  for (int i=0; i<=numberLayers; i++) {

    //we check for the camera here
    if (i==0) { if(camera->numnodes>0) { camera->updateNodes(Frame); } }

    //we only compute the nodes if the layer is visible to save processing
    if (layers[i].layerStatus) {
      if (i>0) { if(layers[i].numnodes>0) { layers[i].updateNodes(Frame); } }

        //how to clean this mess up?
        if ( (layers[i].videotex == TRUE) && (animsliderselected==TRUE) && (layers[i].layerStatus) && (forceplay) )
		      { updateVideoTexture(i,Frame); } else
		      if ( (layers[i].videotex == TRUE) && (animsliderselected==FALSE) && (layers[i].layerStatus) )
		        { updateVideoTexture(i,Frame); }  else
		          if ( (layers[i].videotexkey == TRUE) && (animsliderselected==FALSE) && (layers[i].layerStatus) )
		          { updateVideoTexture(i,Frame); }

      }
  }
  updateGL();
}

void GLWorld::updateanimation(int Frame) { //if (JAHDEBUG) debug("GlWorld we are in update animation");

  for (int i=0; i<=numberLayers; i++) {

    //we check the camera here
    if (i==0) { if  (camera->numnodes>0)    { camera->updateNodes(Frame);   }            }

    //we only compute the nodes if the layer is visible to save processing
    if (layers[i].layerStatus) {
      if (i>0)  { if  (layers[i].numnodes>0)  { layers[i].updateNodes(Frame); }  }
    }

    //we could use a OR statement here instead of the else below
    if ( (layers[i].videotex == TRUE) && (animsliderselected==FALSE) && (layers[i].layerStatus) ) {
     updateVideoTexture(i,Frame); } else {
       if ( (layers[i].videotexkey == TRUE) && (animsliderselected==FALSE) && (layers[i].layerStatus) ) {
         updateVideoTexture(i,Frame); }
       }
  }

  //update the slider for visual feedback
  updateSlider(Frame);
}


void GLWorld::addKeyframe() { // heres a workaround for the background object which is layer 1

  currentFrame = controllerslider->value();

  if (activeLayer==0) { camera->addNodes(currentFrame,camera->node); }       // the layer 1 vs layer 0 thing sucks
   else layers[activeLayer].addNodes(currentFrame,layers[activeLayer].node);

}


















