#include "glworld.h"



////////////////////////////////////////////
// layer controls

//world controls here                      //these were all zero
void GLWorld::setWorldXR( int degrees ) { camera->node->rx = (GLfloat)(degrees); updateGL(); }
void GLWorld::setWorldYR( int degrees ) { camera->node->ry = (GLfloat)(degrees); updateGL(); }
void GLWorld::setWorldZR( int degrees ) { camera->node->rz = (GLfloat)(degrees); updateGL(); }

void GLWorld::setWorldXT( int degrees )  { camera->node->tx = (GLfloat)(degrees); updateGL(); }
void GLWorld::setWorldYT( int degrees )  { camera->node->ty = (GLfloat)(degrees); updateGL(); }
void GLWorld::setWorldZT( int degrees )  { camera->node->tz = (GLfloat)(degrees); updateGL(); }


//active layer controls here
void GLWorld::setXRotation( int degrees )  { layers[activeLayer].node->rx = (GLfloat)(degrees ); updateGL(); }
void GLWorld::setYRotation( int degrees )  { layers[activeLayer].node->ry = (GLfloat)(degrees ); updateGL(); }
void GLWorld::setZRotation( int degrees )  { layers[activeLayer].node->rz = (GLfloat)(degrees ); updateGL(); }

void GLWorld::setXScale   ( int degree )   { float degrees = degree; layers[activeLayer].node->sx = (GLfloat)(degrees/10); updateGL(); }
void GLWorld::setYScale   ( int degree )   { float degrees = degree; layers[activeLayer].node->sy = (GLfloat)(degrees/10); updateGL(); }
void GLWorld::setZScale   ( int degree )   { float degrees = degree; layers[activeLayer].node->sz = (GLfloat)(degrees/10); updateGL(); }

void GLWorld::setXTrans   ( int degrees )  { layers[activeLayer].node->tx = (GLfloat)(degrees); updateGL(); }
void GLWorld::setYTrans   ( int degrees )  { layers[activeLayer].node->ty = (GLfloat)(degrees); updateGL(); }
void GLWorld::setZTrans   ( int degrees )  { layers[activeLayer].node->tz = (GLfloat)(degrees); updateGL(); }

void GLWorld::setAlpha    ( int degrees )  { layers[activeLayer].node->Alpha = (GLfloat)(degrees); updateGL(); }
void GLWorld::setZoom     ( int degrees )  { camera->node->sc = (GLfloat)(degrees); updateGL(); }

void GLWorld::setExtrude  ( int degrees )  {
	
	if (degrees<=0) degrees=0;
	layers[activeLayer].text->extrude = degrees;

	layers[activeLayer].makeText();
	updateGL();
}

void GLWorld::setKeyframeDrawStatus()         {
	
	if (activeLayer>0) layers[activeLayer].drawKeyframes =  !layers[activeLayer].drawKeyframes;

	updateGL();
}


/*
void GLWorld::spaceButtonEvent  ( int button )  {
	
  //we will use buttons 6/5/4 to lock on x/y/z axes any other button releases
      switch(button) {

        case 4    : { debug("spaced PLAYER"); break;  }
        case 5    : { debug("spaced LIBRARY"); break; }
        case 6    : { debug("spaced PAINT"); break;   }

        default   : {  xloxk = true; ylock; }

      }

}
*/

void GLWorld::spaceEvent  ( double x, double y, double z, double a, double b, double c )  {
	
  //we will use buttons 6/5/4 to lock on x/y/z axes any other button releases

  int sensitivty = 70;
  int thelayer = activeLayer;

  if (thelayer==1) thelayer=0;

    layers[thelayer].node->rx += (GLfloat)(a/sensitivty);
    layers[thelayer].node->ry += (GLfloat)(b/sensitivty);
    layers[thelayer].node->tx += (GLfloat)(c/sensitivty);

    layers[thelayer].node->tx += (GLfloat)(x/sensitivty);
    layers[thelayer].node->ty += (GLfloat)(y/sensitivty);
    layers[thelayer].node->tz += (GLfloat)(-z/sensitivty);

	updateGL();
}

////////////////////////////////////////////
// layer video controls

//we need to add inframe and outframe or startslipframe and endslipframe

//if forceplay we update visuals here as well

void GLWorld::setinFrames      ( int frame )   {

	layers[activeLayer].startframe = frame;
	layers[activeLayer].endframe   = frame + layers[activeLayer].numframes;

	//is it possible to only update the layer and not the entire scene? no
	if (forceplay) updateanimframe(controllerslider->value()); else updateGL();
	updateSliders();

}

void GLWorld::setoutFrames      ( int frame )   {

	layers[activeLayer].endframe     = frame;
	layers[activeLayer].startframe   = frame - layers[activeLayer].numframes;
	
	if (forceplay) updateanimframe(controllerslider->value()); else updateGL();
	updateSliders();

}

void GLWorld::setinKeyFrames      ( int frame )   {

	layers[activeLayer].keystartframe = frame;
	layers[activeLayer].keyendframe   = frame + layers[activeLayer].numkeyframes;
	
	if (forceplay) updateanimframe(controllerslider->value()); else updateGL();
	updateSliders();

}

void GLWorld::setoutKeyFrames      ( int frame )   {

	layers[activeLayer].keystartframe = frame;
	layers[activeLayer].keyendframe   = frame - layers[activeLayer].numkeyframes;
	
	if (forceplay) updateanimframe(controllerslider->value()); else updateGL();
	updateSliders();

}

//adds the current layer to the listbox and selects it
void GLWorld::addSelection(bool status)
{

  QCheckListItem * rasta;
  rasta = new QCheckListItem( lv, layers[numberLayers].layername, QCheckListItem::CheckBox );
  rasta->setOn(status);

  lv->setSelected ( rasta, status );

  QString laynum; laynum.setNum(numberLayers);

  rasta->setText ( 0, layers[numberLayers].layername);
  rasta->setText ( 1, laynum);

  //set the layer to visible, need to 'check' the checkbox
  changeSelection(numberLayers);

  setLayerVisible(numberLayers,status);

}

void GLWorld::changeSelection(int layer) {

  JahDebug("changing selection for layer:",layer);

      layers[activeLayer].selected=FALSE;
      activeLayer = layer;
      layers[activeLayer].selected=TRUE;

      //updateScene(); //we need to update sliders of new layer... to stored setting
}

void GLWorld::setLayerVisible( int layer, bool status ) {
  QString data;

  JahDebug("Setting layer: "+data.setNum(layer)+" visibility to:",status);

	layers[layer].layerStatus = status;
	
	updateGL();
}

void GLWorld::activateObject(int obj) {JahDebug("fix me to call setLayerVisisble instead..."); setLayerVisible(obj,TRUE); } //qApp->flushX(); is this function obsolete

//void GLWorld::updateScene(void) { qApp->flushX(); } // does this trigger a renderGL?

void GLWorld::delLayer(void)
{

    //cant delete background
    if (activeLayer == 1) return;

    QListViewItem *ras; ras = lv->selectedItem();
    if (ras==0) return;

    lv->takeItem(ras);
    layers[activeLayer].layerStatus=FALSE; updateGL();

}


void GLWorld::objectMenu(int layer) {           //having trouble overriding this locally

	if (JAHDEBUG) JahDebug("raising the menu associated with layer", layer);

	LayerCategory layertype;	layertype = layers[layer].layertype;
	ObjectCategory object;		object    = layers[layer].objtype;

	  switch ( layertype ) {

		case LAYER        :     {       switch ( object ) {
										case BACKDROP     : { fxaxis->raiseWidget(3); fxobject->raiseWidget(2); break; }
										case JAHLAYER     : { fxaxis->raiseWidget(0); fxobject->raiseWidget(0); break; }
										default           : { fxaxis->raiseWidget(0); fxobject->raiseWidget(0); break; }
										}

								break; }


		case PARTICLE     :     {   fxaxis->raiseWidget(0); fxobject->raiseWidget(4); break; }	
			
		case OBJECTS      :     {   if (object==OBJOBJECTS )   { fxaxis->raiseWidget(0); fxobject->raiseWidget(5); }
									if (object==MAXOBJECTS )   { fxaxis->raiseWidget(0); fxobject->raiseWidget(6); }
									break; }

		case FRAME        :     {   break; }

		case TEXT         :     {   if ( object==JAHTEXT )     { fxaxis->raiseWidget(0); fxobject->raiseWidget(1); }
									break; }

		case GRID         :     {   break; }

		default           :     {    debug("unknown layer type, unable to select menus"); break; }

	  }

    changeSelection(layer);
}











