/*******************************************************************************
**
** The source file for the Jahshaka glworld dataio code
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "glworld.h"
#include "qfile.h"
#include <qfiledialog.h>

#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qapplication.h>
#include <qaccel.h>

#include <qpainter.h>
#include <qpaintdevicemetrics.h>


void GLWorld::LoadAllData(QFile & f, int laynum) {

  QString text;
  QTextStream t( &f );

  bool backdropstatus = false;

  for (int i=0; i<=laynum; i++) {

    activeLayer = i; numberLayers = i;

    text = t.readLine(); JahDebug(text);  //JahDebug("Info for Layer:",i);
    layers[i].layernumber = ParseDataInt( t.readLine() );     JahDebug("Setting layer number to:",layers[i].layernumber);
    layers[i].layername   = ParseDataString( t.readLine() );  JahDebug("Setting layer name:",layers[i].layername);

    layers[i].blend       = ParseDataInt( t.readLine() );     JahDebug("Setting blend settings:",layers[i].blend);
    layers[i].depth       = ParseDataInt( t.readLine() );     JahDebug("Setting depth settings:",layers[i].depth);
    layers[i].cull        = ParseDataInt( t.readLine() );     JahDebug("Setting cull settings:",layers[i].cull);
    layers[i].lighting    = ParseDataInt( t.readLine() );     JahDebug("Setting lighting settings:",layers[i].lighting);
    layers[i].foreground  = ParseDataInt( t.readLine() );     JahDebug("Setting foreground settings:",layers[i].foreground);

		//thisis weather the layer is on or off
		bool layerstat = ParseDataInt( t.readLine() );  //get the layerstatus

		text = t.readLine(); //JahDebug("Reading LayerInfo:");

		text = ParseDataString( t.readLine() ); JahDebug("Setting layer type to:",text);
		int LayerCode = ParseDataInt( t.readLine() ); JahDebug("Stored layer type is:",LayerCode);
		LayerCategory layerCat = (LayerCategory)LayerCode;

		text = ParseDataString( t.readLine() ); JahDebug("Setting layer code to:",text);
		int ObjCode   = ParseDataInt( t.readLine() ); JahDebug("Stored layer code is:",ObjCode);
		ObjectCategory objectCat = (ObjectCategory)ObjCode;

		//set the layerstatus  based on object type
		//we need to override for backgroundlayer though
		if (ObjCode==BACKDROP)
				{	JahDebug("Setting backdrop activation to:",layerstat);
			  		layers[0].layerStatus = layerstat;
					backdropstatus = layerstat;
				}
		else	{ JahDebug("Setting layer    activation to:",layerstat);
					layers[i].layerStatus = layerstat;
				}

		
	//read the objects information in
	  switch ( LayerCode ) {

	    case LAYER        :     {
			
									if (ObjCode==BACKDROP) {
									
										//layers[i].layertype = LAYER; layers[i].objtype = BACKDROP;

										gridval    = ParseDataInt( t.readLine() ); //gridval
										polySmooth = ParseDataInt( t.readLine() ); //polySmooth
										textsafe->layerStatus = ParseDataInt( t.readLine() ); //textsafe layerStatus;

										text = t.readLine();
										if (text.contains(":")) {   layers[i].layer=true; LoadImageData(f,i);
																	createLayer(i,layers[i].layername, layerCat, objectCat );
																}

										LoadNodes(f,0); //backdrop data is stored under layer zero
                    addSelection(layerstat);
									}

									else {

										//layers[i].layertype = LAYER; layers[i].objtype = JAHLAYER;
										bool drawlayer=false;

										text = t.readLine();
										if (text.contains(":")) {   layers[i].layer=true; LoadImageData(f,i);					
																	drawlayer=true;
																	//createLayer(i,layers[i].layername, layerCat, objectCat );
																}

										text = t.readLine();
										if (text.contains(":")) {	layers[i].drawtheKey =true; LoadImageKeyData(f,i);
																	drawlayer=true;
																}

										if (drawlayer) createLayer(i,layers[i].layername, layerCat, objectCat );

                    LoadNodes(f,i);
                    addSelection(layerstat);

									}

								break; }


		case PARTICLE     :     {
									text = t.readLine();
									if (text.contains(":")) { layers[i].layer=true;   LoadImageData(f,i); }
									
									LoadParticleData(f,i);
									
									createLayer(numberLayers,layers[i].layername, layerCat, objectCat);

                  LoadNodes(f,i);
                  addSelection(layerstat);
			
								break; }	
			
		case OBJECTS      :     {
			
									text = t.readLine();
									if (text.contains(":")) { layers[i].layer=true;   LoadImageData(f,i); }
									
									LoadObjectData(f,i);
									
									createLayer(numberLayers,layers[i].layername, layerCat, objectCat);

									LoadNodes(f,i);
									addSelection(layerstat);

								break; }

		case FRAME        :     {   break; }

		case TEXT         :     {
			
									text = t.readLine();
									if (text.contains(":")) { layers[i].layer=true;   LoadImageData(f,i); }

									layers[i].addTextObj();

									LoadColor(f,i);
									LoadText(f,i);
									
									createLayer(numberLayers,layers[i].layername, layerCat, objectCat);

									LoadNodes(f,i);
									addSelection(layerstat);


								break; }

		case GRID         :     {   break; }

		default           :     {   break; }

	  }


	  //need to reset this as adding the lyaer overrides it
      if (layerstat==1) setLayerVisible(i,TRUE); else setLayerVisible(i,FALSE);

	  layers[i].selected = false;

      text = t.readLine(); JahDebug(text);   //read the object divider line

    }
 /*
	//select the world layer after loading scene
	//first deselect all
	lv->clearSelection();

	//set checkbox status for world
	//this is done here since world is created before the load routine starts
	QListViewItem * rasta;
	rasta = lv->lastItem();  //lastitem is the world!
	(( QCheckListItem* )rasta)->setOn(backdropstatus);

	lv->setSelected ( rasta, true );
   */
	//set selection modes
	//layers[0].selected = true;

}


///////////////////////////////////////////////////////////////
// file save routine
//needs to be working!

void GLWorld::LoadObjectData(QFile & file, int i) {

        QString text;  QTextStream t( &file );

        text = t.readLine(); JahDebug(text);  //JahDebug("Info for Layer:",i);
        text = ParseDataString( t.readLine() ); layers[i].objfilename = text; //JahDebug("Object name:",text); //  text=JahDebug("Stored layer object name:",layers[i].filename); text += "\n";   os << text;
        text = ParseDataString( t.readLine() ); layers[i].objextension = text; //JahDebug("Object extension:",text); //  text=JahDebug("Stored layer object extension:",layers[i].extension);   text += "\n";   os << text;


}  // save scene files to disk

void GLWorld::LoadParticleData(QFile & file, int i) {

        QString text;  QTextStream t( &file );

        text = t.readLine(); JahDebug(text);  //JahDebug("Info for Layer:",i);

		int ParticleStyle   = ParseDataInt( t.readLine() ); JahDebug("Stored Particle Style is:",ParticleStyle);
	    ParticleCategory particleStyle = (ParticleCategory)ParticleStyle;
		layers[i].ParticleStyle = particleStyle;

		int ParticleDraw   = ParseDataInt( t.readLine() ); JahDebug("Stored Particle Draw is:",ParticleDraw);
	    ParticleDrawstyle particleDraw = (ParticleDrawstyle)ParticleDraw;
		layers[i].ParticleDraw = particleDraw;

		int ParticleColor   = ParseDataInt( t.readLine() ); JahDebug("Stored Particle color is:",ParticleColor);
	    bool particleColor = (bool)ParticleColor;
		layers[i].ParticleColors = particleColor;


}  // save scene files to disk

void GLWorld::LoadImageData( QFile & file, int i) {
        JahDebug("Loading Image data");
       QString text;  QTextStream t( &file );

        text = t.readLine(); JahDebug(text);
           //text = ParseDataString(t.readLine()); layers[i].filename = text; JahDebug(text); //text=JahDebug("Stored layer image name:",layers[i].filename);   text += "\n";   os << text;
           //text = ParseDataString(t.readLine()); layers[i].extension = text; JahDebug(text); //text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;
           //text = ParseDataString(t.readLine()); layers[i].pathname = text; JahDebug(text); //text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;

           layers[i].filename = ParseDataString(t.readLine()); JahDebug(text); //text=JahDebug("Stored layer image name:",layers[i].filename);   text += "\n";   os << text;
           layers[i].extension= ParseDataString(t.readLine()); JahDebug(text); //text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;

#ifdef WIN32		   
		   layers[i].pathname = ParseWinDataString(t.readLine()); JahDebug(text); //text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;
#else
		   layers[i].pathname = ParseDataString(t.readLine()); JahDebug(text); //text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;
#endif

           text = t.readLine();
		   if (text.contains(":"))    {

                     text = t.readLine(); JahDebug(text);  // text = t.readLine(); JahDebug(text); //text=JahDebug("Layer is a sequence:",layers[i].videotex);   text += "\n";   os << text;

                      layers[i].numframes = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].startframe = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].endframe = ParseDataInt( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;
                      layers[i].inframe = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].outframe = ParseDataInt( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;

					  layers[i].videoext = ParseDataString( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;

                      layers[i].currentframe = 1;
					  layers[i].videotex=true;
            }


}

//add video support here mon
void GLWorld::LoadImageKeyData(QFile & file, int i) {

        QString text;  QTextStream t( &file ); bool status;

        status = ParseDataInt( t.readLine() ); layers[i].drawtheKey = status;
        status = ParseDataInt( t.readLine() ); layers[i].keyStatus = status;
        text = ParseDataString( t.readLine() ); layers[i].keyfilename = text;
        text = ParseDataString( t.readLine() ); layers[i].keyextension = text;
		text = ParseDataString( t.readLine() ); layers[i].keypathname = text;
        status = ParseDataInt( t.readLine() ); layers[i].invertKey = status;

           text = t.readLine();
		   if (text.contains(":"))    {

                     text = t.readLine(); JahDebug(text);  // text = t.readLine(); JahDebug(text); //text=JahDebug("Layer is a sequence:",layers[i].videotex);   text += "\n";   os << text;

                      layers[i].numkeyframes = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].keystartframe = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].keyendframe = ParseDataInt( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;
                      layers[i].keyinframe = ParseDataInt( t.readLine() );// Startframe:"+sframe);  text += "\n";   os << text;
                      layers[i].keyoutframe = ParseDataInt( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;

					  layers[i].videoextkey = ParseDataString( t.readLine() );// Endframe:"+eframe);    text += "\n";   os << text;;

                      //layers[i].currentframe = 1;
					  layers[i].videotexkey=true;
            }

}


//i think this is fixed now as we cleaned up the keyframe engine so we no
//longer need 2 routines... though maybe we do as the 2nd is for when no keyframe
//has been set but the object has been positioned

void GLWorld::LoadNodes(QFile & file,int i) {
    QString text;  QTextStream t( &file );
        JahDebug("Loading node data");

        int numnodes = ParseDataInt( t.readLine() );  JahDebug("Number of keyframes:",numnodes);

		if (numnodes>0) {

			for (int x=0; x<numnodes; x++) {


			int keyframe = ParseDataInt( t.readLine() );  JahDebug("Adding Current keyframe:",keyframe);

      if (i>0) {
			layers[i].node->sx = ParseDataFloat( t.readLine() );
			layers[i].node->sy = ParseDataFloat( t.readLine() );
			layers[i].node->sz = ParseDataFloat( t.readLine() );

			layers[i].node->tx = ParseDataFloat( t.readLine() );
			layers[i].node->ty = ParseDataFloat( t.readLine() );
			layers[i].node->tz = ParseDataFloat( t.readLine() );

			layers[i].node->rx = ParseDataFloat( t.readLine() );
			layers[i].node->ry = ParseDataFloat( t.readLine() );
			layers[i].node->rz = ParseDataFloat( t.readLine() );

			layers[i].node->Alpha = ParseDataFloat( t.readLine() );

      //if (activeLayer==1) { layers[0].addNodes(currentFrame,layers[0].node); }       // for the world layer or BACKDROP
      layers[i].addNodes(keyframe,layers[i].node);
      } else
      //its the camera
      {
			camera->node->sx = ParseDataFloat( t.readLine() );
			camera->node->sy = ParseDataFloat( t.readLine() );
			camera->node->sz = ParseDataFloat( t.readLine() );

			camera->node->tx = ParseDataFloat( t.readLine() );
			camera->node->ty = ParseDataFloat( t.readLine() );
			camera->node->tz = ParseDataFloat( t.readLine() );

			camera->node->rx = ParseDataFloat( t.readLine() );
			camera->node->ry = ParseDataFloat( t.readLine() );
			camera->node->rz = ParseDataFloat( t.readLine() );

			camera->node->Alpha = ParseDataFloat( t.readLine() );

      //if (activeLayer==1) { layers[0].addNodes(currentFrame,layers[0].node); }       // for the world layer or BACKDROP
      camera->addNodes(keyframe,camera->node);


      }

			}
		}

		else {

			int keyframe = ParseDataInt( t.readLine() );  JahDebug("Current keyframe:",keyframe);

      if (i>0) {
			layers[i].node->sx = ParseDataFloat( t.readLine() );
			layers[i].node->sy = ParseDataFloat( t.readLine() );
			layers[i].node->sz = ParseDataFloat( t.readLine() );

			layers[i].node->tx = ParseDataFloat( t.readLine() );
			layers[i].node->ty = ParseDataFloat( t.readLine() );
			layers[i].node->tz = ParseDataFloat( t.readLine() );

			layers[i].node->rx = ParseDataFloat( t.readLine() );
			layers[i].node->ry = ParseDataFloat( t.readLine() );
			layers[i].node->rz = ParseDataFloat( t.readLine() );

			layers[i].node->Alpha = ParseDataFloat( t.readLine() );
      } else {
			camera->node->sx = ParseDataFloat( t.readLine() );
			camera->node->sy = ParseDataFloat( t.readLine() );
			camera->node->sz = ParseDataFloat( t.readLine() );

			camera->node->tx = ParseDataFloat( t.readLine() );
			camera->node->ty = ParseDataFloat( t.readLine() );
			camera->node->tz = ParseDataFloat( t.readLine() );

			camera->node->rx = ParseDataFloat( t.readLine() );
			camera->node->ry = ParseDataFloat( t.readLine() );
			camera->node->rz = ParseDataFloat( t.readLine() );

			camera->node->Alpha = ParseDataFloat( t.readLine() );

      //if (activeLayer==1) { layers[0].addNodes(currentFrame,layers[0].node); }       // for the world layer or BACKDROP
      //camera->addNodes(keyframe,camera->node);

      }

		}

}  // save scene files to disk


void GLWorld::LoadColor(QFile & file,int i) {
    QString text;  QTextStream t( &file );
      JahDebug("Loading color data");
        layers[i].Red = ParseDataFloat( t.readLine() );
        layers[i].Green = ParseDataFloat( t.readLine() );
        layers[i].Blue = ParseDataFloat( t.readLine() );

}  // save scene files to disk


void GLWorld::LoadText(QFile & file,int i) {
    QString text;  QTextStream t( &file );

    layers[i].text->text = ParseDataString( t.readLine() );  //JahDebug("Stored lighting settings:",layers[i].lighting);
    layers[i].text->font = ParseDataString( t.readLine() );  //JahDebug("Stored lighting settings:",layers[i].lighting);

    int FontStyle   = ParseDataInt( t.readLine() );
    FontDrawstyle fontStyle = (FontDrawstyle)FontStyle;
    layers[i].text->fontstyle = fontStyle;

    layers[i].text->extrude = ParseDataFloat( t.readLine() );

}  // save scene files to disk


void GLWorld::SetLayerTexture(int i) {

	if ( layers[i].videotex!=true  )
	{ layers[i].LoadGlImage(layers[i].filename+layers[i].extension,IMAGE); }
	else
	{ layers[i].LoadGlImage(layers[i].filename+"0001"+layers[i].extension,IMAGE); }
}

void GLWorld::SetLayerKeyTexture(int i) {

	if ( layers[i].videotex!=true  )
	{ layers[i].LoadGlImage(layers[i].filename+layers[i].extension,KEY); }
	else
	{ layers[i].LoadGlImage(layers[i].filename+"0001"+layers[i].extension,KEY); }
}