/*******************************************************************************
**
** The source file for the Jahshaka glworld dataio code
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "glworld.h"
#include "qfile.h"
#include <qfiledialog.h>

#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qapplication.h>
#include <qaccel.h>

#include <qpainter.h>
#include <qpaintdevicemetrics.h>


void GLWorld::SaveAllData(QFile & f) {

  QString text;
  QTextStream t( &f );

  for (int i=0; i<=numberLayers; i++) {
    text = JahDebug("Info for Layer:",i);   text += "\n"; t << text;
    text = JahDebug("Stored layer number:",layers[i].layernumber); text += "\n"; t << text;
    text = JahDebug("Stored layer name:",layers[i].layername);    text += "\n"; t << text;

    text = JahDebug("Stored blend settings:",layers[i].blend);  text += "\n"; t << text;
    text = JahDebug("Stored depth settings:",layers[i].depth);  text += "\n"; t << text;
    text = JahDebug("Stored cull settings:",layers[i].cull);    text += "\n"; t << text;
    text = JahDebug("Stored lighting settings:",layers[i].lighting);    text += "\n"; t << text;
    text = JahDebug("Stored foreground settings:",layers[i].foreground);    text += "\n"; t << text;

    text = JahDebug("Stored layer is activated:",layers[i].layerStatus);  text += "\n"; t << text; //is it on or off...

    text = JahDebug("LayerInfo:");   text += "\n"; t << text;

    text = JahDebug("Stored layer type is:",layers[i].layertype);  text += "\n"; t << text;
    int LayerCode; LayerCode = (int)layers[i].layertype;
    text = JahDebug("Stored layer code:",LayerCode);    text += "\n"; t << text;

    text = JahDebug("Stored layer is a:",layers[i].objtype);  text += "\n"; t << text;
    int ObjCode; ObjCode = (int)layers[i].objtype;
    text = JahDebug("Stored layer code:",ObjCode);    text += "\n"; t << text;


	//now write the objects information out
	  switch ( LayerCode ) {

		case LAYER        :     {
									//break this out into its own subroutine like the others
									if (ObjCode==BACKDROP) {
										//need to save special options for backdrop such as gridstatus, selection status
										text = JahDebug("Stored grid setting:",gridval);    text += "\n"; t << text;
										text = JahDebug("Stored aliasing:",polySmooth);    text += "\n"; t << text;
										text = JahDebug("Stored text safe:",textsafe->layerStatus);    text += "\n"; t << text;

										if (layers[i].layer)
										{  text = ":"; text += "\n";   t << text; SaveImageData(f,i); }
										else { text = "&"; text += "\n";   t << text;  }

										SaveNodes(f,0);

									} else { //its any other object

										if (layers[i].layer)
										{  text = ":"; text += "\n";   t << text; SaveImageData(f,i); }
										else { text = "&"; text += "\n";   t << text;  }

										if (layers[i].drawtheKey)
										{ text = ":"; text += "\n";   t << text; SaveImageKeyData(f,i); }
										else { text = "&"; text += "\n";   t << text;  }

										SaveNodes(f,i);
									
									}

								break; }

		case PARTICLE     :     {
			
									if (layers[i].layer)
									{ text = ":"; text += "\n";   t << text;   SaveImageData(f,i); }
									else { text = "&"; text += "\n";   t << text;  }

									SaveParticleData(f,i);
									SaveNodes(f,i);

			
								break; }	
			
		case OBJECTS      :     {
			
									if (layers[i].layer)
									{ text = ":"; text += "\n";   t << text;   SaveImageData(f,i); }
									else { text = "&"; text += "\n";   t << text;  }

									SaveObjectData(f,i);
									SaveNodes(f,i);

								break; }

		case FRAME        :     {   break;  }

		case TEXT         :     {

									if (layers[i].layer)
									{ text = ":"; text += "\n";   t << text;   SaveImageData(f,i); }
									else { text = "&"; text += "\n";   t << text;  }

									SaveColor(f,i);
									SaveText(f,i);
									SaveNodes(f,i);

									break;
								}

		case GRID         :     {   break; }

		default           :     {   break; }

	  }

      text = JahDebug("------------------------------");  text += "\n"; t << text;
    }

}  // save scene files to disk




///////////////////////////////////////////////////////////////
// file save routine
//needs to be working!

void GLWorld::SaveObjectData(QFile & file, int i) {
        QString text;  QTextStream os( &file );

        text=JahDebug("Stored layer is object:");  text += "\n";   os << text; //is it on or off...
        text=JahDebug("Stored layer object name:",layers[i].objfilename); text += "\n";   os << text;
        text=JahDebug("Stored layer object extension:",layers[i].objextension);   text += "\n";   os << text;

}  // save scene files to disk

void GLWorld::SaveParticleData(QFile & file, int i) {
        QString text;  QTextStream os( &file );

        text=JahDebug("Stored layer is particle:");  text += "\n";   os << text; //is it on or off...

		int parstyle; parstyle = (int)layers[i].ParticleStyle;
        text=JahDebug("Stored layer particle type:",parstyle); text += "\n";   os << text;

		int pardraw; pardraw = (int)layers[i].ParticleDraw;
        text=JahDebug("Stored layer particle type:",pardraw); text += "\n";   os << text;

		int parcolor; parcolor = (int)layers[i].ParticleColors;
        text=JahDebug("Stored layer particle type:",parcolor); text += "\n";   os << text;
					
}  // save scene files to disk

void GLWorld::SaveImageData( QFile & file, int i) {
       QString text;  QTextStream os( &file );
        text=JahDebug("Stored layer has image:",layers[i].layer);   text += "\n";   os << text;//is it on or off...
           text=JahDebug("Stored layer image name:",layers[i].filename);   text += "\n";   os << text;
           text=JahDebug("Stored layer image extension:",layers[i].extension);   text += "\n";   os << text;
           text=JahDebug("Stored layer image path:",layers[i].pathname);   text += "\n";   os << text;

           if (layers[i].videotex) {                                              // text += "\n";
                      text = ":"; text += "\n";   os << text;
                      text=JahDebug("Layer is a sequence:",layers[i].videotex);  text += "\n";     os << text;

                     QString nframe; nframe.setNum(layers[i].numframes);
                      text=JahDebug("Num Frames:"+nframe);  text += "\n";   os << text;

                     QString sframe; sframe.setNum(layers[i].startframe);
                      text=JahDebug("Startframe:"+sframe);  text += "\n";   os << text;

                     QString eframe; eframe.setNum(layers[i].endframe);
                      text=JahDebug("Endframe:"+eframe);    text += "\n";   os << text;

					 QString inframe; inframe.setNum(layers[i].inframe);
                      text=JahDebug("Inframe:"+inframe);  text += "\n";   os << text;

                     QString outframe; outframe.setNum(layers[i].outframe);
                      text=JahDebug("Outframe:"+outframe);    text += "\n";   os << text;

                     QString vext(layers[i].videoext);
                      text=JahDebug("Videoextension:"+vext);    text += "\n";   os << text;

		   }  else { text = "&"; text += "\n";   os << text; }


}  // save scene files to disk



void GLWorld::SaveImageKeyData(QFile & file, int i) {

        QString text;  QTextStream os( &file );

          text=JahDebug("Draw the key:",layers[i].drawtheKey);  text += "\n";   os << text;
          text=JahDebug("Stored layer has keys:",layers[i].keyStatus);  text += "\n";   os << text;
          text=JahDebug("Stored layer key image name:",layers[i].keyfilename);   text += "\n";   os << text;
          text=JahDebug("Stored layer key extension :",layers[i].keyextension);   text += "\n";   os << text;
          text=JahDebug("Stored layer key path :",layers[i].keypathname);   text += "\n";   os << text;
          text=JahDebug("Stored key invert:",layers[i].invertKey);   text += "\n";   os << text;

           if (layers[i].videotexkey) {                                              // text += "\n";
                      text = ":"; text += "\n";   os << text;
                      text=JahDebug("KeyLayer is a sequence:",layers[i].videotexkey);  text += "\n";     os << text;

                     QString nframe; nframe.setNum(layers[i].numkeyframes);
                      text=JahDebug("Num Frames:"+nframe);  text += "\n";   os << text;

                     QString sframe; sframe.setNum(layers[i].keystartframe);
                      text=JahDebug("Startframe:"+sframe);  text += "\n";   os << text;

                     QString eframe; eframe.setNum(layers[i].keyendframe);
                      text=JahDebug("Endframe:"+eframe);    text += "\n";   os << text;

					 QString inframe; inframe.setNum(layers[i].keyinframe);
                      text=JahDebug("Inframe:"+inframe);  text += "\n";   os << text;

                     QString outframe; outframe.setNum(layers[i].keyoutframe);
                      text=JahDebug("Outframe:"+outframe);    text += "\n";   os << text;

                     QString vext(layers[i].videoextkey);
                      text=JahDebug("Videoextension:"+vext);    text += "\n";   os << text;

		   }  else { text = "&"; text += "\n";   os << text; }

}  // save scene files to disk




//we are going to have to loop through these later on
//so we can restore multiple kekframes

void GLWorld::SaveNodes(QFile & file,int i) {

	//updateNodes(int currentFrame)


    QString text;  QTextStream os( &file );

if (i>0) {






	text=JahDebug("Stored layer numnodes:",layers[i].numnodes);  text += "\n";   os << text;

	if ( layers[i].numnodes > 0 ) {
    debug("layer");
		for (int x=0; x<layers[i].numnodes; x++) {

      QString key="0"; key.setNum(layers[i].nodes[x]->nodenum); text=JahDebug("NN:"+key);  text += "\n";   os << text;

      layers[i].updateNodes(  layers[i].nodes[x]->nodenum  );

      QString nsx="0"; nsx.setNum(layers[i].node->sx);     text=JahDebug("SX:"+nsx);  text += "\n";   os << text;
      QString nsy="0"; nsy.setNum(layers[i].node->sy);     text=JahDebug("SY:"+nsy);  text += "\n";   os << text;
      QString nsz="0"; nsz.setNum(layers[i].node->sz);     text=JahDebug("SZ:"+nsz);  text += "\n";   os << text;

      QString ntx="0"; ntx.setNum(layers[i].node->tx);     text=JahDebug("TX:"+ntx);  text += "\n";   os << text;
      QString nty="0"; nty.setNum(layers[i].node->ty);     text=JahDebug("TY:"+nty);  text += "\n";   os << text;
      QString ntz="0"; ntz.setNum(layers[i].node->tz);     text=JahDebug("TZ:"+ntz);  text += "\n";   os << text;

      QString nrx="0"; nrx.setNum(layers[i].node->rx);     text=JahDebug("RX:"+nrx);  text += "\n";   os << text;
      QString nry="0"; nry.setNum(layers[i].node->ry);     text=JahDebug("RY:"+nry);  text += "\n";   os << text;
      QString nrz="0"; nrz.setNum(layers[i].node->rz);     text=JahDebug("RZ:"+nrz);  text += "\n";   os << text;

      QString nra="0"; nra.setNum(layers[i].node->Alpha);  text=JahDebug("AL:"+nra);  text += "\n";   os << text;

   }

	} else {

   //if (i>0) {
    //problem here if layer has no keyframes...
		QString key="0"; key.setNum(0); text=JahDebug("NN:"+key);  text += "\n";   os << text;
		//QString key="0"; key.setNum(layers[i].nodes[0]->nodenum); text=JahDebug("NN:"+key);  text += "\n";   os << text;
    //debug("backdrop");
		QString nsx="0"; nsx.setNum(layers[i].node->sx);     text=JahDebug("SX:"+nsx);  text += "\n";   os << text;
		QString nsy="0"; nsy.setNum(layers[i].node->sy);     text=JahDebug("SY:"+nsy);   text += "\n";   os << text;
		QString nsz="0"; nsz.setNum(layers[i].node->sz);     text=JahDebug("SZ:"+nsz);    text += "\n";   os << text;

		QString ntx="0"; ntx.setNum(layers[i].node->tx);     text=JahDebug("TX:"+ntx);  text += "\n";   os << text;
		QString nty="0"; nty.setNum(layers[i].node->ty);     text=JahDebug("TY:"+nty);  text += "\n";   os << text;
		QString ntz="0"; ntz.setNum(layers[i].node->tz);     text=JahDebug("TZ:"+ntz);  text += "\n";   os << text;

		QString nrx="0"; nrx.setNum(layers[i].node->rx);     text=JahDebug("RX:"+nrx);  text += "\n";   os << text;
		QString nry="0"; nry.setNum(layers[i].node->ry);     text=JahDebug("RY:"+nry);  text += "\n";   os << text;
		QString nrz="0"; nrz.setNum(layers[i].node->rz);     text=JahDebug("RZ:"+nrz);  text += "\n";   os << text;

		QString nra="0"; nra.setNum(layers[i].node->Alpha);  text=JahDebug("AL:"+nra);  text += "\n";   os << text;
  }

}
  //0 is the camera
else {

	text=JahDebug("Stored layer numnodes:",camera->numnodes);  text += "\n";   os << text;

	if ( camera->numnodes > 0 ) {
    debug("layer");
		for (int x=0; x<camera->numnodes; x++) {

      QString key="0"; key.setNum(camera->nodes[x]->nodenum); text=JahDebug("NN:"+key);  text += "\n";   os << text;

      camera->updateNodes(  camera->nodes[x]->nodenum  );

      QString nsx="0"; nsx.setNum(camera->node->sx);     text=JahDebug("SX:"+nsx);  text += "\n";   os << text;
      QString nsy="0"; nsy.setNum(camera->node->sy);     text=JahDebug("SY:"+nsy);  text += "\n";   os << text;
      QString nsz="0"; nsz.setNum(camera->node->sz);     text=JahDebug("SZ:"+nsz);  text += "\n";   os << text;

      QString ntx="0"; ntx.setNum(camera->node->tx);     text=JahDebug("TX:"+ntx);  text += "\n";   os << text;
      QString nty="0"; nty.setNum(camera->node->ty);     text=JahDebug("TY:"+nty);  text += "\n";   os << text;
      QString ntz="0"; ntz.setNum(camera->node->tz);     text=JahDebug("TZ:"+ntz);  text += "\n";   os << text;

      QString nrx="0"; nrx.setNum(camera->node->rx);     text=JahDebug("RX:"+nrx);  text += "\n";   os << text;
      QString nry="0"; nry.setNum(camera->node->ry);     text=JahDebug("RY:"+nry);  text += "\n";   os << text;
      QString nrz="0"; nrz.setNum(camera->node->rz);     text=JahDebug("RZ:"+nrz);  text += "\n";   os << text;

      QString nra="0"; nra.setNum(camera->node->Alpha);  text=JahDebug("AL:"+nra);  text += "\n";   os << text;

   }

	} else {

   //if (i>0) {
    //problem here if layer has no keyframes...
		QString key="0"; key.setNum(0); text=JahDebug("NN:"+key);  text += "\n";   os << text;
		//QString key="0"; key.setNum(camera->nodes[0]->nodenum); text=JahDebug("NN:"+key);  text += "\n";   os << text;
    //debug("backdrop");
		QString nsx="0"; nsx.setNum(camera->node->sx);     text=JahDebug("SX:"+nsx);  text += "\n";   os << text;
		QString nsy="0"; nsy.setNum(camera->node->sy);     text=JahDebug("SY:"+nsy);   text += "\n";   os << text;
		QString nsz="0"; nsz.setNum(camera->node->sz);     text=JahDebug("SZ:"+nsz);    text += "\n";   os << text;

		QString ntx="0"; ntx.setNum(camera->node->tx);     text=JahDebug("TX:"+ntx);  text += "\n";   os << text;
		QString nty="0"; nty.setNum(camera->node->ty);     text=JahDebug("TY:"+nty);  text += "\n";   os << text;
		QString ntz="0"; ntz.setNum(camera->node->tz);     text=JahDebug("TZ:"+ntz);  text += "\n";   os << text;

		QString nrx="0"; nrx.setNum(camera->node->rx);     text=JahDebug("RX:"+nrx);  text += "\n";   os << text;
		QString nry="0"; nry.setNum(camera->node->ry);     text=JahDebug("RY:"+nry);  text += "\n";   os << text;
		QString nrz="0"; nrz.setNum(camera->node->rz);     text=JahDebug("RZ:"+nrz);  text += "\n";   os << text;

		QString nra="0"; nra.setNum(camera->node->Alpha);  text=JahDebug("AL:"+nra);  text += "\n";   os << text;
  }


}

}  // save scene files to disk



void GLWorld::SaveColor(QFile & file,int i) {
    QString text;  QTextStream os( &file );

    QString red; red.setNum(layers[i].Red);         text=JahDebug("Red:"+red);  text += "\n";   os << text;
    QString green; green.setNum(layers[i].Green);   text=JahDebug("Green:"+green);  text += "\n";   os << text;
    QString blue; blue.setNum(layers[i].Blue);      text=JahDebug("Blue:"+blue);  text += "\n";   os << text;


}  // save scene files to disk


void GLWorld::SaveText(QFile & file,int i) {
    QString text;  QTextStream os( &file );

    text=JahDebug("Stored text is:",layers[i].text->text);  text += "\n";   os << text;
    text=JahDebug("Stored font is:",layers[i].text->font);  text += "\n";   os << text;
    text=JahDebug("Stored font type is:",(int)layers[i].text->fontstyle);  text += "\n";   os << text;

    QString depth; depth.setNum(layers[i].text->extrude);
    text=JahDebug("Extrude depth:",depth);                   text += "\n";   os << text;

}  // save scene files to disk

