#include "glworld.h"

// Overloaded debug messages for feedback

//we need to check the return values here
//and find a quicker way to get back
//or not even execute functions
//if JAHDEBUG is off
//as these functions are a real performance killer
//better to use JahDebug in the calling command as well for now

QString GLWorld::JahDebug(QString debugmessage) {

	debug(debugmessage);
	
	return debugmessage;

}

QString GLWorld::JahDebug(QString debugmessage, int value) {

	QString stringval; debugmessage += stringval.setNum(value);
	debug(debugmessage);

	return debugmessage;

}

QString GLWorld::JahDebug(QString debugmessage, ObjectCategory cat) { 

    QString ObjType;      // based on enum ObjectCategory or objtype

	switch ( cat ) {

		case JAHLAYER     :     {     ObjType = "JAHLAYER";      break; }
		case MESHLAYER    :     {     ObjType = "MESHLAYER";     break; }
		case BACKDROP     :     {     ObjType = "BACKDROP";      break; }
		case BEZIERS      :     {     ObjType = "BEZIERS";       break; }
		case CUBE         :     {     ObjType = "CUBE";          break; }
		case SPHERE       :     {     ObjType = "SPHERE";        break; }
		case CYLINDER     :     {     ObjType = "CYLINDER";      break; }

		case JAHTEXT      :     {     ObjType = "JAHTEXT";       break; }
		case JAHPARTICLE  :     {     ObjType = "JAHPARTICLE";   break; }
			
		case OBJOBJECTS   :     {     ObjType = "OBJOBJECTS";    break; }
		case MAXOBJECTS   :     {     ObjType = "MAXOBJECTS";    break; }

		case JAHAXIS      :     {     ObjType = "JAHAXIS";       break; }
		case JAHLIGHT     :     {     ObjType = "JAHLIGHT";      break; }

		default           :     {     ObjType = "*NULL* create in GlWorld JahDebug";        
									  break; }
	}

	debugmessage += ObjType;
    debug(debugmessage);

    return debugmessage;

}

QString GLWorld::JahDebug(QString debugmessage, LayerCategory cat) { 
   
    QString LayType;      // based on enum LayerCategory or layertype

	switch ( cat ) {

		case LAYER        :     {     LayType = "LAYER";         break; }
		case PARTICLE     :     {     LayType = "PARTICLE";      break; }
		case OBJECTS      :     {     LayType = "OBJECTS";       break; }
		case FRAME        :     {     LayType = "FRAME";         break; }
		case TEXT         :     {     LayType = "TEXT";          break; }
		case GRID         :     {     LayType = "GRID";          break; }

		default           :     {     LayType = "*NULL* create in GlWorld JahDebug";        
			                          break; }
	}

	debugmessage += LayType;
    debug(debugmessage);

    return debugmessage;

}

QString GLWorld::JahDebug(QString debugmessage, float value) {

	QString stringval; debugmessage += stringval.setNum(value);
	debug(debugmessage);

	return debugmessage;

}

QString GLWorld::JahDebug(QString debugmessage, QString value) {
	
	debugmessage += value;
	debug(debugmessage);

	return debugmessage;

}

void GLWorld::printScene(void) {

	if (JAHDEBUG) {

		QString text;
		debug("print out the scene data here");

	 //layer 0 is the camera...
	 //maybe we should create a separate object like titleobject for camera object
	 //if its an array, then we can add more than one camer as well...
 
	 //first number of layers in scene file
		 for (int i=1; i<=numberLayers; i++) {
			 JahDebug("Info for Layer:",i);   
			text = JahDebug("Stored layer number:",layers[i].layernumber); 
			text = JahDebug("Stored layer name:",layers[i].layername);   
			text = JahDebug("Stored blend settings:",layers[i].blend); 
			text = JahDebug("Stored depth settings:",layers[i].depth);  
			text = JahDebug("Stored cull settings:",layers[i].cull);   
			text = JahDebug("Stored lighting settings:",layers[i].lighting);   
			text = JahDebug("Stored layer is activated:",layers[i].layerStatus); 
			text = JahDebug("LayerInfo:");   
			text = JahDebug("Stored layer is a:",layers[i].objtype);
        
			int ObjCode; ObjCode = (int)layers[i].objtype;
			text = JahDebug("Stored layer code:",ObjCode);   
		}
	}

}






