#include "glworld.h"


// Subroutine to determine which object is selected in
// On Screen selections

void GLWorld::mousePressEvent( QMouseEvent *e ) {

  /////////// check for object selection

      int xpos,ypos; xpos = e->x(); ypos = e->y();
      lastx = xpos; lasty = ypos;   // used for tracking motion

    	GLuint selectBuff[64];
    	GLint hits, viewport[4];

    	// Setup selection buffer
    	glSelectBuffer(64, selectBuff);

    	// Get the viewport
    	glGetIntegerv(GL_VIEWPORT, viewport);

    	// Switch to projection and save the matrix
    	glMatrixMode(GL_PROJECTION);
    	glPushMatrix();
    	glRenderMode(GL_SELECT);
    	glLoadIdentity();
    	gluPickMatrix(xpos, viewport[3] - ypos, 2,2, viewport);

    	// Apply perspective matrix
    	gluPerspective(45.0f, fAspect, 1.0, 425.0);
      glTranslatef( 0.0, 0.0, -75.0 );

    	// Draw the scene without the background on
            select = TRUE;	paintGL();  select = FALSE;
    	// Collect the hits
    	hits = glRenderMode(GL_RENDER);

    	if(hits == 1) processSelection(selectBuff);

    	glMatrixMode(GL_PROJECTION);
    	glPopMatrix();
    	glMatrixMode(GL_MODELVIEW);

//      updateScene();                  //whats this do?
      updateGL();

      mousePressed = TRUE;

}

void GLWorld::processSelection(GLuint *pSelectBuff)
	{

	int id,count;
	// How many names on the name stack
	count = pSelectBuff[0];
	// Bottom of the name stack
	id = pSelectBuff[3];

    QString clicked;  qDebug("you clicked"+clicked.setNum(id) );

  //we are getting the wrong id and it crashes

      layers[activeLayer].selected=FALSE;
      activeLayer = id;
      layers[activeLayer].selected=TRUE;
    //  updateGL();
    //we need a switch layer routine that updates sliders according to layers information!
   //switchLayers(activeLayer,newlayer);


}

void GLWorld::mouseReleaseEvent( QMouseEvent * ) {
    mousePressed = FALSE; }

//editing onscreen tools
void GLWorld::toolTranslate( void ) { mmode = MTRANSLATE;  updateToolDisplay(); updateGL(); }

void GLWorld::toolScale( void )     { mmode = MSCALE;      updateToolDisplay(); updateGL(); }

void GLWorld::toolRotate( void )    { mmode = MROTATE;     updateToolDisplay(); updateGL(); }

//still need to fix axis changes between layer and backdrop types
void GLWorld::toolToggleView( void ) {

	displayToggle =!displayToggle;

	if (!displayToggle) { layers[1].objtype = BACKDROP; } else { layers[1].objtype = MESHLAYER; }

	JahDebug("hit toggle"); updateGL();
}

void GLWorld::toolSplitEffect( void ) {
	
	displaySplit =!displaySplit;
	JahDebug("hit split effect"); updateGL();
}


void GLWorld::updateToolDisplay(void) {  renderSpace->setToolMode(mmode);     }

//need to update this routine for camera moves
void GLWorld::mouseMoveEvent( QMouseEvent *e ) {

  if ( mmode == MOFF ) return;

  int x = e->x();
  int y = e->y();

  if  (activeLayer == 0) { mouseMoveCamera(x,y);            }
  else                   { mouseMoveLayer (activeLayer,x,y); }

  updateGL();
  updateSliders();

  lastx = x; lasty = y;

}


void GLWorld::mouseMoveLayer ( int thelayer, int x, int y ) {

  //this will be used to apply zdepth to movements for sensitivity
  GLfloat coef;  coef = layers[thelayer].node->tz;             //        (GLfloat)(degrees )

  switch ( mmode ) {

      case MROTATE    : { if ( x>lastx)      { layers[thelayer].node->ry +=10.0; }
                          else if ( x<lastx) { layers[thelayer].node->ry -=10.0; }
                          if ( y>lasty)      { layers[thelayer].node->rx +=10.0; }
                          else if ( y<lasty) { layers[thelayer].node->rx -=10.0; }
                          break; }

      case MTRANSLATE : { if ( x>lastx)      { layers[thelayer].node->tx +=5.0; }
                          else if ( x<lastx) { layers[thelayer].node->tx -=5.0; }
                          if ( y>lasty)      { layers[thelayer].node->ty -=5.0; }
                          else if ( y<lasty) { layers[thelayer].node->ty +=5.0; }
                          break; }

      case MSCALE     : { if ( x>lastx)      { layers[thelayer].node->sx +=0.1; }
                          else if ( x<lastx) { layers[thelayer].node->sx -=0.1; }
                          if ( y>lasty)      { layers[thelayer].node->sy -=0.1; }
                          else if ( y<lasty) { layers[thelayer].node->sy +=0.1; }
                          break; }

      case MOFF       : {  break; }

      default         : {  break; }

    }

}

void GLWorld::mouseMoveCamera( int x,int y ) {

  //this will be used to apply zdepth to movements for sensitivity
  GLfloat coef;  coef = camera->node->tz;             //        (GLfloat)(degrees )

  switch ( mmode ) {

      case MROTATE    : { if ( x>lastx)         { camera->node->ry +=10.0; }
                          else if ( x<lastx)    { camera->node->ry -=10.0; }
                          if ( y>lasty)         { camera->node->rx +=10.0; }
                          else if ( y<lasty)    { camera->node->rx -=10.0; }
                          break; }

      case MTRANSLATE : { if ( x>lastx)         { camera->node->tx +=5.0; }
                          else if ( x<lastx)    { camera->node->tx -=5.0; }
                          if ( y>lasty)         { camera->node->ty -=5.0; }
                          else if ( y<lasty)    { camera->node->ty +=5.0; }
                          break; }

      case MSCALE     : { if ( x>lastx)         { camera->node->sx +=0.1; }
                          else if ( x<lastx)    { camera->node->sx -=0.1; }
                          if ( y>lasty)         { camera->node->sy -=0.1; }
                          else if ( y<lasty)    { camera->node->sy +=0.1; }
                          break; }

      case MOFF       : { break; }

      default         : { break; }

    }

}








