#include "glworld.h"

void GLWorld::buildController( QHBox* controller) {

   //////////////////////////////////////////////////////////////
   // This is the control bar
   // please clean me up and make me look cool
   // also get rid of constraints on startframe and endframe
   // and use the resizeable lcds in timecode format
   // for these variables display

    Astartframe=1;  Aendframe=100;  Aanimframe=1; MaxFrames = 100000;


    Form1Layout = new QHBoxLayout( controller, 11, 6, "Form1Layout");

    maincontroller = new QFrame( controller, "maincontroller" );
    maincontroller->setMinimumSize( QSize( 0, 35 ) );
    maincontroller->setMaximumSize( QSize( 32767, 35 ) );
    maincontroller->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
    maincontroller->setFrameShape( QFrame::Box );
    maincontroller->setFrameShadow( QFrame::Plain );
    maincontrollerLayout = new QHBoxLayout( maincontroller, 0, 0, "maincontrollerLayout");

    MainController = new QWidgetStack( maincontroller, "MainController" );

    page = new QWidget( MainController, "page" );
    pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
    QSpacerItem* spacer = new QSpacerItem( 30, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer );

    forceplayframe = new QFrame( page, "forceplayframe" );
    forceplayframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, forceplayframe->sizePolicy().hasHeightForWidth() ) );
    forceplayframe->setMinimumSize( QSize( 90, 20 ) );
    forceplayframe->setMaximumSize( QSize( 90, 20 ) );
    forceplayframe->setFrameShape( QFrame::StyledPanel );
    forceplayframe->setFrameShadow( QFrame::Raised );

    forcedplay = new QCheckBox( forceplayframe, "forceplaycheckbox" );
    forcedplay->setGeometry( QRect( 0, 0, 91, 21 ) );
    forcedplay->setText("ForcePlay" );
    pageLayout->addWidget( forceplayframe );
    connect( forcedplay,  SIGNAL(clicked()), this, SLOT(setForcePlay())  );

    QSpacerItem* spacer_2 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_2 );
    QSpacerItem* spacer_3 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_3 );

    controllerframe = new QFrame( page, "controllerframe" );
    controllerframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, controllerframe->sizePolicy().hasHeightForWidth() ) );
    controllerframe->setMinimumSize( QSize( 170, 30 ) );
    controllerframe->setMaximumSize( QSize( 170, 30 ) );
    controllerframe->setFrameShape( QFrame::NoFrame );
    controllerframe->setFrameShadow( QFrame::Plain );

/* scrublast->setText( tr( " >>"  ) ); */

    scrubfirst = new QPushButton( controllerframe, "controllerrewindbutton" );
    scrubfirst->setGeometry( QRect( 0, 2, 25, 28 ) );
    scrubfirst->setMinimumSize( QSize( 25, 0 ) );
    scrubfirst->setMaximumSize( QSize( 25, 32767 ) );
    scrubfirst->setText("<<" );
    connect( scrubfirst,  SIGNAL(clicked()), SLOT(firstframeanimation())  );

    scrubprevious = new QPushButton( controllerframe, "controllerpreviousbutton" );
    scrubprevious->setGeometry( QRect( 25, 2, 25, 28 ) );
    scrubprevious->setMinimumSize( QSize( 25, 0 ) );
    scrubprevious->setMaximumSize( QSize( 25, 32767 ) );
    scrubprevious->setText("<" );
    connect( scrubprevious,  SIGNAL(clicked()), SLOT(previousframeanimation())  );

    scrubstop = new QPushButton( ( QIconSet( QPixmap("Pixmaps/stop.xpm")) ), "", controllerframe, "stop" );
    scrubstop->setGeometry( QRect( 50, 2, 30, 28 ) );
    scrubstop->setMinimumSize( QSize( 30, 0 ) );
    scrubstop->setMaximumSize( QSize( 30, 32767 ) );
    connect( scrubstop,  SIGNAL(clicked()), SLOT(stopanimation())  );

    scrubplay = new QPushButton( ( QIconSet( QPixmap("Pixmaps/play.xpm")) ), "", controllerframe, "play" );
    scrubplay->setGeometry( QRect( 80, 2, 30, 28 ) );
    scrubplay->setMinimumSize( QSize( 30, 0 ) );
    scrubplay->setMaximumSize( QSize( 30, 32767 ) );
    connect( scrubplay,  SIGNAL(clicked()), SLOT(startanimation())  );

    scrubnext = new QPushButton( controllerframe, "controllernextbutton" );
    scrubnext->setGeometry( QRect( 110, 2, 25, 28 ) );
    scrubnext->setMinimumSize( QSize( 25, 0 ) );
    scrubnext->setMaximumSize( QSize( 25, 32767 ) );
    scrubnext->setText( ">" );
    connect( scrubnext,  SIGNAL(clicked()), SLOT(nextframeanimation())  );

    scrublast = new QPushButton( controllerframe, "controllerffworardbutton" );
    scrublast->setGeometry( QRect( 135, 2, 25, 28 ) );
    scrublast->setMinimumSize( QSize( 25, 0 ) );
    scrublast->setMaximumSize( QSize( 25, 32767 ) );
    scrublast->setText(">>");
    connect( scrublast,  SIGNAL(clicked()), SLOT(lastframeanimation())  );

    pageLayout->addWidget( controllerframe );

  /* Slider2 = new QSlider( page, "controllerslider" ); */
    controllerslider = new QSlider( page, "controllerslider" );
    controllerslider->setStyle( new QPlatinumStyle );
    controllerslider->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, 0, 0, controllerslider->sizePolicy().hasHeightForWidth() ) );
    controllerslider->setMinimumSize( QSize( 490, 0 ) );
    controllerslider->setMaximumSize( QSize( 500, 32767 ) );
    controllerslider->setOrientation( QSlider::Horizontal );
    controllerslider->setTickmarks( QSlider::Right );
    controllerslider->setMinValue( Astartframe );
    controllerslider->setMaxValue( Aendframe );
    controllerslider->setValue   ( Aanimframe );

    connect( controllerslider,   SIGNAL(sliderMoved(int)),    SLOT(updateanimframe(int)) );
    connect( controllerslider,   SIGNAL(sliderPressed()),     SLOT(sliderselected()) );
    connect( controllerslider,   SIGNAL(sliderReleased()),    SLOT(sliderreleased()) );

    pageLayout->addWidget( controllerslider );

    timecodeframe = new QFrame( page, "timecodeframe" );
    timecodeframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, timecodeframe->sizePolicy().hasHeightForWidth() ) );
    timecodeframe->setMinimumSize( QSize( 125, 30 ) );
    timecodeframe->setMaximumSize( QSize( 125, 30 ) );
    timecodeframe->setFrameShape( QFrame::NoFrame );
    timecodeframe->setFrameShadow( QFrame::Raised );

    animframe = new InputLCD( timecodeframe, "timecodedisplay",9 );
    addSliderLcd(animframe, 5, 0, 90, 31, 100);
    animframe->setValue( 1 );
    connect( controllerslider,   SIGNAL(valueChanged(int)),   animframe, SLOT(setValue(int)) );
	  connect( animframe, SIGNAL(valueChanged(int)),   SLOT(updateanimframe(int)) );

    scrubkey = new QPushButton( timecodeframe, "keyframebutton" );
    scrubkey->setGeometry( QRect( 95, 0, 25, 28 ) );
    scrubkey->setText( tr( "key"  ) );
    scrubkey->setMinimumSize( QSize( 25, 0 ) );
    scrubkey->setMaximumSize( QSize( 25, 32767 ) );
    connect( scrubkey, SIGNAL(clicked()), SLOT(addKeyframe()) );

    pageLayout->addWidget( timecodeframe );

    QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_4 );

    imagingframe = new QFrame( page, "imagingframe" );
    imagingframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, imagingframe->sizePolicy().hasHeightForWidth() ) );
    imagingframe->setMinimumSize( QSize( 105, 20 ) );
    imagingframe->setMaximumSize( QSize( 105, 20 ) );
    imagingframe->setFrameShape( QFrame::NoFrame );
    imagingframe->setFrameShadow( QFrame::Raised );

    scrubrender = new QPushButton( imagingframe, "imagingphotobutton" );
    scrubrender->setGeometry( QRect( 0, 0, 50, 20 ) );
    scrubrender->setMinimumSize( QSize( 50, 20 ) );
    scrubrender->setMaximumSize( QSize( 50, 20 ) );
    scrubrender->setText( tr( "Photo"  ) );
    connect( scrubrender, SIGNAL(clicked()), SLOT( Render()) );   //change this mon

    scrubrenderAll = new QPushButton( imagingframe, "imagingrenderbutton" );
    scrubrenderAll->setGeometry( QRect( 55, 0, 50, 20 ) );
    scrubrenderAll->setMinimumSize( QSize( 50, 20 ) );
    scrubrenderAll->setMaximumSize( QSize( 50, 20 ) );
    scrubrenderAll->setText( tr( "Render"  ) );
    connect( scrubrenderAll, SIGNAL(clicked()), SLOT( RenderScene()) );   //change this mon

    pageLayout->addWidget( imagingframe );

    QSpacerItem* spacer_5 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_5 );

    MainController->addWidget( page, 0 );
    maincontrollerLayout->addWidget( MainController );
    Form1Layout->addWidget( maincontroller );
    MainController->raiseWidget(0);

}


void GLWorld::updatesliderStartframe( int startframe ) {
	
	controllerslider->setMinValue( startframe );
  controllerslider->setTickmarks(QSlider::Right);
}

void GLWorld::updatesliderEndframe( int endframe )     {
	
	controllerslider->setMaxValue( endframe );
  maxFrame = endframe;
	controllerslider->setTickmarks(QSlider::Right);
}

/////////////////////////////////////////////////////////////////////////////
// These are interface building subrutines to save space
// in all module interface building code


void GLWorld::addButton( QPushButton * button, int x, int y, int w, int h, QString text ) {

    button->setGeometry( QRect( x, y, w, h ) );
    button->setText( tr( text  ) );

}

void GLWorld::addCheckButton( QCheckBox * button, int x, int y, int w, int h, QString text ) {

    button->setGeometry( QRect( x, y, w, h ) );
    button->setText( tr( text  ) );

}

void GLWorld::addIconButton( QPushButton * button, int x, int y, int w, int h, QString icon ) {

  button->setGeometry( QRect( x, y, w, h ) );
	button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addIconButton( QPushButton * button, int x, int y, int w, int h ) {

  button->setGeometry( QRect( x, y, w, h ) );
	//button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addToolButton( QToolButton * button, int x, int y, int w, int h, QString icon ) {

    button->setGeometry( QRect( x, y, w, h ) );

	button->setToggleButton(true);
	button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addToolButton( QToolButton * button, int x, int y, int w, int h ) {

    button->setGeometry( QRect( x, y, w, h ) );
	button->setToggleButton(true);
	button->setIconSet(QIconSet( QPixmap(), QPixmap() ));
	
}


void GLWorld::addLabel( QLabel * label, int x, int y, int w, int h, QString text, int size) {

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( text  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );
}

void GLWorld::addSlider( QSlider * slider, int x, int y, int w, int h, int range) {
    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

}



void GLWorld::addSliderLcd( InputLCD * lcd, int x, int y, int w, int h, int range) {

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, w, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addRangeSlider( QSlider * slider, int x, int y, int w, int h, int rangemin, int rangemax) {
    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

}


void GLWorld::addLcdLabel      ( QFrame * frame,
                                 InputLCD * lcd, int x, int y, int w, int h, int range,
                                 QString labeltext, int size ) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+w+5, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addLabelLcd      ( QFrame * frame,
                                 InputLCD * lcd, int x, int y, int w, int h, int range,
                                 QString labeltext, int size ) {

   QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x+30, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );


}

void GLWorld::addSliderAndLcd( QSlider * slider, int x, int y, int w, int h, int range,
                               InputLCD * lcd ) {

    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, w, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addSliderAndLcd( QSlider * slider, int x, int y, int w, int h, int rangemin, int rangemax,
                               InputLCD * lcd ) {

    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+w, y, 21, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );
    lcd->setMinInt( 0 );
    lcd->setMaxInt( 100 );

}

void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h, int range,
                                 InputLCD * lcd,
                                 QString labeltext, int size) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, 21, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addDialLcdLabel( QFrame * frame,
                                 QDial  * dial, int x, int y, int w, int h, int range,
                                 InputLCD * lcd,
                                 QString labeltext, int size) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    dial->setStyle( new QPlatinumStyle );
    dial->setGeometry( QRect( x+10, y, w+100, h ) );
   // dial->setOrientation( QSlider::Horizontal );
    dial->setMinValue( 0 );
    dial->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, w+21, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h,
                                 int rangemin, int rangemax,
                                 InputLCD * lcd,
                                 QString labeltext, int size) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, w+21, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( rangemin );

}

void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h,
                                 int rangemin, int rangemax, int preset,
                                 InputLCD * lcd,
                                 QString labeltext, int size) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    slider->setStyle( new QPlatinumStyle );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );
    slider->setValue( preset );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, w+21, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( rangemin );

}












