/*******************************************************************************
**
** The source file for the Jahshaka glworldlayer.cpp module
** The Jahshaka Project
** Copyright (C) 2000-2003 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"


bool GLWorld::createLayer( int nl, QString layerName, LayerCategory layertype, ObjectCategory objtype ) {

	//first we set up default variables

	layers[nl].layernumber   = nl;
	layers[nl].layertype     = layertype;
	layers[nl].objtype       = objtype;

	QString layNum;	layNum.setNum(nl);
	layers[nl].layername     = layerName;

	bool itworked = TRUE;
	
	  //now we create the layer

	  switch ( layertype ) {

		case LAYER        :     {   //if no path is set...
                                //if (!layers[nl].pathname) { layers[nl].pathname  = JahBasePath; }
                                //we should check this
                                layers[nl].drawtheLayer = TRUE;

              									//we only auto-create single frame layers
              									//but the .jah loader uses this so we override for clips
              									if (!layers[nl].videotex) { layers[nl].startframe = 1; layers[nl].endframe = 1; layers[nl].numframes = 1; }
              									debug(">>>Fix this please<<<");
                                debug(">>layername:"+layers[nl].filename);
              									debug(">>layerpath:"+layers[nl].pathname);

                                layers[nl].LoadLayerImage(IMAGE);   //IMAGE is image, AVI for a AVI file...

              									if (layers[nl].keyStatus)
              										{ //if (!layers[nl].keypathname) layers[nl].keypathname = JahBasePath;
              										
              									if (!layers[nl].videotex) {layers[nl].keystartframe = 1; layers[nl].keyendframe = 1; layers[nl].numkeyframes = 1;}
              										  layers[nl].drawtheKey = TRUE;
              										  layers[nl].LoadLayerImage(KEY); }

              									layers[nl].makeTexture();

              								  break; }

		case PARTICLE     :     {   layers[nl].addParticleObj();   break; }	
			
		case OBJECTS      :     {   if (!layers[nl].pathname) layers[nl].pathname  = JahBasePath;
									              if ( objtype==OBJOBJECTS) {
                                     layers[nl].loadOBJ   (layers[nl].objfilename+layers[nl].objextension);   }
			                          if ( objtype==MAXOBJECTS) {
                                     layers[nl].loadMaxOBJ(layers[nl].objfilename+layers[nl].objextension);   }

                                break; }

		case FRAME        :     {   break; }

		case TEXT         :     {   debug("creating the font layer");
                                if ( layers[nl].loadFontText()) { layers[nl].drawText(); }
                                break; }

		case GRID         :     {   break; }

		default           :     {   itworked = FALSE;
                                debug("object type not supported"); break; }

	  }

	 return itworked;

}

//switch the layer object type
void GLWorld::ChangeObjectLayer(void)    { if (activeLayer>0) layers[activeLayer].objtype = JAHLAYER;  updateGL(); }
void GLWorld::ChangeObjectCube(void)     { if (activeLayer>0) layers[activeLayer].objtype = CUBE;      updateGL(); }
void GLWorld::ChangeObjectCylinder(void) { if (activeLayer>0) layers[activeLayer].objtype = CYLINDER;  updateGL(); }
void GLWorld::ChangeObjectSphere(void)   { if (activeLayer>0) layers[activeLayer].objtype = SPHERE;    updateGL(); }
void GLWorld::ChangeObjectBezier(void)   { if (activeLayer>0) layers[activeLayer].objtype = BEZIERS;   updateGL(); }
void GLWorld::ChangeObjectMesh(void)     { if (activeLayer>0) layers[activeLayer].objtype = MESHLAYER; updateGL(); }
