#include "glworld.h"

void GLWorld::checkRenderQuality() {

    //defaults
    if (renderquality<0) { renderquality=2; }
    if (renderquality>2) { renderquality=2; }

    switch (renderquality) {

    case 0  : { renderext=".jpg"; renderformat="JPEG"; break; }
    case 1  : { renderext=".png"; renderformat="PNG";  break; }
    case 2  : { renderext=".bmp"; renderformat="BMP";  break; }

    default : { renderext=".png"; renderformat="PNG";  break; }

    }


}

void GLWorld::setRenderQuality(int quality) {

    if ( quality<0) { renderquality=2; }
    else if ( quality>2) { renderquality=2; }
    else { renderquality = quality; }

}

void GLWorld::Render() {

  //clipnumber++;
  videoData thedata;

  checkRenderQuality();

  QString moduleinfo = ModuleName+"Image";
  QString temp;

  thedata.theCategory = IMAGE;
  thedata.cliptype	= SEQUENCE;

  thedata.clipname    = moduleinfo;

  int clipnum = *clipnumber;  clipnum++;

  thedata.clipnumber  = clipnum;   //needs to be globalclipnumber!

  //set the render path here
  QString jahrenderpath = renderpath;

  //thedata.Image       = proxy;
  thedata.location    = jahrenderpath;
  thedata.filename    = moduleinfo + temp.setNum(clipnum);
  thedata.extension   = renderext;
  thedata.startframe  = 1;
  thedata.endframe    = 1;
  thedata.keyStatus   = FALSE;
  thedata.xpos        = 0;
  thedata.ypos        = 0;

  layers[activeLayer].selected=FALSE;

  QImage shot = Photo(thedata);
  thedata.Image=shot;

  layers[activeLayer].selected=TRUE;
  emit updateDesktop(  thedata );

  *clipnumber = clipnum;

}

//added for siggraph demo to update player with still image
void GLWorld::SoftRender() {

  videoData thedata;

  checkRenderQuality();

  QString moduleinfo = ModuleName+"Image";
  QString temp;

  thedata.theCategory = IMAGE;
  thedata.cliptype	= SEQUENCE;

  thedata.clipname    = moduleinfo;

  int clipnum = *clipnumber;
  thedata.clipnumber  = clipnum;   //needs to be globalclipnumber!

  //set the render path here
  QString jahrenderpath = renderpath;

  //thedata.Image       = proxy;
  thedata.location    = jahrenderpath;
  thedata.filename    = moduleinfo + temp.setNum(clipnum);
  thedata.extension   = renderext;
  thedata.startframe  = 1;
  thedata.endframe    = 1;
  thedata.keyStatus   = FALSE;
  thedata.xpos        = 0;
  thedata.ypos        = 0;

  layers[activeLayer].selected=FALSE;

  //QImage shot = SoftPhoto(thedata);
  //thedata.Image=shot;
  thedata.Image=SoftPhoto(thedata);

  layers[activeLayer].selected=TRUE;

  emit updatePlayer (  thedata );


}

void GLWorld::RenderScene() {

	renderStatus = !renderStatus;

  checkRenderQuality();

	//we override rendering of scenes for paint until that module is fixed
	if ( (renderStatus) && (ModuleName!="Paint") ) {

	  changeZoom(0);

		timer->stop(  );

		int startFrame = controllerslider->value();
		QString temp;
		QString moduleinfo = ModuleName+"Clip";
		videoData thedata;

		int clipnum = *clipnumber;  clipnum++;

		//set the render path here
		QString jahrenderpath = renderpath;

		//set up the clip's data
		thedata.theCategory = CLIP;
		thedata.cliptype	= SEQUENCE;
		thedata.clipname    = moduleinfo;      //need to know this
		thedata.clipnumber  = clipnum;
		thedata.location    = jahrenderpath;
		thedata.filename    = moduleinfo + temp.setNum(clipnum)+"_";
		thedata.extension   = renderext;
		thedata.startframe  = 1;
		thedata.endframe    = (maxFrame-startFrame)+1;   //is default length of animation
		thedata.keyStatus   = FALSE;
		thedata.xpos        = 0;
		thedata.ypos        = 0;

		//this is where we figure out the video extension for the numbering sequence
		QString theblankframe;  theblankframe.setNum(maxFrame);
		int     blanklength = theblankframe.length();

		QString theblank;
		for (int i=0; i<blanklength; i++) {
			theblank +="0";
		}

		thedata.videoext    = theblank+"1";

		//deselect the active layer
		layers[activeLayer].selected=FALSE;

		//render out the sequence
		QImage shot = RenderAll(thedata,startFrame,maxFrame);

		//the thumbnail is returned
		thedata.Image=shot;

		//did it end where it was supposed to or was it cancelled early
		int endFrame = controllerslider->value();

		if (renderStatus==FALSE) {
			thedata.endframe = (endFrame - startFrame) +1; 		
		} //+1 ?

		//reselect the activelayer
		layers[activeLayer].selected=TRUE;

		//add clip to tthe desktop now
		emit updateDesktop(  thedata );

		//and then incremnent global clipnumber
		*clipnumber = clipnum;

    }
}

QImage GLWorld::Photo(videoData theclip) {

  QString writefile = theclip.location+theclip.filename+theclip.extension;

	 QImage thephoto;

	if (ModuleName=="Paint")
		 {
        thephoto = screenShot(currentFrame, 0, 0, 0, 0, X_RESOLUTION, Y_RESOLUTION );
     }

	else {

    //based on renderworld renderheight and renderwidth
    int theheight = (renderSpace->renderheight/2)-243;   //700/2   - y = 107
    int thewidth  = (renderSpace->renderwidth/2)-360;    //1210/2  - x = 245

    thephoto = screenShot(currentFrame, thewidth, thewidth, theheight, theheight, X_RESOLUTION, Y_RESOLUTION );
  }

  QImageIO iio; iio.setImage(thephoto);
  iio.setFileName(writefile);
  iio.setFormat(renderformat);
  iio.write();

  return thephoto; // send straight to desktop when controls are local
}

QImage GLWorld::SoftPhoto(videoData theclip) {

	QImage thephoto;

	if (ModuleName=="Paint")
		 {
        thephoto = screenShot(currentFrame, 0, 0, 0, 0, X_RESOLUTION, Y_RESOLUTION );
     }

	else {

    //based on renderworld renderheight and renderwidth
    int theheight = (renderSpace->renderheight/2)-243;   //700/2   - y = 107
    int thewidth  = (renderSpace->renderwidth/2)-360;    //1210/2  - x = 245

    thephoto = screenShot(currentFrame, thewidth, thewidth, theheight, theheight, X_RESOLUTION, Y_RESOLUTION );
  }

  return thephoto; // send straight to desktop when controls are local
}

QImage GLWorld::RenderAll(videoData theclip, int startframe, int endframe ) {

	QImage returnshot;
	QString filename = theclip.location+theclip.filename;
	QString writefile,blank,extension;
	timer->stop();     //supposed to stop the timer so renders are FAST!

	//we loop through everything now
	int frameval = 0;
	QString currentframe;
	int length;
	int blanklength;
	
	for (int i = startframe; i<=endframe; i++) {

		//this is the clip counter for saved frames
		frameval++;

		//we need to check our interupts here to kill render..
		qApp->processEvents();
		if (renderStatus==FALSE) break;

			// This is where we create the extension for the sequence

			//first figure out length of current frame
			currentframe.setNum(frameval);
			length = currentframe.length();  //was theblankframe

			//then remove it from the blank template for the clip
			QString blank(theclip.videoext);
			blank = blank.remove(0, length);

			//now we need to build the blank from scratch to account for sequences begining with 0001 etc
			blanklength = blank.length();
			QString theblank;
			for (int ii=0; ii<blanklength; ii++) {
				theblank +="0";
			}

			blank = theblank+currentframe;

       writefile = filename + blank + theclip.extension;

    //based on renderworld renderheight and renderwidth
    int theheight = (renderSpace->renderheight/2)-243;   //700/2   - y = 107
    int thewidth  = (renderSpace->renderwidth/2)-360;    //1210/2  - x = 245

    //ok lets do some maths now...

    QImage img = screenShot(i, thewidth, thewidth, theheight, theheight, X_RESOLUTION, Y_RESOLUTION );
		//else { img = screenShot(currentFrame, 245, 245, 110, 110, X_RESOLUTION, Y_RESOLUTION ); }


       //QImage img = screenShot(i, 245, 245, 107, 107, X_RESOLUTION, Y_RESOLUTION );

       QImageIO iio; iio.setImage(img);
       iio.setFileName(writefile);
       iio.setFormat(renderformat);
       iio.write();

       if (i==startframe) { returnshot = img; }
   }

	renderStatus=FALSE;
	timer->start( redrawWait, TRUE );        //supposed to reactivate the timer
	return returnshot;
}

QImage GLWorld::screenShot(int Frame, int xloffset,int xroffset,int ytoffset,int yboffset,
                           int xres, int yres) {

  //update visuals    -- follow these commands for debugging here
  updateanimframe(Frame);
  updateSlider(Frame);   //used for visual feedback

  makeCurrent();   //finish the screen redraw?
  renderGL(); // draw the hires scene

  #ifdef _OS_IRIX_

  GLint viewport[4];
  glGetIntegerv(GL_VIEWPORT,viewport);

  QImage img(viewport[2]-(xloffset+xroffset),(viewport[3]-(ytoffset+yboffset)),32);
  // QImage img(720,486,32);
  GLfloat *r=new GLfloat[viewport[2]];
  GLfloat *g=new GLfloat[viewport[2]];
  GLfloat *b=new GLfloat[viewport[2]];

    for(int y=0;y<(viewport[3]-(ytoffset+yboffset));y++) {
        glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_RED,GL_FLOAT,(void *) r);
        glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_GREEN,GL_FLOAT,(void *) g);
        glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_BLUE,GL_FLOAT,(void *) b);

        for(int x=0;x<(viewport[2]-(xloffset+xroffset));x++) {
            uint *p = (uint *)img.scanLine(viewport[3]-1-y-(ytoffset+yboffset) )+x;
            *p = qRgb((uint) (r[x+xloffset]*255),
                      (uint) (g[x+xloffset]*255),
                      (uint) (b[x+xloffset]*255));
        }
    }

    delete[] r;    delete[] g;    delete[] b;
#else

    QPixmap mymap;  //move this out of the loop
    mymap = QPixmap::grabWindow(this->winId(),xloffset,ytoffset,
                                xres,yres); //where canvas is this

	//this is used to test the renderspace
	//if (JAHDEBUG) {
	//	JahDebug("xleft",xloffset);
	//	JahDebug("ytop",ytoffset);
	//	JahDebug("xres",X_RESOLUTION);
	//	JahDebug("yres",Y_RESOLUTION);
	//}

    QImage img; img = mymap;

#endif


    return img; // send straight to desktop when controls are local
}

void GLWorld::renderGL() {

  // we are aliasing in hardware so this routine should no longer be called

  if (polySmooth) {   debug("polysmooth");

    int i;

    GLfloat jitter[4][2] = {   { -0.20,  0.35 },       {  0.20, -0.35 },
                               { -0.30, -0.15 },       {  0.30,  0.15 }   };

    for (i=0; i<4; i++)
        {

        // the world object is 0 we position it here
        layers[0].node->tx += (jitter[i][0] * 100.5);
        layers[0].node->ty += (jitter[i][1] * 100.5);

          paintGL();

        layers[0].node->tx -= (jitter[i][0] * 100.5);
        layers[0].node->ty -= (jitter[i][1] * 100.5);

        if (i == 0)
          glAccum(GL_LOAD, 0.25);
        else
          glAccum(GL_ACCUM, 0.25);
        }

        glAccum(GL_RETURN, 1.0);
    }

  else { paintGL(); }

}

