/*******************************************************************************
**
** The header file for the Jahshaka glworld module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"
#include "glworldheaders.h"

void GLWorld::swap(worldSort &x, worldSort &y)
{
    worldSort temp;

    temp = x;
    x = y;
    y = temp;
}


//now we need to sort against the camera ie if the camera moves behind the scene
void GLWorld::sortLayers(void) {

  for (int x=1; x<=numberLayers; x++) {
    worldorder[x-1].laynum = x;
    worldorder[x-1].depth = layers[x].node->tz;
  }

  // This is where we do the sorting
  for (int i = 0; i < (numberLayers-1); i++)
  {
      int minIndex = i;

      // Find the index of the minimum element
      for (int j = i + 1; j < numberLayers; j++)
      {
          if (worldorder[j].depth < worldorder[minIndex].depth) { minIndex = j; }
      }

      // Swap if i-th element not already smallest
      if (minIndex > i) { swap(worldorder[i], worldorder[minIndex]); }
  }

}

/*
void GLWorld::sortLayers(void) {

  worldSort * wlayers  = new worldSort[numberLayers];

  for (int x=1; x<=numberLayers; x++) {
    wlayers[x-1].laynum = x;
    wlayers[x-1].depth = layers[x].node->tz;
  }

  // This is where we do the sorting
  for (int i = 0; i < (numberLayers-1); i++)
  {
      int minIndex = i;

      // Find the index of the minimum element
      for (int j = i + 1; j < numberLayers; j++)
      {
          if (wlayers[j].depth < wlayers[minIndex].depth) { minIndex = j; }
      }

      // Swap if i-th element not already smallest
      if (minIndex > i) { swap(wlayers[i], wlayers[minIndex]); }
  }

  //builds the drawing order
  for (int x=0; x<numberLayers; x++) { worldorder[x] = wlayers[x]; }

  delete [] wlayers;

}
*/








