/*******************************************************************************
**
** The source file for the Jahshaka animation module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "anime.h"

void GLAnime::initializeObjects() {   if (JAHDEBUG) JahDebug("In the GLAnime initialize objects");

  //make the current opengl context current so the textures can be set up properly
  this->makeCurrent();

  /// first layer is the backgroundimage
  layers[0].blend = FALSE; layers[0].depth = FALSE;
  layers[0].filename = "Pixmaps/jahlayer"; layers[0].extension = ".bmp";
  createLayer(0,"World", LAYER, BACKDROP );


  addSelection(FALSE);   // adds backgroundimage as 'off' uses default numberLayers = 1

  objectMenu(numberLayers); updateSliders();
  toolTranslate();

}

void GLAnime::updateSliders() { //if (JAHDEBUG) debug("GLAnime we are updating the sliders");

  if ( activeLayer>0 ) {     //its the layers

    light1->setChecked(layers[activeLayer].lighting);
    ClipSelect->setChecked(layers[activeLayer].drawtheLayer);
    KeySelect->setChecked(layers[activeLayer].drawtheKey);

    Trans_1->setValue ( (int)(layers[activeLayer].node->Alpha)  );

    RotX_1->setValue  ( (int)layers[activeLayer].node->rx );
    RotY_1->setValue  ( (int)layers[activeLayer].node->ry );
    RotZ_1->setValue  ( (int)layers[activeLayer].node->rz );

    TranX_1->setValue ( (int)layers[activeLayer].node->tx );
    TranY_1->setValue ( (int)layers[activeLayer].node->ty );
    TranZ_1->setValue ( (int)layers[activeLayer].node->tz );

    ScaleX_1->setValue( (int)(layers[activeLayer].node->sx *10) );
    ScaleY_1->setValue( (int)(layers[activeLayer].node->sy *10) );
    ScaleZ_1->setValue( (int)(layers[activeLayer].node->sz *10) );

    //update video frames here
    FramesLcd->setValue   ( layers[activeLayer].numframes );
    inFramesLcd->setValue ( layers[activeLayer].startframe );
    outFramesLcd->setValue( layers[activeLayer].endframe );

    KeyFramesLcd->setValue   ( layers[activeLayer].numkeyframes );
    inKeyFramesLcd->setValue ( layers[activeLayer].keystartframe );
    outKeyFramesLcd->setValue( layers[activeLayer].keyendframe );

  } else  { //its the world...

    RotX_4->setValue ( (int)camera->node->rx );
    RotY_4->setValue ( (int)camera->node->ry );
    RotZ_4->setValue ( (int)camera->node->rz );

    TranX_4->setValue( (int)camera->node->tx );
    TranY_4->setValue( (int)camera->node->ty );
    TranZ_4->setValue( (int)camera->node->tz );

    FramesLcd->setValue      ( layers[0].endframe );
    inFramesLcd->setValue    ( layers[0].startframe );
    outFramesLcd->setValue   ( layers[0].endframe );

    KeyFramesLcd->setValue   ( layers[0].keyendframe );
    inKeyFramesLcd->setValue ( layers[0].keystartframe );
    outKeyFramesLcd->setValue( layers[0].keyendframe );
  }
}

//can we move this routine into the World object?
//seems like it needs to be local
//in order to call the local updatesliders routine

void GLAnime::clicked( QListViewItem* items )
{
	if (!items) return;

  //this raises the control panel when you click on the layer
	if ( controlpanel->id (controlpanel->visibleWidget() )==0 )
		   controlpanel->raiseWidget(1);

	QString laynum =  items->text( 1 );

	int itemstatus;
	if (   ( ( QCheckListItem* )items )->isOn()==1   ) { itemstatus=1; }
	if (   ( ( QCheckListItem* )items )->isOn()==0   ) { itemstatus=0; }


  int pp = laynum.toInt();


  //brings up the menu for the selected layer according to layer number
  objectMenu(pp);

  //we waste a interupt here, always checking the clicked item
  //would be better with a signal slot implementation

	if ( ( itemstatus==1 ) && (layers[pp].layerStatus==0)) { setLayerVisible(pp, TRUE);   }
    else if ( ( itemstatus==0 ) && (layers[pp].layerStatus==1) ){ setLayerVisible(pp, FALSE);  }
		  else updateGL();

	updateSliders();

}






















