/*******************************************************************************
**
** The source file for the Jahshaka effects objects module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "colorize.h"

void GLColorize::doColorMatrix(int layer) {

  glMatrixMode(GL_COLOR);
  glPushMatrix();          //???

  //contrast
  GLfloat ContrastR, ContrastG, ContrastB;

  ContrastR = layers[layer].node->tx/100;
  ContrastG = layers[layer].node->ty/100;
  ContrastB = layers[layer].node->tz/100;

  glScalef(ContrastR, ContrastG, ContrastB );

  //brightness
  GLfloat BrightR, BrightG, BrightB;
  BrightR = layers[layer].node->rx/100;
  BrightG = layers[layer].node->ry/100;
  BrightB = layers[layer].node->rz/100;

  glTranslatef(BrightR, BrightG, BrightB );

  //saturation
  GLfloat saturation;

  saturation=layers[layer].node->sx/100;

  GLfloat matrix[16];

  matrix[0]  = (1.0 - saturation ) * 0.3086 + saturation;
  matrix[1]  = (1.0 - saturation ) * 0.3086 ;
  matrix[2]  = (1.0 - saturation ) * 0.3086 ;
  matrix[3]  = 0.0 ;
  matrix[4]  = (1.0 - saturation ) * 0.6094 ;
  matrix[5]  = (1.0 - saturation ) * 0.6094 + saturation;
  matrix[6]  = (1.0 - saturation ) * 0.6094 ;
  matrix[7]  = 0.0 ;
  matrix[8]  = (1.0 - saturation ) * 0.0820 ;
  matrix[9]  = (1.0 - saturation ) * 0.0820 ;
  matrix[10] = (1.0 - saturation ) * 0.0820 + saturation;
  matrix[12] = 0.0 ;
  matrix[13] = 0.0 ;
  matrix[14] = 0.0 ;
  matrix[15] = 1.0 ;

  glMultMatrixf(matrix);

  //if we can fix this code we are looking good here
  //glPopMatrix();glMatrixMode(GL_MODELVIEW);


}
