/*******************************************************************************
**
** The source file for the Jahshaka editing module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "edit.h"


void GLEdit::initializeObjects() {

  //make the current opengl context current so the textures can be set up properly
  this->makeCurrent();


  /// first layer is the backgroundimage
  layers[0].blend = FALSE; layers[0].depth = FALSE;
  layers[0].filename = "Pixmaps/jahlayer"; layers[0].extension = ".bmp";
  createLayer(0,"VidLayer1", LAYER, BACKDROP );

  //dont know why we do this here but i think its a workaround
  //need to FIX this here


  addSelection(FALSE);   // adds backgroundimage as 'off' uses default numberLayers = 1

  objectMenu(numberLayers); updateSliders();

}


void GLEdit::updateSliders() //update my interface here
{
    if (JAHDEBUG) debug("Edit sliders code needs to be updated here");
   /*
    light1->setChecked(layers[activeLayer].lighting);

    Trans_1->setValue( (int)(layers[activeLayer].node->Alpha)  );

    RotX_1->setValue( (int)layers[activeLayer].node->rx );
    RotY_1->setValue( (int)layers[activeLayer].node->ry );
    RotZ_1->setValue( (int)layers[activeLayer].node->rz );

    TranX_1->setValue( (int)layers[activeLayer].node->tx );
    TranY_1->setValue( (int)layers[activeLayer].node->ty );
    TranZ_1->setValue( (int)layers[activeLayer].node->tz );

    ScaleX_1->setValue( (int)(layers[activeLayer].node->sx *10) );
    ScaleY_1->setValue( (int)(layers[activeLayer].node->sy *10) );
    ScaleZ_1->setValue( (int)(layers[activeLayer].node->sz *10) );
           */

}


void GLEdit::clicked( QListViewItem* items )
{

	if (!items) return;

	QString laynum =  items->text( 1 );

	int itemstatus;
	if (   ( ( QCheckListItem* )items )->isOn()==1   ) { itemstatus=1; }
	if (   ( ( QCheckListItem* )items )->isOn()==0   ) { itemstatus=0; }


	int pp = laynum.toInt();

	//set to background as default
	if (pp==0)  { pp = 1;}

	if (JAHDEBUG) JahDebug("GLAnime stored layer number is", pp );

	//brings up the menu for the selected layer according to layer number
    objectMenu(pp);


	if ( ( itemstatus==1 ) && (layers[pp].layerStatus==0)) { setLayerVisible(pp, TRUE); layers[pp].printInfo();   }
		else
    if ( ( itemstatus==0 ) && (layers[pp].layerStatus==1) ){ setLayerVisible(pp, FALSE);  }
		else
	updateGL();

	updateSliders();


}


void GLEdit::objectMenu(int menu) {
	
	//having trouble overriding this locally
	//we can use the default one when the editing interface is finished
	//in glworldcontrols.cpp

    JahDebug("In editing object menu needs to be rewritten");

    //select new object and update scene
    changeSelection(menu);

}


void GLEdit::sceneSettings(void)
{
    //name layer
    EffectsStatus = !EffectsStatus;
    if (EffectsStatus) { EffectsMain->raiseWidget(0); }
        else  { EffectsMain->raiseWidget(1); }

}


















