/*******************************************************************************
**
** The source file for the Jahshaka editing interface module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "edit.h"

#include "Pixmaps/light.xpm"

void GLEdit::buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller) {

   //////////////////////////////////////////////////////////////
   // This is to be overridden...

}

void GLEdit::buildInterface( QHBox* qtinterface ) {

///////////////////////////This is the interface////////////////////////////////


    LayersFrame = new QFrame( qtinterface, "EffectsFrame" );
    LayersFrame->setGeometry( QRect( 0, 0, 60, 195 ) );
    LayersFrame->setMinimumSize( QSize( 60, 195 ) );  //was 960
    LayersFrame->setMaximumSize( QSize( 60, 195 ) );

    //////////////////// layer options /////////////////////////
    AddButton = new QPushButton( LayersFrame, "AddButton" );
    addButton( AddButton,  0, 5, 55, 25,  "Add" );
    connect  ( AddButton,  SIGNAL(clicked()), this, SLOT( addLayer())  );

    NameButton = new QPushButton( LayersFrame, "NameButton" );
    addButton( NameButton, 0, 30, 55, 25, "Name" );
    //connect  ( NameButton,  SIGNAL(clicked()), this, SLOT( nameLayer())  );

      //namepopup = new FancyPopup( this, "Enter Layer Name",200,100 );  //send size and position as well
      //connect ( namepopup,      SIGNAL( returnText(QString)), SLOT( setlayerName(QString)) );

    DelButton = new QPushButton( LayersFrame, "Delete Button" );
    addButton( DelButton, 0, 60, 55, 25 , "Del" );
    connect  ( DelButton,  SIGNAL(clicked()), this, SLOT( delLayer())  );

    //this is now printbutton
    SceneButton = new QPushButton( LayersFrame, "NameButton" );
    addButton( SceneButton, 0, 100, 55, 25, "Data" );
    connect  ( SceneButton,  SIGNAL(clicked()), this, SLOT( printScene())  );       // sceneSettings() now obsolete




    //////////////////////////////////////////////////////////////

    EffectsMain = new QWidgetStack(qtinterface);
    SceneFrame   = new QFrame(EffectsMain);
    EffectsFrame = new QFrame(EffectsMain);

    EffectsMain->addWidget(SceneFrame,0);
    EffectsMain->addWidget(EffectsFrame,1);
    EffectsMain->setGeometry( QRect( 0, 0, 855, 195) );

    EffectsStatus = FALSE; EffectsMain->raiseWidget(1);

    ////////////////// scene options
    LoadButton = new QPushButton( SceneFrame, "LoadButton" );
    addButton( LoadButton, 10, 10, 86, 25 , "Load" );
    connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

    SaveButton = new QPushButton( SceneFrame, "SaveButton" );
    addButton( SaveButton, 10, 45, 86, 25, "Save" );
    connect  ( SaveButton,  SIGNAL(clicked()), this, SLOT( SceneSave())  );

    ResetButton = new QPushButton( SceneFrame, "ResetButton" );
    addButton( ResetButton, 10, 80, 86, 25, "Reset" );
    connect  ( ResetButton,  SIGNAL(clicked()), this, SLOT( ResetAll())  );

//    ClearButton = new QPushButton( SceneFrame, "ResetButton" );
//    addButton( ClearButton, 10, 115, 86, 25, "Clear" );
//    connect( ClearButton,  SIGNAL(clicked()), this, SLOT( ClearAll())  );

    //these are checkboxes...
    SmoothSelect = new QCheckBox( SceneFrame, "SmoothSelect" );
    addCheckButton( SmoothSelect, 130, 10, 110, 21, "aliasing" );
    connect( SmoothSelect,  SIGNAL(clicked()), this, SLOT(setSmooth())  );

    BlurSelect = new QCheckBox( SceneFrame, "BlurSelect" );
    addCheckButton( BlurSelect, 130, 45, 110, 21, "motion blur" );
    connect( BlurSelect,  SIGNAL(clicked()), this, SLOT(setBlur())  );

    TextSelect = new QCheckBox( SceneFrame, "TitleSafe" );
    addCheckButton( TextSelect, 130, 80, 110, 21, "title safe" );
    connect( TextSelect,  SIGNAL(clicked()), this, SLOT(setTextSafe())  );

  //need to move this into the module
    //this is mandatory for all modules...

    sframetext = new QLabel( SceneFrame, "sframetext" );
    sframetext->setGeometry( QRect( 400, 4, 80, 27 ) );
    sframetext->setText( tr( "STARTFRAME" ) );
    sframetext->setAlignment( int( QLabel::AlignCenter ) );
    QFont sframetext_font(  sframetext->font() );
    sframetext_font.setPointSize( 9 );
    sframetext->setFont( sframetext_font );

    lcdstartframe = new InputLCD( SceneFrame, "startframe",9 );
	  addSliderLcd(lcdstartframe, 500, 5, 90, 21, Astartframe);
	  lcdstartframe->setMinMaxInt( Astartframe, Aendframe-1 );
    lcdstartframe->setValue(Astartframe);
	  connect( lcdstartframe, SIGNAL(valueChanged(int)),   SLOT(updatesliderStartframe(int)) );

    eframetext = new QLabel( SceneFrame, "eframetext" );
    eframetext->setGeometry( QRect( 400, 34, 80, 27 ) );
    eframetext->setText( tr( "ENDFRAME"  ) );
    eframetext->setAlignment( int( QLabel::AlignCenter ) );
    QFont eframetext_font(  eframetext->font() );
    eframetext_font.setPointSize( 9 );
    eframetext->setFont( eframetext_font );

//addSliderLcd(animframe, 5, 0, 90, 31, 100);
    lcdendframe = new InputLCD( SceneFrame, "endframe",9 );
	  addSliderLcd(lcdendframe, 500, 34, 90, 21, Aendframe);
	  lcdendframe->setMinMaxInt( Astartframe+1, MaxFrames );
    lcdendframe->setValue(Aendframe);
	  connect( lcdendframe, SIGNAL(valueChanged(int)),   SLOT(updatesliderEndframe(int)) );


    lv = new QListView( EffectsFrame );

    connect(lv, SIGNAL(clicked(QListViewItem*) ),
	    this, SLOT( clicked(QListViewItem*) ) );

    lv->setGeometry( QRect( 2, 2, 146, 180 ) );
    lv->addColumn( "LAYERS         ", -1 );

    lv->setSorting( -1,1 );   // disables the autosort

    //we need to create four sets of sliders now, one each for clip1, clip2, object and world
    //QHBox* fxoptionals_clipone = new QHBox(optionals_effects);

    ControlFrame_2 = new QFrame( EffectsFrame, "ControlFrame_2" );
    ControlFrame_2->setGeometry( QRect( 148, 1, 700, 180 ) );    // was 540

    fxoptionals = new QWidgetStack(ControlFrame_2);
    fxoptionals_clipone = new QHBox(fxoptionals);
    fxoptionals_cliptwo = new QHBox(fxoptionals);
    fxoptionals_object = new QHBox(fxoptionals);
    fxoptionals_world  = new QHBox(fxoptionals);
    fxoptionals_text  = new QHBox(fxoptionals);

    fxoptionals->addWidget(fxoptionals_clipone,0);
    fxoptionals->addWidget(fxoptionals_cliptwo,1);
    fxoptionals->addWidget(fxoptionals_object,2);
    fxoptionals->addWidget(fxoptionals_world,3);
    fxoptionals->addWidget(fxoptionals_text,4);
    fxoptionals->setGeometry( QRect( 0, 0, 700, 180) );   // was 635

    ///////////////////////////////////////////////////////////////////////
    //object one control set
    ControlFrame1 = new QFrame( fxoptionals_clipone, "ControlFrame1" );
    ControlFrame1->setGeometry( QRect( 0, 0, 760, 180 ) );    // was 510


    theeditdesktop = new EditDesktop( ControlFrame1, "editdesk" );
    theeditdesktop->setFixedSize( QSize( 980, 600 ) );    //was 955,486

    // raise backgound as default
    fxoptionals->raiseWidget(0);
 //   fxselect->raiseWidget(0);

}













