/*******************************************************************************
**
** The source file for the Jahshaka editing selections module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "edit.h"

void GLEdit::addLayer(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;


   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Graphic",7,0 );
    menu->insertItem( "Text",4,0 );
    menu->insertItem( "Layer",1,0 );
   //menu->insertItem( "Desktop",8,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {
      if (numberLayers==NUMBER_LAYERS) return;
      numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {
         case 1  : { layers[numberLayers].blend       = TRUE;           layers[numberLayers].depth = TRUE;
                     layers[numberLayers].filename = "Pixmaps/jahlayer"; layers[numberLayers].extension = ".bmp";
                     createLayer(numberLayers,"VidLayer"+layNum, LAYER, BACKDROP );
				     break; }

         case 4  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
                     layers[numberLayers].text->extrude = 20.0;
                     layers[numberLayers].text->fontstyle = FPOLYGON; //or FSOLID
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = TRUE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"3DText", TEXT, JAHTEXT);
                     break; }

         case 7  : { layers[numberLayers].blend       = TRUE;           layers[numberLayers].depth = TRUE;
                     layers[numberLayers].filename = "Pixmaps/jahlogo"; layers[numberLayers].extension = ".png";
                     createLayer(numberLayers,"Layer", LAYER, JAHLAYER );
				     break; }

         default  :  {  break; }
         //not functional yet, switches to desktop for a clip selection and returns
         //case 7  : { debug("Desktop");  break; }
      }
    } else { added = FALSE;}


    delete menu;


    if (added) {  addSelection(); objectMenu(numberLayers); updateSliders();

    //The is where we need to add a bar to editinterface

    theeditdesktop->addEditLayer(numberLayers,
                                 layers[numberLayers].videotex,
                                 layers[numberLayers].startframe , layers[numberLayers].endframe );

   }

}





void GLEdit::changeParticle() {


    ParticleCategory cat;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Atom",1,0 );
    menu->insertItem( "JetSpray",2,0 );
    menu->insertItem( "Waterfall",3,0 );
    menu->insertItem( "Rocket",4,0 );
    menu->insertItem( "Explosion",5,0 );
    menu->insertItem( "Swirl",6,0 );
    menu->insertItem( "Balloons",7,0 );
    menu->insertItem( "Shape",8,0 );
    menu->insertItem( "FireFlies",9,0 );
    menu->insertItem( "Shower",10,0 );
    menu->insertItem( "Fountain",11,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( loadimage_3->mapToGlobal( QPoint( 0, loadimage_3->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  :  cat = ATOMIC; break;
                case 2  :  cat = JETSPRAY; break;
                case 3  :  cat = WATERFALL; break;
                case 4  :  cat = ROCKET; break;
                case 5  :  cat = EXPLOSION; break;
                case 6  :  cat = SWIRL; break;
                case 7  :  cat = BALLOONS; break;
                case 8  :  cat = SHAPE; break;
                case 9  :  cat = FIREFLIES; break;
                case 10 :  cat = SHOWER; break;
                case 11 :  cat = FOUNTAIN; break;

      }
      layers[activeLayer].ParticleStyle=cat;
      layers[activeLayer].ParticleFirsttime=TRUE;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::changeFontDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Solid",1,0 );
    menu->insertItem( "Outline",2,0 );
    menu->insertItem( "3D",3,0 );
    //menu->insertItem( "Textured",4,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( textDraw->mapToGlobal( QPoint( 0, textDraw->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  :  layers[activeLayer].text->fontstyle = FPOLYGON;    break;
                case 2  :  layers[activeLayer].text->fontstyle = FOUTLINE;  break;
                case 3  :  layers[activeLayer].text->fontstyle = FEXTRUDE;  break;
             //   case 4  :  layers[activeLayer].text->fontstyle = FTEXTURED; break;
                default :                                                    break;
      }
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::changeObjectDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Plain",1,0 );
    menu->insertItem( "Color",2,0 );
    menu->insertItem( "Material",3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( objectstyle->mapToGlobal( QPoint( 0, objectstyle->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  :  layers[activeLayer].material_mode = 0; break;
                case 2  :  layers[activeLayer].material_mode = 1; break;
                case 3  :  layers[activeLayer].material_mode = 2; break;
                default :                                          break;
      }
    }

    delete menu;
    updateGL();  //redraw scene
}


void GLEdit::keyCliplayer() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_DST_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_COLOR",4,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  : { debug("clip: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("clip: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("clip: GL_DST_COLOR"); blendmode = GL_DST_COLOR; break; }
                case 4  : { debug("clip: GL_ONE_MINUS_DST_COLOR"); blendmode = GL_ONE_MINUS_DST_COLOR; break; }

      }
      layers[activeLayer].blendmode1=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::keyClipkey() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_SRC_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_COLOR",4,0 );
    menu->insertItem( "GL_SRC_ALPHA",5,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_ALPHA",6,0 );
    menu->insertItem( "GL_DST_ALPHA",7,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_ALPHA",8,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  : { debug("key: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("key: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("key: GL_SRC_COLOR"); blendmode = GL_SRC_COLOR; break; }
                case 4  : { debug("key: GL_ONE_MINUS_SRC_COLOR"); blendmode = GL_ONE_MINUS_SRC_COLOR; break; }
                case 5  : { debug("key: GL_SRC_ALPHA"); blendmode = GL_SRC_ALPHA; break; }
                case 6  : { debug("key: GL_ONE_MINUS_SRC_ALPHA"); blendmode = GL_ONE_MINUS_SRC_ALPHA; break; }
                case 7  : { debug("key: GL_DST_ALPHA"); blendmode = GL_DST_ALPHA; break; }
                case 8  : { debug("key: GL_ONE_MINUS_DST_ALPHA"); blendmode = GL_ONE_MINUS_DST_ALPHA; break; }
      }
      layers[activeLayer].blendmode2=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene

}












