/*******************************************************************************
**
** The source file for the Jahshaka effects objects module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "effect.h"


void GLEffect::doSwirl(void) {

	GLfloat xx, yy, R, angle;
	GLfloat lensX, lensY;

    GLfloat TwistEffect; TwistEffect =2.4;    // The amount of Twist
    //GLfloat LensEffect;  LensEffect  =0.4;    // The amount of lens effect (Magnification)
    GLfloat LensRadius;                       // Radius of the lens

    lensX      = layers[effectobj].node->tx ;     // get interactive settings       was effectobj
    lensY      = layers[effectobj].node->ty ;     // hardcoded to layer 2 for now needs to be fixed mon
    LensRadius = layers[effectobj].node->rx ;

	xx = -36.0;  yy = -31.0;

	for (int i = 0; i <= 72; i++) {

	   for (int j = 0; j <= 48; j++) {

		  //this one moves layer around, why?
		  R =sqrt(  ((xx-lensX)*(xx-lensX)) + ((yy-lensY)*(yy-lensY))  );  // Get the radius of the current point		
		  angle = atan2((yy-lensY),(xx-lensX));                // Get the angle at that point

		  // If we're inside the unit circle
		
			  if (R < LensRadius) { angle += ( (LensRadius -R)/10*TwistEffect); }
					
		  //set x and y coords in mesh
		  layers[0].setMeshCoord(i,j, (lensX + (R * ( cos(angle))  )) , (lensY + (R * ( sin(angle))  )) );
	
		  yy += 1.25;			

		}
		xx += 1.0;
		yy  = -31.0;
	}
}


void GLEffect::doFisheye(void) {

	GLfloat xx, yy, R, angle;
	GLfloat lensX, lensY;

    //GLfloat TwistEffect; TwistEffect =2.4;    // The amount of Twist
    GLfloat LensEffect;  LensEffect  =0.4;    // The amount of lens effect (Magnification)
    GLfloat LensRadius;                       // Radius of the lens

    lensX      = layers[effectobj].node->tx ;     // get interactive settings
    lensY      = layers[effectobj].node->ty ;     // hardcoded to layer 2 for now needs to be fixed mon
    LensRadius = layers[effectobj].node->rx ;

	xx = -36.0;  yy = -31.0;

	for (int i = 0; i <= 72; i++) {

	   for (int j = 0; j <= 48; j++) {

		  //this one moves layer around, why?
		  R =sqrt(  ((xx-lensX)*(xx-lensX)) + ((yy-lensY)*(yy-lensY))  );  // Get the radius of the current point	
		  angle = atan2((yy-lensY),(xx-lensX));                // Get the angle at that point

		  // If we're inside the unit circle
			  if (R < LensRadius) { R = LensRadius * exp ( log (R/LensRadius)*LensEffect ); }
					
		  //set x and y coords in mesh
		  layers[0].setMeshCoord(i,j, (lensX + (R * ( cos(angle))  )) , (lensY + (R * ( sin(angle))  )) );
	
		  yy += 1.25;			

		}
		xx += 1.0;
		yy  = -31.0;
	}

}


void GLEffect::doColorMatrix(void) {
    //all color ops in one routine!
	if (JAHDEBUG) debug("doing color matrix");

    glMatrixMode(GL_COLOR);
    glPushMatrix();          //???

    //contrast
	GLfloat ContrastR, ContrastG, ContrastB;

	if (JAHDEBUG) JahDebug("activelayer is",activeLayer);

	ContrastR = layers[activeLayer].node->tx/100;
	ContrastG = layers[activeLayer].node->ty/100;
	ContrastB = layers[activeLayer].node->tz/100;

    glScalef(ContrastR, ContrastG, ContrastB );

    //brightness
	GLfloat BrightR, BrightG, BrightB;
	BrightR = layers[activeLayer].node->rx/100;
	BrightG = layers[activeLayer].node->ry/100;
	BrightB = layers[activeLayer].node->rz/100;

    glTranslatef(BrightR, BrightG, BrightB );

    //saturation
	GLfloat saturation;

	saturation=layers[activeLayer].node->sx/100;

    GLfloat matrix[16];

    matrix[0]  = (1.0 - saturation ) * 0.3086 + saturation;
    matrix[1]  = (1.0 - saturation ) * 0.3086 ;
    matrix[2]  = (1.0 - saturation ) * 0.3086 ;
    matrix[3]  = 0.0 ;
    matrix[4]  = (1.0 - saturation ) * 0.6094 ;
    matrix[5]  = (1.0 - saturation ) * 0.6094 + saturation;
    matrix[6]  = (1.0 - saturation ) * 0.6094 ;
    matrix[7]  = 0.0 ;
    matrix[8]  = (1.0 - saturation ) * 0.0820 ;
    matrix[9]  = (1.0 - saturation ) * 0.0820 ;
    matrix[10] = (1.0 - saturation ) * 0.0820 + saturation;
    matrix[12] = 0.0 ;
    matrix[13] = 0.0 ;
    matrix[14] = 0.0 ;
    matrix[15] = 1.0 ;

    glMultMatrixf(matrix);

//if we can fix this code we are looking good here
//glPopMatrix();glMatrixMode(GL_MODELVIEW);


}

