/*******************************************************************************
**
** The source file for the Jahshaka animation selections module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/



#include "effect.h"


void GLEffect::addLayer(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...

   bool added = TRUE;
   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );
    menu->insertItem( "Swirl RT",10,0 );
    menu->insertItem( "Mirror",9,0 );
    menu->insertItem( "SwapRGB",8,0 );
    menu->insertItem( "ColorOps",7,0 );
    menu->insertItem( "Polar P",6,0 );
    menu->insertItem( "RadiaLines P",5,0 );
    menu->insertItem( "FishEye RT",4,0 );
    menu->insertItem( "Edge",3,0 );
    menu->insertItem( "Grey",2,0 );
    menu->insertItem( "Negative",1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {
      if (numberLayers==NUMBER_LAYERS) return;
      numberLayers+=1; layNum.setNum(numberLayers);


					 layers[numberLayers].layernumber = numberLayers;
                     layers[numberLayers].layertype = LAYER; //effect!

      switch(id) {
         case 1  : {

					
					 effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Negative";
                     effects[numberLayers].objtype = NEGATIVE;

                     break; }

         case 2  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Grey";
                     effects[numberLayers].objtype = GREY;

                     break; }

         case 3  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Edge";
                     effects[numberLayers].objtype = EDGE;

                     break; }

         case 4  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" FishEye RT";
                     layers[0].objtype = MESHLAYER;
					           effects[numberLayers].objtype = FISHEYE;
                     effects[numberLayers].r=100;

                     break; }

         case 5  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Radialines";
                     effects[numberLayers].objtype = RADIALINES;
                     effects[numberLayers].r=100;

                     break; }

         case 6  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Polar";
                     effects[numberLayers].objtype = POLAR;

                     break; }

         case 7  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" ColorOps";
                     effects[numberLayers].objtype = COLORMATRIX;

                     break; }

         case 8  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" SwapRGB";
                     effects[numberLayers].objtype = SWAPRGB;

                     break; }

         case 9  : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Mirror";
                     effects[numberLayers].objtype = MIRROR;
                     break; }

         case 10 : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Swirl RT";
                     layers[0].objtype = MESHLAYER;
					           effects[numberLayers].objtype = SWIRLRT;
                     break; }

         case 11 : { effects[numberLayers].effectnumber = numberLayers; layers[numberLayers].layername = layNum+" Sharpen";
                     effects[numberLayers].objtype = SHARPEN;

                     break; }

         default  :  { break; }
      }
    }  else { added = FALSE; }

    delete menu;

    if (added) { addSelection(); }

}




void GLEffect::keyCliplayer() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_DST_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_COLOR",4,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  : { debug("clip: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("clip: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("clip: GL_DST_COLOR"); blendmode = GL_DST_COLOR; break; }
                case 4  : { debug("clip: GL_ONE_MINUS_DST_COLOR"); blendmode = GL_ONE_MINUS_DST_COLOR; break; }

      }
      layers[activeLayer].blendmode1=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEffect::keyClipkey() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_SRC_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_COLOR",4,0 );
    menu->insertItem( "GL_SRC_ALPHA",5,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_ALPHA",6,0 );
    menu->insertItem( "GL_DST_ALPHA",7,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_ALPHA",8,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 1  : { debug("key: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("key: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("key: GL_SRC_COLOR"); blendmode = GL_SRC_COLOR; break; }
                case 4  : { debug("key: GL_ONE_MINUS_SRC_COLOR"); blendmode = GL_ONE_MINUS_SRC_COLOR; break; }
                case 5  : { debug("key: GL_SRC_ALPHA"); blendmode = GL_SRC_ALPHA; break; }
                case 6  : { debug("key: GL_ONE_MINUS_SRC_ALPHA"); blendmode = GL_ONE_MINUS_SRC_ALPHA; break; }
                case 7  : { debug("key: GL_DST_ALPHA"); blendmode = GL_DST_ALPHA; break; }
                case 8  : { debug("key: GL_ONE_MINUS_DST_ALPHA"); blendmode = GL_ONE_MINUS_DST_ALPHA; break; }
      }
      layers[activeLayer].blendmode2=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene

}

















