/*******************************************************************************
**
** The source file for the Jahshaka animation interface module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "paint.h"

#include "Pixmaps/light.xpm"

void GLPaint::buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller) {

   //////////////////////////////////////////////////////////////
   // This is to be overridden...
    //left menu here
    glworldLeft = new QFrame (leftcontroller, "gl left");
    //glworldLeft->setFixedSize( QSize( 30, 300 ) );

    tooltranslate = new QPushButton( ( QIconSet( QPixmap("Pixmaps/buttonPen.png"), QPixmap("Pixmaps/buttonPen.png") )) ,"", glworldLeft, "play" );
    tooltranslate->setGeometry( QRect( 0, 205, 30, 27 ) );
    tooltranslate->setFlat(true);

    toolrotate = new QPushButton( ( QIconSet( QPixmap("Pixmaps/buttonLine.png"), QPixmap("Pixmaps/buttonLine.png") )) ,"", glworldLeft, "rotate" );
    toolrotate->setGeometry( QRect( 0, 233, 30, 27 ) );
    toolrotate->setFlat(true);

    toolscale = new QPushButton( ( QIconSet( QPixmap("Pixmaps/delete.xpm"), QPixmap("Pixmaps/delete.xpm") )) ,"", glworldLeft, "scale" );
    toolscale->setGeometry( QRect( 0, 263, 30, 27 ) );
    toolscale->setFlat(true);

    //rightmenu here
    glworldRight =  new QFrame (rightcontroller, "gl right" );
   // glworldRight->setFixedSize( QSize( 30, 300 ) );

    toolzoomin = new QPushButton( ( QIconSet( QPixmap("Pixmaps/zoomin.xpm"), QPixmap("Pixmaps/zoomin.xpm") )) ,"", glworldRight, "zoomin" );
    toolzoomin->setGeometry( QRect( 0, 115, 30, 27 ) );
    toolzoomin->setFlat(true);

    zoom = new QSlider( glworldRight, "scrubslider" );
    zoom->setStyle( new QPlatinumStyle );
    zoom->setGeometry( QRect( 0, 150, 30, 200 ) );
    zoom->setOrientation( QSlider::Vertical );
    zoom->setMinValue( -10 );    zoom->setMaxValue( 10 );    zoom->setValue   ( 0 );

    toolzoomout = new QPushButton( ( QIconSet( QPixmap("Pixmaps/zoomout.xpm"), QPixmap("Pixmaps/zoomout.xpm") )) ,"", glworldRight, "zoomout" );
    toolzoomout->setGeometry( QRect( 0, 355, 30, 27 ) );
    toolzoomout->setFlat(true);

	  //connect tools to object and add object to display widget
    //note that zoom isnt hooked up yet...
    connect( tooltranslate,  SIGNAL(clicked()), this, SLOT(slotPen() )  );
    connect( toolrotate,      SIGNAL(clicked()), this, SLOT(slotLine() )  );
    //connect( toolscale ,     SIGNAL(clicked()), this, SLOT(toolRotate() )  );

}

void GLPaint::buildInterface( QHBox* qtinterface ) {

  ///////////////////////////////////////////////////////////
  //The layers interface
  LayersFrame = new QFrame( qtinterface, "EffectsFrame" );
  LayersFrame->setGeometry( QRect( 0, 0, 60, 195 ) );
  LayersFrame->setMinimumSize( QSize( 60, 195 ) );  //was 960
  LayersFrame->setMaximumSize( QSize( 60, 195 ) );

  ///////////////////////////////////////////////////////////
  //The layer options
  AddButton = new QPushButton( LayersFrame, "AddButton" );
  addButton( AddButton,  0, 5, 55, 25,  "Add" );
  connect  ( AddButton,  SIGNAL(clicked()), this, SLOT( addLayer())  );

  NameButton = new QPushButton( LayersFrame, "NameButton" );
  addButton( NameButton, 0, 30, 55, 25, "Name" );
  connect  ( NameButton,  SIGNAL(clicked()), this, SLOT( nameLayer())  );

  namepopup = new FancyPopup( this, "Enter Layer Name",200,100 );  //send size and position as well
  connect ( namepopup,      SIGNAL( returnText(QString)), SLOT( setlayerName(QString)) );

  DelButton = new QPushButton( LayersFrame, "Delete Button" );
  addButton( DelButton, 0, 60, 55, 25 , "Del" );
  connect  ( DelButton,  SIGNAL(clicked()), this, SLOT( delLayer())  );

  //this is now printbutton
  //SceneButton = new QPushButton( LayersFrame, "Scene" );
  //addButton( SceneButton, 0, 100, 55, 25, "Scene" );
  //connect  ( SceneButton,  SIGNAL(clicked()), this, SLOT( toggleScene())  );       // sceneSettings() now obsolete


  //////////////////////////////////////////////////////////////
  // set up the scene options, or prefernces
  EffectsMain = new QWidgetStack(qtinterface);
  SceneFrame   = new QFrame(EffectsMain);
  EffectsFrame = new QFrame(EffectsMain);

  EffectsMain->addWidget(SceneFrame,0);
  EffectsMain->addWidget(EffectsFrame,1);
  EffectsMain->setGeometry( QRect( 0, 0, 855, 195) );

  EffectsStatus = FALSE; EffectsMain->raiseWidget(1);

  /////////////////////////////////////////////////////////
  //this is the list-view
  lv = new QListView( EffectsFrame );

  connect( lv, SIGNAL( clicked( QListViewItem* ) ), this, SLOT( clicked( QListViewItem* ) ) );

  lv->setGeometry( QRect( 2, 2, 146, 180 ) );
  lv->addColumn( "LAYERS         ", -1 );
  lv->setSorting( -1,1 );   // disables the autosort


	//////////////////////////////////////////////////////////
  // set up options here

  controlpanel = new QWidgetStack(EffectsFrame);

  //this may need to be QHBox as it is below...
  scene_controls  = new QFrame(controlpanel);     controlpanel->addWidget(scene_controls,0);
  object_controls = new QFrame(controlpanel);     controlpanel->addWidget(object_controls,1);
  	
  controlpanel->setGeometry( QRect( 148, 0, 700, 180) );

  /////////////////////////////////////////////////////////
  //Set up scene interface

  sceneframe = new QFrame( scene_controls, "scenecontrols" );
  sceneframe->setGeometry( QRect( 1, 1, 700, 180 ) );
  sceneframe->setStyle( new QPlatinumStyle );

  //fxobject->setGeometry( QRect( 0, 0, 700, 120) );   // was 635
  /*
  LoadButton = new QPushButton( sceneframe, "LoadButton" );
  addButton( LoadButton, 10, 10, 86, 25 , "Load" );
  connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

  // clean up this mess here!
  */

  /////////////////////////////////////////////////////////
  //Set up tabbed interface

  // tabframe = new QTabWidget( EffectsFrame, "axiscontrols" );
  tabframe = new QTabWidget( object_controls, "axiscontrols" );
  tabframe->setGeometry( QRect( 1, 1, 700, 180 ) );
  tabframe->setTabShape( QTabWidget::Triangular );
  tabframe->setAutoMask( FALSE );
  tabframe->setStyle( new QPlatinumStyle );

  objectcontrols = new QWidget( EffectsFrame, "objectcontrols" );
  tabframe->insertTab( objectcontrols, tr( "  SCENE  " ) );

  effectscontrols = new QWidget( EffectsFrame, "effectscontrols" );
  tabframe->insertTab( effectscontrols, tr( "  TOOLS  " ) );

  brushcontrols = new QWidget( EffectsFrame, "brushcontrols" );
  tabframe->insertTab( brushcontrols, tr( "  COLOR  " ) );

  //this has become the settings panel need to update variable names
  scenecontrols = new QWidget( EffectsFrame, "scenesettings" );
  tabframe->insertTab( scenecontrols, tr( "  EFFECTS  " ) );

  axiscontrols = new QWidget( EffectsFrame, "axiscontrols" );
  tabframe->insertTab( axiscontrols, tr( "  LAYERS  " ) );

  texturecontrols = new QWidget( EffectsFrame, "texturecontrols" );
  tabframe->insertTab( texturecontrols, tr( "    CONTROLS    " ) );




  /////////////////////////////////////////////////////////////////////
  // the layout boxes for different types of layers
  // these should be changed and regroups to represent tabs above
  // these should be arrays

  // the axis control tab bar
  // this is just really world and layer now
  // we can get rid of the rest

  fxaxis = new QWidgetStack(axiscontrols);

  fxaxis_clipone = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_clipone,0);
  fxaxis_cliptwo = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_cliptwo,1);
  fxaxis_object  = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_object, 2);
  fxaxis_world   = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_world,  3);
  fxaxis_text    = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_text,   4);

  fxaxis->setGeometry( QRect( 0, 0, 700, 120) );


  ///////////////////////////////////////////////////////////////////
  // the object control tab bar
  // this is the object control panel

  fxobject = new QWidgetStack(objectcontrols);

  fxobject_clip     = new QHBox(fxobject);          fxobject->addWidget(fxobject_clip,    0);
  fxobject_text     = new QHBox(fxobject);          fxobject->addWidget(fxobject_text,    1);
  fxobject_world    = new QHBox(fxobject);          fxobject->addWidget(fxobject_world,   2);
  fxobject_key      = new QHBox(fxobject);          fxobject->addWidget(fxobject_key,     3);
  fxobject_particle = new QHBox(fxobject);          fxobject->addWidget(fxobject_particle,4);
  fxobject_object   = new QHBox(fxobject);          fxobject->addWidget(fxobject_object,  5);
  fxobject_maxobject= new QHBox(fxobject);          fxobject->addWidget(fxobject_maxobject,  6);

  fxobject->setGeometry( QRect( 0, 0, 700, 120) );   // was 635

  QPalette p( QColor( 0, 0, 0 ) );
  p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

	///////////////////////////////////////////////////////////
	//Tool control panel

  ControlFrame1 = new QFrame( effectscontrols, "ControlFrame1" );
  ControlFrame1->setGeometry( QRect( 0, 0, 660, 120 ) );    // was 510

	//standard tools are here
  ControlFrame1L1 = new QLabel( ControlFrame1, "brushslider" );
  addLabel( ControlFrame1L1, 10, 1, 150, 10, "DRAW OBJECTS", 9);

//these were toolbuttons not pushbuttons so we could see what was selected
	ControlFrame1B1	= new QPushButton(ControlFrame1,"brush");
	addIconButton(ControlFrame1B1, 10, 20, 22, 22, "Pixmaps/buttonPen.png");
  connect( ControlFrame1B1,  SIGNAL(clicked()), this, SLOT(slotPen())  );

	ControlFrame1B2	= new QPushButton(ControlFrame1,"line");
	addIconButton(ControlFrame1B2, 35, 20, 22, 22, "Pixmaps/buttonLine.png");
  connect( ControlFrame1B2,  SIGNAL(clicked()), this, SLOT(slotLine())  );

	ControlFrame1B3	= new QPushButton(ControlFrame1,"square");
	addIconButton(ControlFrame1B3, 70, 20, 22, 22, "Pixmaps/buttonRectangle.png");
  connect( ControlFrame1B3,  SIGNAL(clicked()), this, SLOT(slotRectangle())  );

	ControlFrame1B4	= new QPushButton(ControlFrame1,"square");
	addIconButton(ControlFrame1B4, 95, 20, 22, 22, "Pixmaps/buttonRectangleFilled.png");
  connect( ControlFrame1B4,  SIGNAL(clicked()), this, SLOT(slotRectangleFilled())  );

	ControlFrame1B5	= new QPushButton(ControlFrame1,"triangle");
	addIconButton(ControlFrame1B5, 130, 20, 22, 22, "Pixmaps/buttonTriangle.png");
    connect( ControlFrame1B5,  SIGNAL(clicked()), this, SLOT(slotTriangle())  );

	ControlFrame1B6	= new QPushButton(ControlFrame1,"triangle");
	addIconButton(ControlFrame1B6, 155, 20, 22, 22, "Pixmaps/buttonTriangleFilled.png");
    connect( ControlFrame1B6,  SIGNAL(clicked()), this, SLOT(slotTriangleFilled())  );

	ControlFrame1B7	= new QPushButton(ControlFrame1,"circle");
	addIconButton(ControlFrame1B7, 190, 20, 22, 22, "Pixmaps/buttonCircle.png");
    connect( ControlFrame1B7,  SIGNAL(clicked()), this, SLOT(slotCircle())  );

	ControlFrame1B8	= new QPushButton(ControlFrame1,"circle");
	addIconButton(ControlFrame1B8, 215, 20, 22, 22, "Pixmaps/buttonCircleFilled.png");
    connect( ControlFrame1B8,  SIGNAL(clicked()), this, SLOT(slotCircleFilled())  );

	// the undo and redo buttons are here
	ControlFrame1B9	= new QPushButton(ControlFrame1,"undo");
	addIconButton(ControlFrame1B9, 400, 20, 22, 22, "Pixmaps/buttonHistoryPrevious.png");
  connect( ControlFrame1B9,  SIGNAL(clicked()), this, SLOT(slotHistoryPrevious())  );

	ControlFrame1B10	= new QPushButton(ControlFrame1,"redo");
	addIconButton(ControlFrame1B10, 425, 20, 22, 22, "Pixmaps/buttonHistoryNext.png");
  connect( ControlFrame1B10,  SIGNAL(clicked()), this, SLOT(slotHistoryNext())  );


	//////////////////////////////////////////////////////
	// Brushes
    ControlFrame1L2 = new QLabel( ControlFrame1, "brushslider" );
    addLabel( ControlFrame1L2, 10, 55, 150, 10, "BRUSHES", 9);

	//dynamic brush size slider
    ControlFrame1L3 = new QLabel( ControlFrame1, "brushslider" );
    addLabel( ControlFrame1L3, 400, 70, 150, 22, "BRUSH SIZE", 9);

    ControlFrame1S1 = new QSlider( ControlFrame1 );   ControlFrame1S1Lcd = new InputLCD( ControlFrame1 );
    addSliderAndLcd(  ControlFrame1S1, 400, 90, 150, 21,  1, 50, ControlFrame1S1Lcd );
	ControlFrame1S1->setTickInterval(2); ControlFrame1S1->setTickmarks(QSlider::Below);
    connect( ControlFrame1S1, SIGNAL(valueChanged(int)), this, SLOT(slotBrushSize(int)) );
    connect( ControlFrame1S1, SIGNAL(valueChanged(int)), ControlFrame1S1Lcd, SLOT(display(int)) );
	connect(ControlFrame1S1Lcd, SIGNAL(valueChanged(int)), this, SLOT(slotBrushSize(int)) );


    ///////////////////////////////////////////////////////////////
    // texture layer options
	// need to add video-texture options here

	//image options

    ControlFrame2 = new QFrame( texturecontrols, "ControlFrame5" );
    ControlFrame2->setGeometry( QRect( 0, 0, 660, 120 ) );


	// video options
	// need to hook this up now...

    VideoLabel = new QLabel( ControlFrame2, "TranslateText_1" );
    addLabel( VideoLabel, 380, 10, 110, 21, "VIDEO OPTIONS", 9);


    FramesLcd = new InputLCD( ControlFrame2 );
    addLabelLcd( ControlFrame2, FramesLcd,       380, 30, 60, 21,  0,  "Frames", 8);

    inFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, inFramesLcd,     460, 30, 30, 21,  0,  "In", 8);
	connect(inFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setinFrames(int)) );

	outFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, outFramesLcd,    530, 30, 30, 21,  0,  "Out", 8);
	connect(outFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setoutFrames(int)) );

    KeyFramesLcd = new InputLCD( ControlFrame2 );
    addLabelLcd( ControlFrame2, KeyFramesLcd,    380, 75, 60, 21,  0,  "Frames", 8);

    inKeyFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, inKeyFramesLcd,  460, 75, 30, 21,  0,  "In", 8);
	connect(inKeyFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setinKeyFrames(int)) );

	outKeyFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, outKeyFramesLcd, 530, 75, 30, 21,  0,  "Out", 8);
	connect(outKeyFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setoutKeyFrames(int)) );

    //need to make the icon a lock... 3x current height as well for links
  	lockicon	= new QToolButton(ControlFrame2,"lockicon");
    lockicon->setGeometry( QRect( 600, 55, 18, 26 ) );
  	lockicon->setFixedSize(18, 26);  	//lighticon->setUsesBigPixmap(true);
  	lockicon->setAutoRaise(true);

  	QIconSet	*icoSet2;
    	icoSet2 = new QIconSet(QPixmap((const char**)light_xpm) );
    	icoSet2->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Active);
    	icoSet2->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Disabled);
    	lockicon->setIconSet(*icoSet2);
    delete icoSet2;

    ///////////////////////////////////////////////////////////////////////
    //set up world control set

    ControlFrame3 = new QFrame( fxobject_world, "ControlFrame3" );
    ControlFrame3->setGeometry( QRect( 0, 0, 660, 120 ) );

    LoadButton = new QPushButton( ControlFrame3, "LoadButton" );
    addButton( LoadButton, 10, 10, 86, 25 , "Load" );
    connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

    SaveButton = new QPushButton( ControlFrame3, "SaveButton" );
    addButton( SaveButton, 10, 45, 86, 25, "Save" );
    connect  ( SaveButton,  SIGNAL(clicked()), this, SLOT( SceneSave())  );

    ResetButton = new QPushButton( ControlFrame3, "ResetButton" );
    addButton( ResetButton, 10, 80, 86, 25, "Reset" );
    connect  ( ResetButton,  SIGNAL(clicked()), this, SLOT( ResetAll())  );

    ClearButton = new QPushButton( ControlFrame3, "ClearButton" );
    addButton( ClearButton, 110, 10, 86, 25, "Clear" );
    connect( ClearButton,  SIGNAL(clicked()), this, SLOT( ClearAll())  );

    TextSelect = new QCheckBox( ControlFrame3, "TitleSafe" );
    addCheckButton( TextSelect, 300, 80, 110, 21, "title safe" );
    connect( TextSelect,  SIGNAL(clicked()), this, SLOT(setTextSafe())  );

	///////////////////////////////////////////////////////////
	//color control panel

    ControlFrame4 = new QFrame( brushcontrols, "ControlFrame4" );
    ControlFrame4->setGeometry( QRect( 0, 0, 660, 120 ) );    // was 510



    ControlFrame4L1 = new QLabel( ControlFrame4, "gradientslider" );
    addLabel( ControlFrame4L1, 10, 10, 90, 22, "BACKGROUND", 9);

  ControlFrame4B1	= new QPushButton(ControlFrame4,"backgroundcolor");
  addIconButton(ControlFrame4B1, 100, 10, 40, 22 );
  ControlFrame4B1->setPaletteBackgroundColor( QColor(5,38,10) );
  connect( ControlFrame4B1,  SIGNAL(clicked()), this, SLOT(slotBackgroundColor())  );

  ControlFrame4L2 = new QLabel( ControlFrame4, "gradientslider" );
  addLabel( ControlFrame4L2, 10, 40, 90, 22, "PEN", 9);

  ControlFrame4B2	= new QPushButton(ControlFrame4,"pencolor");
  addIconButton(ControlFrame4B2, 100, 40, 40, 22 );
  ControlFrame4B2->setPaletteBackgroundColor( QColor(0,58,140) );
  connect( ControlFrame4B2,  SIGNAL(clicked()), this, SLOT(slotPenColor())  );

  ControlFrame4L3 = new QLabel( ControlFrame4, "gradientslider" );
  addLabel( ControlFrame4L3, 10, 70, 90, 22, "FILL", 9);

  ControlFrame4B3	= new QPushButton(ControlFrame4,"fillcolor");
  addIconButton(ControlFrame4B3, 100, 70, 40, 22 );
  ControlFrame4B3->setPaletteBackgroundColor( QColor(0,97,140) );
  connect( ControlFrame4B3,  SIGNAL(clicked()), this, SLOT(slotFillColor())  );


  //dynamic brush size slider change to a dial...
  ControlFrame4L2 = new QLabel( ControlFrame4, "gradientslider" );
  addLabel( ControlFrame4L2, 300, 40, 150, 22, "GRADIENT ANGLE", 9);

  ControlFrame4S2 = new QSlider( ControlFrame4 );   ControlFrame4S2Lcd = new InputLCD( ControlFrame4 );
  addSliderAndLcd(  ControlFrame4S2, 300, 60, 150, 21,  -255, 255, ControlFrame4S2Lcd );
  ControlFrame4S2->setTickInterval(25); ControlFrame4S2->setTickmarks(QSlider::Below);
  connect( ControlFrame4S2, SIGNAL(valueChanged(int)), this, SLOT(slotGradientDegree(int)) );
  connect( ControlFrame4S2, SIGNAL(valueChanged(int)), ControlFrame4S2Lcd, SLOT(display(int)) );
  connect(ControlFrame4S2Lcd, SIGNAL(valueChanged(int)), this, SLOT(slotGradientDegree(int)) );

 //paint brushes
   /*paintbrush1 = new QPushButton( effectscontrols, "brush1" );
    paintbrush1->setGeometry( QRect( 10, 15, 80, 25 ) );
    paintbrush1->setText( tr( "Brush"  ) );
    connect( paintbrush1,  SIGNAL(clicked()), this, SLOT(slotAlphaBrush())  );

    paintbrush2 = new QPushButton( effectscontrols, "brush2" );
    paintbrush2->setGeometry( QRect( 100, 15, 80, 25 ) );
    paintbrush2->setText( tr( "Pencil"  ) );
    connect( paintbrush2,  SIGNAL(clicked()), this, SLOT(slotBitBrush())  );

    //paint clips
    //paintBWidth = new QSpinBox( 1, 20, 1, tools );   add some defaults for the spinbox ie no negatives etc
    paintclip1 = new QPushButton( effectscontrols, "clip1" );
    paintclip1->setGeometry( QRect( 10, 55, 80, 25 ) );
    paintclip1->setText( tr( "clip one"  ) );
    connect( paintclip1,  SIGNAL(clicked()), this, SLOT(slotClipOne())  );

    paintclip1grab = new QPushButton( effectscontrols, "clip1grab" );
    paintclip1grab->setGeometry( QRect( 100, 55, 80, 25 ) );
    paintclip1grab->setText( tr( "load"  ) );
    connect( paintclip1grab,  SIGNAL(clicked()), this, SLOT(slotClipOneGrab())  );

    paintclip2 = new QPushButton( effectscontrols, "clip2" );
    paintclip2->setGeometry( QRect( 10, 85, 80, 25 ) );
    paintclip2->setText( tr( "clip two"  ) );
    connect( paintclip2,  SIGNAL(clicked()), this, SLOT(slotClipTwo())  );

    paintclip2grab = new QPushButton( effectscontrols, "clip2grab" );
    paintclip2grab->setGeometry( QRect( 100, 85, 80, 25 ) );
    paintclip2grab->setText( tr( "load"  ) );
    connect( paintclip2grab,  SIGNAL(clicked()), this, SLOT(slotClipTwoGrab())  );

    paintcolor = new QPushButton( effectscontrols, "color" );
    paintcolor->setGeometry( QRect( 290, 15, 86, 25 ) );
    paintcolor->setText( tr( "color"  ) );
    connect( paintcolor,  SIGNAL(clicked()), this, SLOT(slotSetColor())  );
*/

  /////////////////////////////////////////////////////////////////////////////
  //world control sliders


  ///////////////////////////////////////////////////////////////
  // object layer options
  ControlFrame5 = new QFrame( fxobject_clip, "ControlFrame5" );
  ControlFrame5->setGeometry( QRect( 0, 0, 660, 120 ) );


  Transparency_1 = new QLabel( ControlFrame5, "ScaleText_2" );
  addLabel( Transparency_1, 400, 5, 110, 21, "TRANSPARENCY", 9);
  Trans_1 = new QSlider( ControlFrame5 );  Translcd_1 = new InputLCD( ControlFrame5 );
  addSliderLcdLabel( ControlFrame5, Trans_1,   400, 25, 10, 21,  1, 100,    Translcd_1,  "T", 9);
  connect( Trans_1,    SIGNAL(valueChanged(int)), Translcd_1, SLOT(display(int)) );
  connect( Trans_1,    SIGNAL(valueChanged(int)), this, SLOT(setAlpha(int)) );
  connect( Translcd_1, SIGNAL(valueChanged(int)), this, SLOT(setAlpha(int)) );


  ControlFrame5B1	= new QPushButton(ControlFrame5,"fillcolor");
  addButton(ControlFrame5B1, 10, 10, 45, 32, "Clear" );
  connect( ControlFrame5B1,  SIGNAL(clicked()), this, SLOT(slotClear())  );


  /////////////////font options
  ControlFrame6 = new QFrame( fxobject_text, "ControlFrame4" );
  ControlFrame6->setGeometry( QRect( 0, 0, 40, 120 ) );

  ScaleText_5 = new QLabel( ControlFrame6, "ScaleText_4" );
  addLabel( ScaleText_5, 0, 10, 110, 21, "EXTRUDE", 9);

  ScaleX_5 = new QSlider( ControlFrame6 ); ScaleXlcd_5 = new InputLCD( ControlFrame6 );
  addSliderLcdLabel( ControlFrame6, ScaleX_5,   0, 30, 110, 21,  1, 200,  30,  ScaleXlcd_5,  "E", 9);
  connect( ScaleX_5,    SIGNAL(valueChanged(int)), ScaleXlcd_5, SLOT(display(int)) );
  connect( ScaleX_5,    SIGNAL(valueChanged(int)), this, SLOT(setExtrude(int)) );
  connect( ScaleXlcd_5, SIGNAL(valueChanged(int)), this, SLOT(setExtrude(int)) );

  textDraw = new QPushButton( ControlFrame6, "draw" );
  addButton( textDraw, 115, 30, 36, 21, "Draw" );
  connect( textDraw,  SIGNAL(clicked()), this, SLOT(changeFontDraw())  );

  textEd	= new QLineEdit( ControlFrame6, "text" );
  textEd->setGeometry( QRect( 0, 60, 150, 21 ) );
  textEd->setFocus();    textEd->setText( "jahshaka" );
  connect( textEd, SIGNAL(textChanged(const QString&)), this, SLOT(setText(const QString&)) );

  textFont = new QPushButton( ControlFrame6, "font" );
  addButton( textFont, 0, 90, 55, 21, "Font" );
  connect( textFont,  SIGNAL(clicked()), this, SLOT(loadFont())  );

  textColor = new QPushButton( ControlFrame6, "color" );
  addButton( textColor, 60, 90, 55, 21, "Color" );
  connect( textColor,  SIGNAL(clicked()), this, SLOT(setFontColor())  );

  ///////////////////////////////////////////////////////////////////
  // the scene control tab bar noe effects?

  //add the layer reset button here as well
  ControlFrame7 = new QFrame( scenecontrols, "ControlFrame4" );
  ControlFrame7->setGeometry( QRect( 0, 0, 660, 180 ) );

  //column one
  effectInvert = new QPushButton( ControlFrame7, "invert" );
  addButton( effectInvert, 10, 10, 100, 21, "Invert" );
  connect( effectInvert,  SIGNAL(clicked()), this, SLOT(slotInvert())  );

  effectBlur = new QPushButton( ControlFrame7, "blur" );
  addButton( effectBlur, 10, 40, 100, 21, "Blur" );
  connect( effectBlur,  SIGNAL(clicked()), this, SLOT(slotBlur())  );

  effectSharpen = new QPushButton( ControlFrame7, "sharpen" );
  addButton( effectSharpen, 10, 70, 100, 21, "Sharpen" );
  connect( effectSharpen,  SIGNAL(clicked()), this, SLOT(slotSharpen())  );

  //column 2
  effectFade = new QPushButton( ControlFrame7, "fade" );         //these need a slider as well
  addButton( effectFade, 150, 10, 100, 21, "Fade" );
  connect( effectFade,  SIGNAL(clicked()), this, SLOT(fade())  );

  effectIntensify = new QPushButton( ControlFrame7, "intensify" );     //these need a slider as well
  addButton( effectIntensify, 150, 40, 100, 21, "Intensify" );
  connect( effectIntensify,  SIGNAL(clicked()), this, SLOT(intensify())  );

  //add slider here

  //column three
  effectEdgeX = new QPushButton( ControlFrame7, "edgex" );
  addButton( effectEdgeX, 280, 10, 100, 21, "Edge detectX" );
  connect( effectEdgeX,  SIGNAL(clicked()), this, SLOT(slotEdgeDetectX())  );

  effectEdgeY = new QPushButton( ControlFrame7, "edgey" );
  addButton( effectEdgeY, 280, 40, 100, 21, "Edge detectY" );
  connect( effectEdgeY,  SIGNAL(clicked()), this, SLOT(slotEdgeDetectY())  );

  //column four
  effectSobel = new QPushButton( ControlFrame7, "sobel" );
  addButton( effectSobel, 500, 10, 100, 21, "Sobel" );
  connect( effectSobel,  SIGNAL(clicked()), this, SLOT(slotSobel())  );

  effectLapacian = new QPushButton( ControlFrame7, "lapacian" );
  addButton( effectLapacian, 500, 40, 100, 21, "Lapacian" );
  connect( effectLapacian,  SIGNAL(clicked()), this, SLOT(slotLaplacian())  );

  effectLapacian2 = new QPushButton( ControlFrame7, "lapacian2" );
  addButton( effectLapacian2, 500, 70, 100, 21, "Lapacian2" );
  connect( effectLapacian2,  SIGNAL(clicked()), this, SLOT(slotLaplacian2())  );

  effectGauss = new QPushButton( ControlFrame7, "gaussian" );
  addButton( effectGauss, 500, 70, 100, 21, "Gaussian" );
  connect( effectGauss,  SIGNAL(clicked()), this, SLOT(slotLapOfGauss())  );


    ///////////////////////////////////////////////////////////////////////
    //set up object control set and sliders

    ControlFrame8 = new QFrame( fxaxis_clipone, "ControlFrame1" );
    ControlFrame8->setGeometry( QRect( 0, 0, 660, 120 ) );    // was 510

   // set up rotate sliders

	
    RotateText_1 = new QLabel( ControlFrame8, "RotateText_1" );
    addLabel( RotateText_1, 10, 10, 110, 21, "ROTATE", 9);

    RotX_1 = new QSlider( ControlFrame8 );   RotXlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, RotX_1, 0, 30, 10, 21,  100, RotXlcd_1,  "X", 9);
    connect( RotX_1, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );
    connect( RotX_1, SIGNAL(valueChanged(int)), RotXlcd_1, SLOT(display(int)) );
	  connect(RotXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );

    RotY_1 = new QSlider( ControlFrame8 );   RotYlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, RotY_1, 0, 60, 10, 21,  100, RotYlcd_1,  "Y", 9);
    connect( RotY_1, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );
    connect( RotY_1, SIGNAL(valueChanged(int)), RotYlcd_1, SLOT(display(int)) );
	  connect(RotYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );

    RotZ_1 = new QSlider( ControlFrame8 );   RotZlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, RotZ_1, 0, 90, 10, 21,  100, RotZlcd_1,  "Z", 9);
    connect( RotZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)) );
    connect( RotZ_1, SIGNAL(valueChanged(int)), RotZlcd_1, SLOT(display(int)) );
	  connect(RotZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)) );


    // set up translate sliders
    TranslateText_1 = new QLabel( ControlFrame8, "TranslateText_1" );
    addLabel( TranslateText_1, 180, 10, 110, 21, "TRANSLATE", 9);

    TranX_1 = new QSlider( ControlFrame8 );   TranXlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, TranX_1, 180, 30, 10, 21,  100, TranXlcd_1,  "X", 9);
    connect( TranX_1,   SIGNAL(valueChanged(int)), this, SLOT(setXTrans(int)) );
    connect( TranX_1,   SIGNAL(valueChanged(int)), TranXlcd_1, SLOT(display(int)) );
	  connect(TranXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXTrans(int)) );

    TranY_1 = new QSlider( ControlFrame8 );   TranYlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, TranY_1, 180, 60, 10, 21,  100, TranYlcd_1,  "Y", 9);
    connect( TranY_1, SIGNAL(valueChanged(int)), this, SLOT(setYTrans(int)) );
    connect( TranY_1, SIGNAL(valueChanged(int)), TranYlcd_1, SLOT(display(int)) );
	  connect(TranYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYTrans(int)) );

    TranZ_1 = new QSlider( ControlFrame8 );   TranZlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, TranZ_1, 180, 90, 10, 21,  100, TranZlcd_1,  "Z", 9);
    connect( TranZ_1,   SIGNAL(valueChanged(int)), this, SLOT(setZTrans(int)) );
    connect( TranZ_1,   SIGNAL(valueChanged(int)), TranZlcd_1, SLOT(display(int)) );
	  connect(TranZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZTrans(int)) );


    // set up scale sliders
    ScaleText_1 = new QLabel( ControlFrame8, "ScaleText_1" );
    addLabel( ScaleText_1, 350, 10, 110, 21, "SCALE", 9);

    ScaleX_1 = new QSlider( ControlFrame8 );   ScaleXlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, ScaleX_1, 350, 30, 10, 21,  100, ScaleXlcd_1,  "X", 9);
    connect( ScaleX_1, SIGNAL(valueChanged(int)), this, SLOT(setXScale(int)) );
    connect( ScaleX_1, SIGNAL(valueChanged(int)), ScaleXlcd_1, SLOT(display(int)) );
	  connect(ScaleXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXScale(int)) );

    ScaleY_1 = new QSlider( ControlFrame8 );   ScaleYlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, ScaleY_1, 350, 60, 10, 21,  100, ScaleYlcd_1,  "Y", 9);
    connect( ScaleY_1, SIGNAL(valueChanged(int)), this, SLOT(setYScale(int)) );
    connect( ScaleY_1, SIGNAL(valueChanged(int)), ScaleYlcd_1, SLOT(display(int)) );
	  connect(ScaleYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYScale(int)) );

    ScaleZ_1 = new QSlider( ControlFrame8 );   ScaleZlcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, ScaleZ_1, 350, 90, 10, 21,  100, ScaleZlcd_1,  "Z", 9);
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZScale(int)) );
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), ScaleZlcd_1, SLOT(display(int)) );
	  connect(ScaleZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZScale(int)) );


    ////////////////////////////////////////////////////////
    //object options

    ControlFrame9 = new QFrame( fxobject_object, "ControlFrame4" );
    ControlFrame9->setGeometry( QRect( 0, 0, 660, 120 ) );


    loadobject_1 = new QPushButton( ControlFrame9, "load" );
    addButton( loadobject_1, 0, 20, 111, 30, "Load Object" );
    connect( loadobject_1,  SIGNAL(clicked()), this, SLOT(loadObject())  );

    objectstyle = new QPushButton( ControlFrame9, "draw" );
    addButton( objectstyle, 115, 20, 35, 30, "fill" );
    connect( objectstyle,  SIGNAL(clicked()), this, SLOT(changeObjectDraw())  );


    ////////////////////////////////////////////////////////
    //max object options

    ControlFrame10 = new QFrame( fxobject_maxobject, "ControlFrame4" );
    ControlFrame10->setGeometry( QRect( 0, 0, 40, 120 ) );

    loadmaxobject_1 = new QPushButton( ControlFrame10, "load" );
    addButton( loadmaxobject_1, 0, 20, 111, 30, "Load MObject" );
    connect( loadmaxobject_1,  SIGNAL(clicked()), this, SLOT(loadMaxObject())  );


    ////////////////////////////////////////////////////////
    //effects options now brushes



    ////////////////////////////////////////////////////////
    // raise the control bar and raise backgound as default

    fxaxis->raiseWidget(3);
    fxobject->raiseWidget(0);
	controlpanel->raiseWidget(1);

}













