/*******************************************************************************
**
** The source file for the Jahshaka animation interface module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "character.h"

#include "Pixmaps/light.xpm"

void GLChar::buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller) {

   //////////////////////////////////////////////////////////////
   // This is to be overridden...

    //left menu here
    glworldLeft = new QFrame (leftcontroller, "gl left");
    //glworldLeft->setFixedSize( QSize( 30, 300 ) );

    tooltranslate = new QPushButton( ( QIconSet( QPixmap("Pixmaps/translate.xpm"), QPixmap("Pixmaps/translate.xpm") )) ,"", glworldLeft, "play" );
    tooltranslate->setGeometry( QRect( 0, 205, 30, 27 ) );
    tooltranslate->setFlat(true);

    toolrotate = new QPushButton( ( QIconSet( QPixmap("Pixmaps/rotate.xpm"), QPixmap("Pixmaps/rotate.xpm") )) ,"", glworldLeft, "rotate" );
    toolrotate->setGeometry( QRect( 0, 233, 30, 27 ) );
    toolrotate->setFlat(true);

    toolscale = new QPushButton( ( QIconSet( QPixmap("Pixmaps/scale.xpm"), QPixmap("Pixmaps/scale.xpm") )) ,"", glworldLeft, "scale" );
    toolscale->setGeometry( QRect( 0, 263, 30, 27 ) );
    toolscale->setFlat(true);

    //rightmenu here
    glworldRight =  new QFrame (rightcontroller, "gl right" );
   // glworldRight->setFixedSize( QSize( 30, 300 ) );

    toolzoomin = new QPushButton( ( QIconSet( QPixmap("Pixmaps/zoomin.xpm"), QPixmap("Pixmaps/zoomin.xpm") )) ,"", glworldRight, "zoomin" );
    toolzoomin->setGeometry( QRect( 0, 115, 30, 27 ) );
    toolzoomin->setFlat(true);

    zoom = new QSlider( glworldRight, "scrubslider" );
    zoom->setStyle( new QPlatinumStyle );
    zoom->setGeometry( QRect( 0, 150, 30, 200 ) );
    zoom->setOrientation( QSlider::Vertical );
    zoom->setMinValue( -10 );    zoom->setMaxValue( 10 );    zoom->setValue   ( 0 );

    toolzoomout = new QPushButton( ( QIconSet( QPixmap("Pixmaps/zoomout.xpm"), QPixmap("Pixmaps/zoomout.xpm") )) ,"", glworldRight, "zoomout" );
    toolzoomout->setGeometry( QRect( 0, 355, 30, 27 ) );
    toolzoomout->setFlat(true);

	  //connect tools to object and add object to display widget
    //note that zoom isnt hooked up yet...
    connect( tooltranslate,  SIGNAL(clicked()), this, SLOT(toolTranslate() )  );
    connect( toolscale,      SIGNAL(clicked()), this, SLOT(toolScale() )  );
    connect( toolrotate,     SIGNAL(clicked()), this, SLOT(toolRotate() )  );

    connect( zoom,  SIGNAL(sliderMoved(int)), this, SLOT(changeZoom(int) )  );


}

void GLChar::buildInterface( QHBox* qtinterface ) {

	    ///////////////////////////////////////////////////////////
    //The layers interface
    LayersFrame = new QFrame( qtinterface, "EffectsFrame" );
    LayersFrame->setGeometry( QRect( 0, 0, 60, 195 ) );
    LayersFrame->setMinimumSize( QSize( 60, 195 ) );  //was 960
    LayersFrame->setMaximumSize( QSize( 60, 195 ) );

    ///////////////////////////////////////////////////////////
    //The layer options
    AddButton = new QPushButton( LayersFrame, "AddButton" );
    addButton( AddButton,  0, 5, 55, 25,  "Add" );
    connect  ( AddButton,  SIGNAL(clicked()), this, SLOT( addLayer())  );

    NameButton = new QPushButton( LayersFrame, "NameButton" );
    addButton( NameButton, 0, 30, 55, 25, "Name" );
    connect  ( NameButton,  SIGNAL(clicked()), this, SLOT( nameLayer())  );

      namepopup = new FancyPopup( this, "Enter Layer Name",170,90 );  //send size and position as well
      connect ( namepopup,      SIGNAL( returnText(QString)), SLOT( setlayerName(QString)) );

    DelButton = new QPushButton( LayersFrame, "Delete Button" );
    addButton( DelButton, 0, 60, 55, 25 , "Del" );
    connect  ( DelButton,  SIGNAL(clicked()), this, SLOT( delLayer())  );

    //////////////////////////////////////////////////////////////
    // set up the scene options, or prefernces
    EffectsMain = new QWidgetStack(qtinterface);
    SceneFrame   = new QFrame(EffectsMain);
    EffectsFrame = new QFrame(EffectsMain);

    EffectsMain->addWidget(SceneFrame,0);
    EffectsMain->addWidget(EffectsFrame,1);
    EffectsMain->setGeometry( QRect( 0, 0, 855, 195) );

    EffectsStatus = FALSE; EffectsMain->raiseWidget(1);

    /////////////////////////////////////////////////////////
    //this is the list-view
    lv = new QListView( EffectsFrame );

      connect( lv, SIGNAL( clicked( QListViewItem* ) ), this, SLOT( clicked( QListViewItem* ) ) );

      lv->setGeometry( QRect( 2, 2, 146, 180 ) );
      lv->addColumn( "LAYERS         ", -1 );
      lv->setSorting( -1,1 );   // disables the autosort


	//////////////////////////////////////////////////////////
	// set up options here

	controlpanel = new QWidgetStack(EffectsFrame);

	//this may need to be QHBox as it is below...
     scene_controls  = new QFrame(controlpanel);     controlpanel->addWidget(scene_controls,0);
     object_controls = new QFrame(controlpanel);     controlpanel->addWidget(object_controls,1);
	
	 controlpanel->setGeometry( QRect( 148, 0, 700, 180) );

    /////////////////////////////////////////////////////////
    //Set up scene interface

	sceneframe = new QFrame( scene_controls, "scenecontrols" );
    sceneframe->setGeometry( QRect( 1, 1, 700, 180 ) );
    sceneframe->setStyle( new QPlatinumStyle );

    //fxobject->setGeometry( QRect( 0, 0, 700, 120) );   // was 635
	/*
    LoadButton = new QPushButton( sceneframe, "LoadButton" );
    addButton( LoadButton, 10, 10, 86, 25 , "Load" );
    connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

  // clean up this mess here!
   */

    /////////////////////////////////////////////////////////
    //Set up tabbed interface

   // tabframe = new QTabWidget( EffectsFrame, "axiscontrols" );
    tabframe = new QTabWidget( object_controls, "axiscontrols" );
    tabframe->setGeometry( QRect( 1, 1, 700, 180 ) );
    tabframe->setTabShape( QTabWidget::Triangular );
    tabframe->setAutoMask( FALSE );
    tabframe->setStyle( new QPlatinumStyle );

    objectcontrols = new QWidget( EffectsFrame, "objectcontrols" );
    //objectcontrols->setGeometry( QRect( 148, 1, 700, 130 ) );
    tabframe->insertTab( objectcontrols, tr( "  OBJECT  " ) );

    axiscontrols = new QWidget( EffectsFrame, "axiscontrols" );
    //axiscontrols->setGeometry( QRect( 148, 1, 700, 130 ) );
    tabframe->insertTab( axiscontrols, tr( "  AXIS  " ) );

    texturecontrols = new QWidget( EffectsFrame, "texturecontrols" );
    tabframe->insertTab( texturecontrols, tr( "    CLIP    " ) );

    effectscontrols = new QWidget( EffectsFrame, "effectscontrols" );
    tabframe->insertTab( effectscontrols, tr( "  EFFECTS  " ) );

	//this has become the settings panel need to update variable names
    scenecontrols = new QWidget( EffectsFrame, "scenesettings" );
    tabframe->insertTab( scenecontrols, tr( "  SETTINGS  " ) );

    /////////////////////////////////////////////////////////////////////
    // the layout boxes for different types of layers
    // these should be changed and regroups to represent tabs above
	// these should be arrays

    // the axis control tab bar
	// this is just really world and layer now
	// we can get rid of the rest

    fxaxis = new QWidgetStack(axiscontrols);

     fxaxis_clipone = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_clipone,0);
     fxaxis_cliptwo = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_cliptwo,1);
     fxaxis_object  = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_object, 2);
     fxaxis_world   = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_world,  3);
     fxaxis_text    = new QHBox(fxaxis);     fxaxis->addWidget(fxaxis_text,   4);

    fxaxis->setGeometry( QRect( 0, 0, 700, 120) );


    ///////////////////////////////////////////////////////////////////
    // the object control tab bar
	// this is the object control panel

    fxobject = new QWidgetStack(objectcontrols);

     fxobject_clip     = new QHBox(fxobject);          fxobject->addWidget(fxobject_clip,    0);
     fxobject_text     = new QHBox(fxobject);          fxobject->addWidget(fxobject_text,    1);
     fxobject_world    = new QHBox(fxobject);          fxobject->addWidget(fxobject_world,   2);
     fxobject_key      = new QHBox(fxobject);          fxobject->addWidget(fxobject_key,     3);
     fxobject_particle = new QHBox(fxobject);          fxobject->addWidget(fxobject_particle,4);
     fxobject_object   = new QHBox(fxobject);          fxobject->addWidget(fxobject_object,  5);
	 fxobject_maxobject= new QHBox(fxobject);          fxobject->addWidget(fxobject_maxobject,  6);

    fxobject->setGeometry( QRect( 0, 0, 700, 120) );   // was 635

    ///////////////////////////////////////////////////////////////////
    // the scene control tab bar

    //add the layer reset button here as well

    BlurSelect = new QCheckBox( scenecontrols, "BlurSelect" );
    addCheckButton( BlurSelect, 10, 10, 110, 21, "motion blur" );
    connect( BlurSelect,  SIGNAL(clicked()), this, SLOT(setBlur())  );




    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );


    ///////////////////////////////////////////////////////////////////////
    //set up world control set

    ControlFrame3 = new QFrame( fxobject_world, "ControlFrame3" );
    ControlFrame3->setGeometry( QRect( 0, 0, 660, 120 ) );

    LoadButton = new QPushButton( ControlFrame3, "LoadButton" );
    addButton( LoadButton, 10, 10, 86, 25 , "Load" );
    connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

    SaveButton = new QPushButton( ControlFrame3, "SaveButton" );
    addButton( SaveButton, 10, 45, 86, 25, "Save" );
    connect  ( SaveButton,  SIGNAL(clicked()), this, SLOT( SceneSave())  );

    ResetButton = new QPushButton( ControlFrame3, "ResetButton" );
    addButton( ResetButton, 10, 80, 86, 25, "Reset" );
    connect  ( ResetButton,  SIGNAL(clicked()), this, SLOT( ResetAll())  );

    ClearButton = new QPushButton( ControlFrame3, "ClearButton" );
    addButton( ClearButton, 110, 10, 86, 25, "Clear" );
    connect( ClearButton,  SIGNAL(clicked()), this, SLOT( ClearAll())  );

    TextSelect = new QCheckBox( ControlFrame3, "TitleSafe" );
    addCheckButton( TextSelect, 300, 80, 110, 21, "title safe" );
    connect( TextSelect,  SIGNAL(clicked()), this, SLOT(setTextSafe())  );

    GridSelect = new QCheckBox( ControlFrame3, "Grid" );
    addCheckButton( GridSelect, 300, 40, 110, 21, "grid" );
    connect( GridSelect,  SIGNAL(clicked()), this, SLOT(setGrid())  );

    SmoothSelect = new QCheckBox( ControlFrame3, "SmoothSelect" );
    addCheckButton( SmoothSelect, 300, 10, 110, 21, "aliasing" );
    connect( SmoothSelect,  SIGNAL(clicked()), this, SLOT(setSmooth())  );

  //need to move this into the module
    //this is mandatory for all modules...

    sframetext = new QLabel( ControlFrame3, "sframetext" );
    sframetext->setGeometry( QRect( 400, 4, 80, 27 ) );
    sframetext->setText( tr( "STARTFRAME" ) );
    sframetext->setAlignment( int( QLabel::AlignCenter ) );
    QFont sframetext_font(  sframetext->font() );
    sframetext_font.setPointSize( 9 );
    sframetext->setFont( sframetext_font );

    lcdstartframe = new InputLCD( ControlFrame3, "startframe",9 );
	  addSliderLcd(lcdstartframe, 500, 5, 90, 21, Astartframe);
	  lcdstartframe->setMinMaxInt( Astartframe, Aendframe-1 );
    lcdstartframe->setValue(Astartframe);
	  connect( lcdstartframe, SIGNAL(valueChanged(int)),   SLOT(updatesliderStartframe(int)) );

    eframetext = new QLabel( ControlFrame3, "eframetext" );
    eframetext->setGeometry( QRect( 400, 34, 80, 27 ) );
    eframetext->setText( tr( "ENDFRAME"  ) );
    eframetext->setAlignment( int( QLabel::AlignCenter ) );
    QFont eframetext_font(  eframetext->font() );
    eframetext_font.setPointSize( 9 );
    eframetext->setFont( eframetext_font );

//addSliderLcd(animframe, 5, 0, 90, 31, 100);
    lcdendframe = new InputLCD( ControlFrame3, "endframe",9 );
	  addSliderLcd(lcdendframe, 500, 34, 90, 21, Aendframe);
	  lcdendframe->setMinMaxInt( Astartframe+1, MaxFrames );
    lcdendframe->setValue(Aendframe);
	  connect( lcdendframe, SIGNAL(valueChanged(int)),   SLOT(updatesliderEndframe(int)) );

   /////////////////////////////////////////////////////////////////////////////
    //world control sliders
    ControlFrame4 = new QFrame( fxaxis_world, "ControlFrame4" );
    ControlFrame4->setGeometry( QRect( 0, 0, 660, 120 ) );

    // set up rotate sliders
    RotateText_4 = new QLabel( ControlFrame4, "RotateText_4" );
    addLabel( RotateText_4, 10, 10, 110, 21, "ROTATE", 9);

    RotX_4 = new QSlider( ControlFrame4 );   RotXlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, RotX_4, 10, 30, 10, 21,  500, RotXlcd_4,  "X", 9);
    connect( RotX_4, SIGNAL(valueChanged(int)),     this,       SLOT(setWorldXR(int)) );
    connect( RotX_4, SIGNAL(valueChanged(int)),     RotXlcd_4,  SLOT(display(int)) );
	connect(RotXlcd_4, SIGNAL(valueChanged(int)),   this,       SLOT(setWorldXR(int)) );

    RotY_4 = new QSlider( ControlFrame4 );   RotYlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, RotY_4, 10, 60, 10, 21,  500, RotYlcd_4,  "Y", 9);
    connect( RotY_4, SIGNAL(valueChanged(int)),     this,       SLOT(setWorldYR(int)) );
    connect( RotY_4, SIGNAL(valueChanged(int)),     RotYlcd_4,  SLOT(display(int)) );
	connect(RotYlcd_4, SIGNAL(valueChanged(int)),   this,       SLOT(setWorldYR(int)) );

    RotZ_4 = new QSlider( ControlFrame4 );   RotZlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, RotZ_4, 10, 90, 10, 21,  500, RotZlcd_4,  "Z", 9);
    connect( RotZ_4, SIGNAL(valueChanged(int)),     this,       SLOT(setWorldZR(int)) );
	connect( RotZ_4, SIGNAL(valueChanged(int)),     RotZlcd_4,  SLOT(display(int)) );
    connect( RotZlcd_4, SIGNAL(valueChanged(int)),  this,       SLOT(setWorldZR(int)) );


    // set up translate sliders
    TranslateText_4 = new QLabel( ControlFrame4, "TranslateText_4" );
    addLabel( TranslateText_4, 200, 10, 110, 21, "TRANSLATE", 9);

    TranX_4 = new QSlider( ControlFrame4 );   TranXlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, TranX_4, 200, 30, 10, 21,  500, TranXlcd_4,  "X", 9);
    connect( TranX_4, SIGNAL(valueChanged(int)),    this,       SLOT(setWorldXT(int)) );
    connect( TranX_4, SIGNAL(valueChanged(int)),    TranXlcd_4, SLOT(display(int)) );
    connect( TranXlcd_4, SIGNAL(valueChanged(int)), this,       SLOT(setWorldXT(int)) );

    TranY_4 = new QSlider( ControlFrame4 );   TranYlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, TranY_4, 200, 60, 10, 21,  500, TranYlcd_4,  "Y", 9);
    connect( TranY_4, SIGNAL(valueChanged(int)),    this,       SLOT(setWorldYT(int)) );
    connect( TranY_4, SIGNAL(valueChanged(int)),    TranYlcd_4, SLOT(display(int)) );
    connect( TranYlcd_4, SIGNAL(valueChanged(int)), this,       SLOT(setWorldYT(int)) );

    TranZ_4 = new QSlider( ControlFrame4 );   TranZlcd_4 = new InputLCD( ControlFrame4 );
    addSliderLcdLabel( ControlFrame4, TranZ_4, 200, 90, 10, 21,  500, TranZlcd_4,  "Z", 9);
    connect( TranZ_4, SIGNAL(valueChanged(int)),    this,       SLOT(setWorldZT(int)) );
    connect( TranZ_4, SIGNAL(valueChanged(int)),    TranZlcd_4, SLOT(display(int)) );
    connect( TranZlcd_4, SIGNAL(valueChanged(int)), this,       SLOT(setWorldZT(int)) );

    // set up zoom slider
    //ScaleText_4 = new QLabel( ControlFrame4, "ScaleText_4" );
    //addLabel( ScaleText_4, 370, 10, 110, 21, "ZOOM", 9);

    //ScaleX_4 = new QSlider( ControlFrame4 );   ScaleXlcd_4 = new InputLCD( ControlFrame4 );
    //addSliderLcdLabel( ControlFrame4, ScaleX_4, 370, 30, 10, 21,  100, ScaleXlcd_4,  "Z", 9);
    //connect( ScaleX_4, SIGNAL(valueChanged(int)), ScaleXlcd_4, SLOT(display(int)) );


    ///////////////////////////////////////////////////////////////
    // object layer options
    ControlFrame5 = new QFrame( fxobject_clip, "ControlFrame5" );
    ControlFrame5->setGeometry( QRect( 0, 0, 660, 120 ) );

	//the different object types

    ObjectLayer = new QPushButton( ControlFrame5, "Layer" );
    addButton( ObjectLayer, 10, 10, 86, 25 , "Layer" );
    connect  ( ObjectLayer,  SIGNAL(clicked()), this, SLOT( ChangeObjectLayer())  );

    ObjectCube = new QPushButton( ControlFrame5, "Cube" );
    addButton( ObjectCube, 10, 45, 86, 25, "Cube" );
    connect  ( ObjectCube,  SIGNAL(clicked()), this, SLOT( ChangeObjectCube())  );

    ObjectCylinder = new QPushButton( ControlFrame5, "Cylinder" );
    addButton( ObjectCylinder, 10, 80, 86, 25, "Cylinder" );
    connect  ( ObjectCylinder,  SIGNAL(clicked()), this, SLOT( ChangeObjectCylinder())  );

    ObjectSphere = new QPushButton( ControlFrame5, "Sphere" );
    addButton( ObjectSphere, 110, 10, 86, 25, "Sphere" );
    connect( ObjectSphere,  SIGNAL(clicked()), this, SLOT( ChangeObjectSphere())  );

    ObjectBezier = new QPushButton( ControlFrame5, "Bezier" );
    addButton( ObjectBezier, 110, 45, 86, 25, "Bezier" );
    connect( ObjectBezier,  SIGNAL(clicked()), this, SLOT( ChangeObjectBezier())  );

    ObjectMesh = new QPushButton( ControlFrame5, "Mesh" );
    addButton( ObjectMesh, 110, 80, 86, 25, "Mesh" );
    connect( ObjectMesh,  SIGNAL(clicked()), this, SLOT( ChangeObjectMesh())  );

    ResetLayerButton = new QPushButton( ControlFrame5, "ResetLayerButton" );
    addButton( ResetLayerButton, 410, 10, 86, 25, "Reset" );
    connect  ( ResetLayerButton,  SIGNAL(clicked()), this, SLOT( ResetLayer())  );


    ///////////////////////////////////////////////////////////////////////
    //set up object control set and sliders

    ControlFrame1 = new QFrame( fxaxis_clipone, "ControlFrame1" );
    ControlFrame1->setGeometry( QRect( 0, 0, 760, 120 ) );    // was 510

    // set up rotate sliders
    RotateText_1 = new QLabel( ControlFrame1, "RotateText_1" );
    addLabel( RotateText_1, 10, 10, 110, 21, "ROTATE", 9);

    RotX_1 = new QSlider( ControlFrame1 );   RotXlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, RotX_1, 0, 30, 10, 21,  500, RotXlcd_1,  "X", 9);
    connect( RotX_1, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );
    connect( RotX_1, SIGNAL(valueChanged(int)), RotXlcd_1, SLOT(display(int)) );
	  connect(RotXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );

    RotY_1 = new QSlider( ControlFrame1 );   RotYlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, RotY_1, 0, 60, 10, 21,  500, RotYlcd_1,  "Y", 9);
    connect( RotY_1, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );
    connect( RotY_1, SIGNAL(valueChanged(int)), RotYlcd_1, SLOT(display(int)) );
	  connect(RotYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );

    RotZ_1 = new QSlider( ControlFrame1 );   RotZlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, RotZ_1, 0, 90, 10, 21,  500, RotZlcd_1,  "Z", 9);
    connect( RotZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)) );
    connect( RotZ_1, SIGNAL(valueChanged(int)), RotZlcd_1, SLOT(display(int)) );
	  connect(RotZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)) );


    // set up translate sliders
    TranslateText_1 = new QLabel( ControlFrame1, "TranslateText_1" );
    addLabel( TranslateText_1, 180, 10, 110, 21, "TRANSLATE", 9);

    TranX_1 = new QSlider( ControlFrame1 );   TranXlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, TranX_1, 180, 30, 10, 21,  500, TranXlcd_1,  "X", 9);
    connect( TranX_1,   SIGNAL(valueChanged(int)), this, SLOT(setXTrans(int)) );
    connect( TranX_1,   SIGNAL(valueChanged(int)), TranXlcd_1, SLOT(display(int)) );
	  connect(TranXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXTrans(int)) );

    TranY_1 = new QSlider( ControlFrame1 );   TranYlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, TranY_1, 180, 60, 10, 21,  500, TranYlcd_1,  "Y", 9);
    connect( TranY_1, SIGNAL(valueChanged(int)), this, SLOT(setYTrans(int)) );
    connect( TranY_1, SIGNAL(valueChanged(int)), TranYlcd_1, SLOT(display(int)) );
	  connect(TranYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYTrans(int)) );

    TranZ_1 = new QSlider( ControlFrame1 );   TranZlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, TranZ_1, 180, 90, 10, 21,  500, TranZlcd_1,  "Z", 9);
    connect( TranZ_1,   SIGNAL(valueChanged(int)), this, SLOT(setZTrans(int)) );
    connect( TranZ_1,   SIGNAL(valueChanged(int)), TranZlcd_1, SLOT(display(int)) );
	  connect(TranZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZTrans(int)) );


    // set up scale sliders
    ScaleText_1 = new QLabel( ControlFrame1, "ScaleText_1" );
    addLabel( ScaleText_1, 350, 10, 110, 21, "SCALE", 9);

    ScaleX_1 = new QSlider( ControlFrame1 );   ScaleXlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, ScaleX_1, 350, 30, 10, 21,  100, ScaleXlcd_1,  "X", 9);
    connect( ScaleX_1, SIGNAL(valueChanged(int)), this, SLOT(setXScale(int)) );
    connect( ScaleX_1, SIGNAL(valueChanged(int)), ScaleXlcd_1, SLOT(display(int)) );
	  connect(ScaleXlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setXScale(int)) );

    ScaleY_1 = new QSlider( ControlFrame1 );   ScaleYlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, ScaleY_1, 350, 60, 10, 21,  100, ScaleYlcd_1,  "Y", 9);
    connect( ScaleY_1, SIGNAL(valueChanged(int)), this, SLOT(setYScale(int)) );
    connect( ScaleY_1, SIGNAL(valueChanged(int)), ScaleYlcd_1, SLOT(display(int)) );
	  connect(ScaleYlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setYScale(int)) );

    ScaleZ_1 = new QSlider( ControlFrame1 );   ScaleZlcd_1 = new InputLCD( ControlFrame1 );
    addSliderLcdLabel( ControlFrame1, ScaleZ_1, 350, 90, 10, 21,  100, ScaleZlcd_1,  "Z", 9);
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZScale(int)) );
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), ScaleZlcd_1, SLOT(display(int)) );
	  connect(ScaleZlcd_1, SIGNAL(valueChanged(int)), this, SLOT(setZScale(int)) );

    ShowKeySelect = new QCheckBox( ControlFrame1, "KeySelect" );
    addCheckButton( ShowKeySelect, 510, 30, 145, 25, "Show Keyframes" );
    connect( ShowKeySelect,  SIGNAL(clicked()), this, SLOT(setKeyframeDrawStatus())  ); //for clip

    ///////////////////////////////////////////////////////////////
    // texture layer options
	// need to add video-texture options here

	//image options

    ControlFrame2 = new QFrame( texturecontrols, "ControlFrame5" );
    ControlFrame2->setGeometry( QRect( 0, 0, 660, 120 ) );

    ClipSelect = new QCheckBox( ControlFrame2, "ClipSelect" );
    addCheckButton( ClipSelect, 0, 30, 45, 25, "Clip" );
    connect( ClipSelect,  SIGNAL(clicked()), this, SLOT(setClipStatus())  ); //for clip

    grabdesktopClip = new QPushButton( ControlFrame2, "grabdesktop" );
    addButton( grabdesktopClip, 45, 30, 110, 25, "Grab Desktop" );
    connect( grabdesktopClip,  SIGNAL(clicked()), this, SLOT(grabDesktop())  );

    //keyimage_2 = new QPushButton( ControlFrame2, "keyOne_2" );
    //addButton( keyimage_2, 165, 30, 35, 25, "IM" );
    //connect( keyimage_2,  SIGNAL(clicked()), this, SLOT(keyCliplayer())  );


    KeySelect = new QCheckBox( ControlFrame2, "KeySelect" );
    addCheckButton( KeySelect, 0, 75, 45, 25, "Key" );
    connect( KeySelect,  SIGNAL(clicked()), this, SLOT(setKeyStatus())  );

    //grabdesktopKey = new QPushButton( ControlFrame2, "grabdesktop" );
    //addButton( grabdesktopKey, 45, 75, 110, 25, "Grab Desktop" );
    //connect( grabdesktopKey,  SIGNAL(clicked()), this, SLOT(grabDesktopKey())  ); //for key...

    //keyimage_3 = new QPushButton( ControlFrame2, "keyOne_3" );
   // addButton( keyimage_3, 165, 75, 35, 25, "KM" );
   // connect( keyimage_3,  SIGNAL(clicked()), this, SLOT(keyClipkey())  );

    keyStatusBox = new QPushButton( ControlFrame2, "Select1" );
    addButton( keyStatusBox, 220, 75, 35, 25, "Invert" );
    connect( keyStatusBox,  SIGNAL(clicked()), this, SLOT(InvertKeyData())  );

	// video options
	// need to hook this up now...

    VideoLabel = new QLabel( ControlFrame2, "TranslateText_1" );
    addLabel( VideoLabel, 380, 10, 110, 21, "VIDEO OPTIONS", 9);


    FramesLcd = new InputLCD( ControlFrame2 );
    addLabelLcd( ControlFrame2, FramesLcd,       380, 30, 60, 21,  0,  "Frames", 8);

    inFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, inFramesLcd,     460, 30, 30, 21,  0,  "In", 8);
	connect(inFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setinFrames(int)) );

	outFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, outFramesLcd,    530, 30, 30, 21,  0,  "Out", 8);
	connect(outFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setoutFrames(int)) );

    KeyFramesLcd = new InputLCD( ControlFrame2 );
    addLabelLcd( ControlFrame2, KeyFramesLcd,    380, 75, 60, 21,  0,  "Frames", 8);

    inKeyFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, inKeyFramesLcd,  460, 75, 30, 21,  0,  "In", 8);
	connect(inKeyFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setinKeyFrames(int)) );

	outKeyFramesLcd = new InputLCD( ControlFrame2 );
    addLcdLabel( ControlFrame2, outKeyFramesLcd, 530, 75, 30, 21,  0,  "Out", 8);
	connect(outKeyFramesLcd, SIGNAL(valueChanged(int)), this, SLOT(setoutKeyFrames(int)) );

    //need to make the icon a lock... 3x current height as well for links
  	lockicon	= new QToolButton(ControlFrame2,"lockicon");
    lockicon->setGeometry( QRect( 600, 55, 18, 26 ) );
  	lockicon->setFixedSize(18, 26);  	//lighticon->setUsesBigPixmap(true);
  	lockicon->setAutoRaise(true);

  	QIconSet	*icoSet2;
    	icoSet2 = new QIconSet(QPixmap((const char**)light_xpm) );
    	icoSet2->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Active);
    	icoSet2->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Disabled);
    	lockicon->setIconSet(*icoSet2);
    delete icoSet2;

    /////////////////font options
    ControlFrame6 = new QFrame( fxobject_text, "ControlFrame4" );
    ControlFrame6->setGeometry( QRect( 0, 0, 40, 120 ) );

    ScaleText_5 = new QLabel( ControlFrame6, "ScaleText_4" );
    addLabel( ScaleText_5, 0, 10, 110, 21, "EXTRUDE", 9);

    ScaleX_5 = new QSlider( ControlFrame6 ); ScaleXlcd_5 = new InputLCD( ControlFrame6 );
    addSliderLcdLabel( ControlFrame6, ScaleX_5,   0, 30, 110, 21,  1, 200,  30,  ScaleXlcd_5,  "E", 9);
    connect( ScaleX_5,    SIGNAL(valueChanged(int)), ScaleXlcd_5, SLOT(display(int)) );
    connect( ScaleX_5,    SIGNAL(valueChanged(int)), this, SLOT(setExtrude(int)) );
    connect( ScaleXlcd_5, SIGNAL(valueChanged(int)), this, SLOT(setExtrude(int)) );

    textDraw = new QPushButton( ControlFrame6, "draw" );
    addButton( textDraw, 115, 30, 36, 21, "Draw" );
    connect( textDraw,  SIGNAL(clicked()), this, SLOT(changeFontDraw())  );

    textEd	= new QLineEdit( ControlFrame6, "text" );
    textEd->setGeometry( QRect( 0, 60, 150, 21 ) );
    textEd->setFocus();    textEd->setText( "jahshaka" );
    connect( textEd, SIGNAL(textChanged(const QString&)), this, SLOT(setText(const QString&)) );

    textFont = new QPushButton( ControlFrame6, "font" );
    addButton( textFont, 0, 90, 55, 21, "Font" );
    connect( textFont,  SIGNAL(clicked()), this, SLOT(loadFont())  );

    textColor = new QPushButton( ControlFrame6, "color" );
    addButton( textColor, 60, 90, 55, 21, "Color" );
    connect( textColor,  SIGNAL(clicked()), this, SLOT(setFontColor())  );

    ///////////////////////////////////////////////////////
    //particle options

    ControlFrame7 = new QFrame( fxobject_particle, "ControlFrame4" );
    ControlFrame7->setGeometry( QRect( 0, 0, 40, 120 ) );

    //loadimage_3 = new QPushButton( ControlFrame7, "emitter" );
    //addButton( loadimage_3, 0, 20, 111, 30,  "Emit" );
    //connect( loadimage_3,  SIGNAL(clicked()), this, SLOT(changeParticle())  );

   // particlestyle = new QPushButton( ControlFrame7, "tex" );
   // addButton( particlestyle, 115, 20, 35, 30, "TEX" );
   // connect( particlestyle,  SIGNAL(clicked()), this, SLOT(changeParticleDraw())  );

    ////////////////////////////////////////////////////////
    //object options

    ControlFrame9 = new QFrame( fxobject_object, "ControlFrame4" );
    ControlFrame9->setGeometry( QRect( 0, 0, 40, 120 ) );


    loadobject_1 = new QPushButton( ControlFrame9, "load" );
    addButton( loadobject_1, 0, 20, 111, 30, "Load Object" );
    connect( loadobject_1,  SIGNAL(clicked()), this, SLOT(loadObject())  );

   // objectstyle = new QPushButton( ControlFrame9, "draw" );
   // addButton( objectstyle, 115, 20, 35, 30, "fill" );
   // connect( objectstyle,  SIGNAL(clicked()), this, SLOT(changeObjectDraw())  );


    ////////////////////////////////////////////////////////
    //max object options

    ControlFrame10 = new QFrame( fxobject_maxobject, "ControlFrame4" );
    ControlFrame10->setGeometry( QRect( 0, 0, 40, 120 ) );

    loadmaxobject_1 = new QPushButton( ControlFrame10, "load" );
    addButton( loadmaxobject_1, 0, 20, 111, 30, "Load MObject" );
    connect( loadmaxobject_1,  SIGNAL(clicked()), this, SLOT(loadMaxObject())  );


    ////////////////////////////////////////////////////////
    //effects options

    ControlFrame8 = new QFrame( effectscontrols, "ControlFrame5" );
    ControlFrame8->setGeometry( QRect( 0, 0, 660, 120 ) );

	//toggle foreground background status
    ForegroundSelect = new QCheckBox( ControlFrame8, "foreground" );
    addCheckButton( ForegroundSelect, 10, 10, 110, 21, "foreground" );
    connect( ForegroundSelect,  SIGNAL(clicked()), this, SLOT(toggleForegroundStatus())  );

    //add a subroutine for creating icons
  	lighticon	= new QToolButton(ControlFrame8,"lighticon");
    lighticon->setGeometry( QRect( 600, 10, 18, 26 ) );
  	lighticon->setFixedSize(18, 26);  	//lighticon->setUsesBigPixmap(true);
  	lighticon->setAutoRaise(true);

  	QIconSet	*icoSet;
    	icoSet = new QIconSet(QPixmap((const char**)light_xpm) );
    	icoSet->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Active);
    	icoSet->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Disabled);
    	lighticon->setIconSet(*icoSet);
    delete icoSet;

    light1 = new QCheckBox( ControlFrame8, "light1" );
    light1->setGeometry( QRect( 600, 36, 20, 21 ) );
    connect( light1,  SIGNAL(clicked()), this, SLOT(toggleLight())  );

    Transparency_1 = new QLabel( ControlFrame8, "ScaleText_2" );
    addLabel( Transparency_1, 400, 5, 110, 21, "TRANSPARENCY", 9);
    Trans_1 = new QSlider( ControlFrame8 );  Translcd_1 = new InputLCD( ControlFrame8 );
    addSliderLcdLabel( ControlFrame8, Trans_1,   400, 25, 10, 21,  1, 100,    Translcd_1,  "T", 9);
    connect( Trans_1,    SIGNAL(valueChanged(int)), Translcd_1, SLOT(display(int)) );
    connect( Trans_1,    SIGNAL(valueChanged(int)), this, SLOT(setAlpha(int)) );
    connect( Translcd_1, SIGNAL(valueChanged(int)), this, SLOT(setAlpha(int)) );
    ////////////////////////////////////////////////////////
    // raise the control bar and raise backgound as default

    fxaxis->raiseWidget(3);
    fxobject->raiseWidget(0);
	controlpanel->raiseWidget(1);


/*
///////////////////////////This is the interface////////////////////////////////


    LayersFrame = new QFrame( qtinterface, "EffectsFrame" );
    LayersFrame->setGeometry( QRect( 0, 0, 60, 140 ) );
    LayersFrame->setMinimumSize( QSize( 60, 140 ) );  //was 960
    LayersFrame->setMaximumSize( QSize( 60, 140 ) );

    ///////////////////////////////////////////////////////////
    //The layer options
    AddButton = new QPushButton( LayersFrame, "AddButton" );
    addButton( AddButton,  0, 5, 55, 25,  "Add" );
    connect  ( AddButton,  SIGNAL(clicked()), this, SLOT( addLayer())  );

    NameButton = new QPushButton( LayersFrame, "NameButton" );
    addButton( NameButton, 0, 30, 55, 25, "Name" );
    connect  ( NameButton,  SIGNAL(clicked()), this, SLOT( nameLayer())  );

      namepopup = new FancyPopup( this, "Enter Layer Name",200,100 );  //send size and position as well
      connect ( namepopup,      SIGNAL( returnText(QString)), SLOT( setlayerName(QString)) );

    DelButton = new QPushButton( LayersFrame, "Delete Button" );
    addButton( DelButton, 0, 60, 55, 25 , "Del" );
    connect  ( DelButton,  SIGNAL(clicked()), this, SLOT( delLayer())  );

    //////////////////////////////////////////////////////////////
    // set up the scene options, or prefernces
    EffectsMain = new QWidgetStack(qtinterface);
    SceneFrame   = new QFrame(EffectsMain);
    EffectsFrame = new QFrame(EffectsMain);

    EffectsMain->addWidget(SceneFrame,0);
    EffectsMain->addWidget(EffectsFrame,1);
    EffectsMain->setGeometry( QRect( 0, 0, 855, 140) );

    EffectsStatus = FALSE; EffectsMain->raiseWidget(1);

    ////////////////// scene options
    LoadButton = new QPushButton( SceneFrame, "LoadButton" );
    addButton( LoadButton, 10, 10, 86, 25 , "Load" );
    connect  ( LoadButton,  SIGNAL(clicked()), this, SLOT( SceneLoad())  );

    SaveButton = new QPushButton( SceneFrame, "SaveButton" );
    addButton( SaveButton, 10, 45, 86, 25, "Save" );
    connect  ( SaveButton,  SIGNAL(clicked()), this, SLOT( SceneSave())  );

    ResetButton = new QPushButton( SceneFrame, "ResetButton" );
    addButton( ResetButton, 10, 80, 86, 25, "Reset" );
    connect  ( ResetButton,  SIGNAL(clicked()), this, SLOT( ResetAll())  );

//    ClearButton = new QPushButton( SceneFrame, "ResetButton" );
//    addButton( ClearButton, 10, 115, 86, 25, "Clear" );
//    connect( ClearButton,  SIGNAL(clicked()), this, SLOT( ClearAll())  );

    //these are checkboxes...
    SmoothSelect = new QCheckBox( SceneFrame, "SmoothSelect" );
    addCheckButton( SmoothSelect, 130, 10, 110, 21, "aliasing" );
    connect( SmoothSelect,  SIGNAL(clicked()), this, SLOT(setSmooth())  );

    BlurSelect = new QCheckBox( SceneFrame, "BlurSelect" );
    addCheckButton( BlurSelect, 130, 45, 110, 21, "motion blur" );
    connect( BlurSelect,  SIGNAL(clicked()), this, SLOT(setBlur())  );

    TextSelect = new QCheckBox( SceneFrame, "TitleSafe" );
    addCheckButton( TextSelect, 130, 80, 110, 21, "title safe" );
    connect( TextSelect,  SIGNAL(clicked()), this, SLOT(setTextSafe())  );


    /////////////////////////////////////////////////////////
    //this is the list-view
    lv = new QListView( EffectsFrame );

      connect( lv, SIGNAL( clicked( QListViewItem* ) ), this, SLOT( clicked( QListViewItem* ) ) );

      lv->setGeometry( QRect( 2, 2, 146, 125 ) );
      lv->addColumn( "LAYERS         ", -1 );
      lv->setSorting( -1,1 );   // disables the autosort

    /////////////////////////////////////////////////////////
    //Set up scene interface

    //we need to create four sets of sliders now, one each for clip1, clip2, object and world
    //QHBox* fxoptionals_clipone = new QHBox(optionals_effects);

    ControlFrame_2 = new QFrame( EffectsFrame, "ControlFrame_2" );
    ControlFrame_2->setGeometry( QRect( 148, 1, 700, 130 ) );    // was 540

    fxoptionals = new QWidgetStack(ControlFrame_2);
    fxoptionals_clipone = new QHBox(fxoptionals);
    fxoptionals_cliptwo = new QHBox(fxoptionals);
    fxoptionals_object = new QHBox(fxoptionals);
    fxoptionals_world  = new QHBox(fxoptionals);
    fxoptionals_text  = new QHBox(fxoptionals);

    fxoptionals->addWidget(fxoptionals_clipone,0);
    fxoptionals->addWidget(fxoptionals_cliptwo,1);
    fxoptionals->addWidget(fxoptionals_object,2);
    fxoptionals->addWidget(fxoptionals_world,3);
    fxoptionals->addWidget(fxoptionals_text,4);
    fxoptionals->setGeometry( QRect( 0, 0, 700, 120) );   // was 635

    ///////////////////////////////////////////////////////////////////////
    //object one control set
    ControlFrame1 = new QFrame( fxoptionals_clipone, "ControlFrame1" );
    ControlFrame1->setGeometry( QRect( 0, 0, 760, 120 ) );    // was 510

    RotateText_1 = new QLabel( ControlFrame1, "RotateText_1" );
    RotateText_1->setGeometry( QRect( 10, 10, 110, 21 ) );
    RotateText_1->setText( tr( "ROTATE"  ) );
    RotateText_1->setAlignment( int( QLabel::AlignCenter ) );
    QFont RotateText_1_font(  RotateText_1->font() );
    RotateText_1_font.setPointSize( 9 );
    RotateText_1->setFont( RotateText_1_font );

    TranslateText_1 = new QLabel( ControlFrame1, "TranslateText_1" );
    TranslateText_1->setGeometry( QRect( 180, 10, 110, 21 ) );
    TranslateText_1->setText( tr( "TRANSLATE"  ) );
    TranslateText_1->setAlignment( int( QLabel::AlignCenter ) );
    QFont TranslateText_1_font(  TranslateText_1->font() );
    TranslateText_1_font.setPointSize( 9 );
    TranslateText_1->setFont( TranslateText_1_font );

    ScaleText_1 = new QLabel( ControlFrame1, "ScaleText_1" );
    ScaleText_1->setGeometry( QRect( 350, 10, 110, 21 ) );
    ScaleText_1->setText( tr( "SCALE"  ) );
    ScaleText_1->setAlignment( int( QLabel::AlignCenter ) );
    QFont ScaleText_1_font(  ScaleText_1->font() );
    ScaleText_1_font.setPointSize( 9 );
    ScaleText_1->setFont( ScaleText_1_font );


    RotY_1 = new QSlider( ControlFrame1, "RotY_1" );
    RotY_1->setGeometry( QRect( 10, 30, 110, 21 ) );
    RotY_1->setOrientation( QSlider::Horizontal );
    RotY_1->setMinValue( -360 );
    RotY_1->setMaxValue( 360 );
    RotYlcd_1 = new QLCDNumber( ControlFrame1, "RotYlcd_1" );
    RotYlcd_1->setGeometry( QRect( 130, 30, 31, 21 ) );
    connect( RotY_1, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );
    connect( RotY_1, SIGNAL(valueChanged(int)), RotYlcd_1, SLOT(display(int)) );


    RotX_1 = new QSlider( ControlFrame1, "RotX_1" );
    RotX_1->setGeometry( QRect( 10, 60, 110, 21 ) );
    RotX_1->setOrientation( QSlider::Horizontal );
    RotX_1->setMinValue( -360 );
    RotX_1->setMaxValue( 360 );
    RotXlcd_1 = new QLCDNumber( ControlFrame1, "RotXlcd_1" );
    RotXlcd_1->setGeometry( QRect( 130, 60, 31, 21 ) );
    connect( RotX_1, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );
    connect( RotX_1, SIGNAL(valueChanged(int)), RotXlcd_1, SLOT(display(int)) );

    RotZ_1 = new QSlider( ControlFrame1, "RotZ_1" );
    RotZ_1->setGeometry( QRect( 10, 90, 110, 21 ) );
    RotZ_1->setOrientation( QSlider::Horizontal );
    RotZ_1->setMinValue( -360 );
    RotZ_1->setMaxValue( 360 );
    RotZlcd_1 = new QLCDNumber( ControlFrame1, "RotZlcd_1" );
    RotZlcd_1->setGeometry( QRect( 130, 90, 31, 21 ) );
    connect( RotZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)) );
    connect( RotZ_1, SIGNAL(valueChanged(int)), RotZlcd_1, SLOT(display(int)) );

    TranX_1 = new QSlider( ControlFrame1, "TranX_1" );
    TranX_1->setGeometry( QRect( 180, 30, 110, 21 ) );
    TranX_1->setOrientation( QSlider::Horizontal );
    TranX_1->setMinValue( -100 );
    TranX_1->setMaxValue( 100 );
    TranXlcd_1 = new QLCDNumber( ControlFrame1, "TranXlcd_1" );
    TranXlcd_1->setGeometry( QRect( 300, 30, 31, 21 ) );
    connect( TranX_1, SIGNAL(valueChanged(int)), this, SLOT(setXTrans(int)) );
    connect( TranX_1, SIGNAL(valueChanged(int)), TranXlcd_1, SLOT(display(int)) );

    TranY_1 = new QSlider( ControlFrame1, "TranY_1" );
    TranY_1->setGeometry( QRect( 180, 60, 110, 21 ) );
    TranY_1->setOrientation( QSlider::Horizontal );
    TranY_1->setMinValue( -100);
    TranY_1->setMaxValue( 100 );
    TranYlcd_1 = new QLCDNumber( ControlFrame1, "TranYlcd_1" );
    TranYlcd_1->setGeometry( QRect( 300, 60, 31, 21 ) );
    connect( TranY_1, SIGNAL(valueChanged(int)), this, SLOT(setYTrans(int)) );
    connect( TranY_1, SIGNAL(valueChanged(int)), TranYlcd_1, SLOT(display(int)) );

    TranZ_1 = new QSlider( ControlFrame1, "TranZ_1" );
    TranZ_1->setGeometry( QRect( 180, 90, 110, 21 ) );
    TranZ_1->setOrientation( QSlider::Horizontal );
    TranZ_1->setMinValue( -100 );
    TranZ_1->setMaxValue( 100 );
    TranZlcd_1 = new QLCDNumber( ControlFrame1, "TranZlcd_1" );
    TranZlcd_1->setGeometry( QRect( 300, 90, 31, 21 ) );
    connect( TranZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZTrans(int)) );
    connect( TranZ_1, SIGNAL(valueChanged(int)), TranZlcd_1, SLOT(display(int)) );

    ScaleX_1 = new QSlider( ControlFrame1, "ScaleX_1" );
    ScaleX_1->setGeometry( QRect( 350, 30, 110, 21 ) );
    ScaleX_1->setOrientation( QSlider::Horizontal );
    ScaleX_1->setMinValue( 0 );
    ScaleX_1->setMaxValue( 50 );
    ScaleXlcd_1 = new QLCDNumber( ControlFrame1, "ScaleXlcd_1" );
    ScaleXlcd_1->setGeometry( QRect( 470, 30, 31, 21 ) );
    connect( ScaleX_1, SIGNAL(valueChanged(int)), this, SLOT(setXScale(int)) );
    connect( ScaleX_1, SIGNAL(valueChanged(int)), ScaleXlcd_1, SLOT(display(int)) );

    ScaleY_1 = new QSlider( ControlFrame1, "ScaleY_1" );
    ScaleY_1->setGeometry( QRect( 350, 60, 110, 21 ) );
    ScaleY_1->setOrientation( QSlider::Horizontal );
    ScaleY_1->setMinValue( 0 );
    ScaleY_1->setMaxValue( 50 );
    ScaleYlcd_1 = new QLCDNumber( ControlFrame1, "ScaleYlcd_1" );
    ScaleYlcd_1->setGeometry( QRect( 470, 60, 31, 21 ) );
    connect( ScaleY_1, SIGNAL(valueChanged(int)), this, SLOT(setYScale(int)) );
    connect( ScaleY_1, SIGNAL(valueChanged(int)), ScaleYlcd_1, SLOT(display(int)) );

    ScaleZ_1 = new QSlider( ControlFrame1, "ScaleZ_1" );
    ScaleZ_1->setGeometry( QRect( 350, 90, 110, 21 ) );
    ScaleZ_1->setOrientation( QSlider::Horizontal );
    ScaleZ_1->setMaxValue( 50 );
    ScaleZ_1->setMinValue( 0 );
    ScaleZlcd_1 = new QLCDNumber( ControlFrame1, "ScaleZlcd_1" );
    ScaleZlcd_1->setGeometry( QRect( 470, 90, 31, 21 ) );
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), this, SLOT(setZScale(int)) );
    connect( ScaleZ_1, SIGNAL(valueChanged(int)), ScaleZlcd_1, SLOT(display(int)) );

    /////////////////////////////////////////////////////////////////////////////
    //world control settings
    ControlFrame4 = new QFrame( fxoptionals_world, "ControlFrame4" );
    ControlFrame4->setGeometry( QRect( 0, 0, 660, 120 ) );

    RotateText_4 = new QLabel( ControlFrame4, "RotateText_4" );
    RotateText_4->setGeometry( QRect( 10, 10, 110, 21 ) );
    RotateText_4->setText( tr( "ROTATE"  ) );
    RotateText_4->setAlignment( int( QLabel::AlignCenter ) );
    QFont RotateText_4_font(  RotateText_4->font() );
    RotateText_4_font.setPointSize( 9 );
    RotateText_4->setFont( RotateText_4_font );

    TranslateText_4 = new QLabel( ControlFrame4, "TranslateText_4" );
    TranslateText_4->setGeometry( QRect( 180, 10, 110, 21 ) );
    TranslateText_4->setText( tr( "TRANSLATE"  ) );
    TranslateText_4->setAlignment( int( QLabel::AlignCenter ) );
    QFont TranslateText_4_font(  TranslateText_4->font() );
    TranslateText_4_font.setPointSize( 9 );
    TranslateText_4->setFont( TranslateText_4_font );

    ScaleText_4 = new QLabel( ControlFrame4, "ScaleText_4" );
    ScaleText_4->setGeometry( QRect( 350, 10, 110, 21 ) );
    ScaleText_4->setText( tr( "ZOOM"  ) );
    ScaleText_4->setAlignment( int( QLabel::AlignCenter ) );
    QFont ScaleText_4_font(  ScaleText_4->font() );
    ScaleText_4_font.setPointSize( 9 );
    ScaleText_4->setFont( ScaleText_4_font );


    RotY_4 = new QSlider( ControlFrame4, "RotY_4" );
    RotY_4->setGeometry( QRect( 10, 30, 110, 21 ) );
    RotY_4->setOrientation( QSlider::Horizontal );
    RotY_4->setMinValue( -180 );
    RotY_4->setMaxValue( 180 );
    RotYlcd_4 = new QLCDNumber( ControlFrame4, "RotYlcd_4" );
    RotYlcd_4->setGeometry( QRect( 130, 30, 31, 21 ) );
    connect( RotY_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldYR(int)) );
    connect( RotY_4, SIGNAL(valueChanged(int)), RotYlcd_4, SLOT(display(int)) );


    RotX_4 = new QSlider( ControlFrame4, "RotX_4" );
    RotX_4->setGeometry( QRect( 10, 60, 110, 21 ) );
    RotX_4->setOrientation( QSlider::Horizontal );
    RotX_4->setMinValue( -180 );
    RotX_4->setMaxValue( 180 );
    RotXlcd_4 = new QLCDNumber( ControlFrame4, "RotXlcd_4" );
    RotXlcd_4->setGeometry( QRect( 130, 60, 31, 21 ) );
    connect( RotX_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldXR(int)) );
    connect( RotX_4, SIGNAL(valueChanged(int)), RotXlcd_4, SLOT(display(int)) );


    RotZ_4 = new QSlider( ControlFrame4, "RotZ_4" );
    RotZ_4->setGeometry( QRect( 10, 90, 110, 21 ) );
    RotZ_4->setOrientation( QSlider::Horizontal );
    RotZ_4->setMinValue( -180 );
    RotZ_4->setMaxValue( 180 );
    RotZlcd_4 = new QLCDNumber( ControlFrame4, "RotZlcd_4" );
    RotZlcd_4->setGeometry( QRect( 130, 90, 31, 21 ) );
    connect( RotZ_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldZR(int)) );
    connect( RotZ_4, SIGNAL(valueChanged(int)), RotZlcd_4, SLOT(display(int)) );

    TranX_4 = new QSlider( ControlFrame4, "TranX_4" );
    TranX_4->setGeometry( QRect( 180, 30, 110, 21 ) );
    TranX_4->setOrientation( QSlider::Horizontal );
    TranX_4->setMinValue( -35 );
    TranX_4->setMaxValue( 35 );
    TranXlcd_4 = new QLCDNumber( ControlFrame4, "TranXlcd_4" );
    TranXlcd_4->setGeometry( QRect( 300, 30, 31, 21 ) );
    connect( TranX_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldXT(int)) );
    connect( TranX_4, SIGNAL(valueChanged(int)), TranXlcd_4, SLOT(display(int)) );

    TranY_4 = new QSlider( ControlFrame4, "TranY_4" );
    TranY_4->setGeometry( QRect( 180, 60, 110, 21 ) );
    TranY_4->setOrientation( QSlider::Horizontal );
    TranY_4->setMinValue( -35 );
    TranY_4->setMaxValue( 35 );
    TranYlcd_4 = new QLCDNumber( ControlFrame4, "TranYlcd_4" );
    TranYlcd_4->setGeometry( QRect( 300, 60, 31, 21 ) );
    connect( TranY_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldYT(int)) );
    connect( TranY_4, SIGNAL(valueChanged(int)), TranYlcd_4, SLOT(display(int)) );

    TranZ_4 = new QSlider( ControlFrame4, "TranZ_4" );
    TranZ_4->setGeometry( QRect( 180, 90, 110, 21 ) );
    TranZ_4->setOrientation( QSlider::Horizontal );
    TranZ_4->setMinValue( -35 );
    TranZ_4->setMaxValue( 35 );
    TranZlcd_4 = new QLCDNumber( ControlFrame4, "TranZlcd_4" );
    TranZlcd_4->setGeometry( QRect( 300, 90, 31, 21 ) );
    connect( TranZ_4, SIGNAL(valueChanged(int)), this, SLOT(setWorldZT(int)) );
    connect( TranZ_4, SIGNAL(valueChanged(int)), TranZlcd_4, SLOT(display(int)) );

    ScaleX_4 = new QSlider( ControlFrame4, "ScaleX_4" );
    ScaleX_4->setGeometry( QRect( 350, 30, 110, 21 ) );
    ScaleX_4->setOrientation( QSlider::Horizontal );
    ScaleX_4->setMinValue( 1 );
    ScaleX_4->setMaxValue( 100 );
    ScaleX_4->setValue( 100 );
    ScaleXlcd_4 = new QLCDNumber( ControlFrame4, "ScaleXlcd_4" );
    ScaleXlcd_4->setGeometry( QRect( 470, 30, 31, 21 ) );
    connect( ScaleX_4, SIGNAL(valueChanged(int)), ScaleXlcd_4, SLOT(display(int)) );
    //connect( ScaleX_4, SIGNAL(valueChanged(int)), c, SLOT(setZoom(int)) );

    GridSelect = new QCheckBox( ControlFrame4, "GridSelect" );
    GridSelect->setGeometry( QRect( 350, 70, 110, 21 ) );
    GridSelect->setText( tr( "titlesafe"  ) );
    connect( GridSelect,  SIGNAL(clicked()), this, SLOT(setTextSafe())  );

    /////////////////////////////////////////////////////////////////////////
    //widget selection sidebar control settings
    ControlFrame = new QFrame( EffectsFrame, "ControlFrame_2" );   //fxoptionals_clipone//
    ControlFrame->setGeometry( QRect( 655, 3, 250, 120 ) );    // was 540

    fxselect = new QWidgetStack(ControlFrame);
    fxselect_clip     = new QHBox(fxselect);
    fxselect_text     = new QHBox(fxselect);
    fxselect_world    = new QHBox(fxselect);

    fxselect->addWidget(fxselect_clip,0);
    fxselect->addWidget(fxselect_text,1);
    fxselect->addWidget(fxselect_world,2);

    fxselect->setGeometry( QRect( 0, 0, 250, 120) );   // was 635

    /////////////// layer options
    ControlFrame5 = new QFrame( fxselect_clip, "ControlFrame4" );
    ControlFrame5->setGeometry( QRect( 0, 0, 40, 120 ) );

    loadimage_1 = new QPushButton( ControlFrame5, "ClipOne_2" );
    loadimage_1->setGeometry( QRect( 0, 10, 110, 25 ) );
    loadimage_1->setText( tr( "Load Image"  ) );
    connect( loadimage_1,  SIGNAL(clicked()), this, SLOT(loadClip())  );

    grabdesktop = new QPushButton( ControlFrame5, "ClipOne_2" );
    grabdesktop->setGeometry( QRect( 0, 40, 110, 25 ) );
    grabdesktop->setText( tr( "Grab Desktop"  ) );
    connect( grabdesktop,  SIGNAL(clicked()), this, SLOT(grabDesktop())  );


  	lighticon	= new QToolButton(ControlFrame5,"lighticon");
    lighticon->setGeometry( QRect( 120, 20, 18, 26 ) );
  	lighticon->setFixedSize(18, 26);
  	//lighticon->setUsesBigPixmap(true);
  	lighticon->setAutoRaise(true);

  	QIconSet	*icoSet;
  	icoSet = new QIconSet(QPixmap((const char**)light_xpm) );
  	icoSet->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Active);
  	icoSet->setPixmap(QPixmap((const char**)light_xpm), QIconSet::Large, QIconSet::Disabled);
  	lighticon->setIconSet(*icoSet);
    delete icoSet;

    light1 = new QCheckBox( ControlFrame5, "light1" );
    light1->setGeometry( QRect( 120, 46, 20, 21 ) );
    connect( light1,  SIGNAL(clicked()), this, SLOT(toggleLight())  );




/////////////////font options
    ControlFrame6 = new QFrame( fxselect_text, "ControlFrame4" );
    ControlFrame6->setGeometry( QRect( 0, 0, 40, 120 ) );

    ScaleText_5 = new QLabel( ControlFrame6, "ScaleText_4" );
    ScaleText_5->setGeometry( QRect( 0, 10, 110, 21 ) );
    ScaleText_5->setText( tr( "EXTRUDE"  ) );
    ScaleText_5->setAlignment( int( QLabel::AlignCenter ) );
    QFont ScaleText_5_font(  ScaleText_5->font() );
    ScaleText_5_font.setPointSize( 9 );
    ScaleText_5->setFont( ScaleText_5_font );

    ScaleX_5 = new QSlider( ControlFrame6, "extrude" );
    ScaleX_5->setGeometry( QRect( 0, 30, 110, 21 ) );
    ScaleX_5->setOrientation( QSlider::Horizontal );
    ScaleX_5->setMinValue( 1 );
    ScaleX_5->setMaxValue( 200 );
    ScaleX_5->setValue( 30 );
    connect( ScaleX_5, SIGNAL(valueChanged(int)), this,    SLOT(setExtrude(int)) );

    textDraw = new QPushButton( ControlFrame6, "draw" );
    textDraw->setGeometry( QRect( 115, 30, 36, 21 ) );
    textDraw->setText( tr( "Draw"  ) );
    connect( textDraw,  SIGNAL(clicked()), this, SLOT(changeFontDraw())  );

    textEd	= new QLineEdit( ControlFrame6, "text" );
    textEd->setGeometry( QRect( 0, 60, 150, 21 ) );
    textEd->setFocus();
    textEd->setText( "jahshaka" );
    connect( textEd, SIGNAL(textChanged(const QString&)), this, SLOT(setText(const QString&)) );

    textFont = new QPushButton( ControlFrame6, "font" );
    textFont->setGeometry( QRect( 0, 90, 55, 21 ) );
    textFont->setText( tr( "Font"  ) );
    connect( textFont,  SIGNAL(clicked()), this, SLOT(loadFont())  );

    textColor = new QPushButton( ControlFrame6, "color" );
    textColor->setGeometry( QRect( 60, 90, 55, 21 ) );
    textColor->setText( tr( "Color"  ) );
    connect( textColor,  SIGNAL(clicked()), this, SLOT(setFontColor())  );
*/

    /*  we want this for the FONTS
    Transparency_1 = new QLabel( ControlFrame5, "ScaleText_2" );
    Transparency_1->setGeometry( QRect( 0, 70, 110, 21 ) );
    Transparency_1->setText( tr( "TRANSPARENCY"  ) );
    Transparency_1->setAlignment( int( QLabel::AlignCenter ) );
    QFont Transparency_1_font(  Transparency_1->font() );
    Transparency_1_font.setPointSize( 9 );
    Transparency_1->setFont( Transparency_1_font );

    Trans_1 = new QSlider( ControlFrame5, "Trans1" );
    Trans_1->setGeometry( QRect( 0, 89, 110, 21 ) );
    Trans_1->setOrientation( QSlider::Horizontal );
    Trans_1->setMinValue( 1 );
    Trans_1->setMaxValue( 100 );
    Trans_1->setValue( 100 );

    Translcd_1 = new QLCDNumber( ControlFrame5, "Translcd_1" );
    Translcd_1->setGeometry( QRect( 120, 89, 31, 21 ) );
    connect( Trans_1, SIGNAL(valueChanged(int)), Translcd_1, SLOT(display(int)) );
    connect( Trans_1, SIGNAL(valueChanged(int)), this, SLOT(setAlpha(int)) );
      */



    // raise the control bar

    // raise backgound as default
    //fxoptionals->raiseWidget(3);
    //fxselect->raiseWidget(0);

}

















