/*******************************************************************************
**
** The source file for the Jahshaka animation selections module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#include "character.h"

void GLChar::addLayer(void)
{

   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;

   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Textured",  6,0 );
    menu->insertItem( "3d Extrude",5,0 );
    menu->insertItem( "Polygon",   4,0 );
    menu->insertItem( "Outline",   3,0 );
    //menu->insertItem( "Pixmap",    2,0 );
    //menu->insertItem( "Bitmap",    1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );

    if ( id != -1 ) {
      if (numberLayers==NUMBER_LAYERS) return;
      numberLayers+=1;

      switch(id) {

         case 1  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
					 layers[numberLayers].text->fontstyle = FBITMAP;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = FALSE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Bitmap", TEXT, JAHTEXT);
                     break; }

         case 2  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
					 layers[numberLayers].text->fontstyle = FPIXMAP;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = FALSE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Pixmap", TEXT, JAHTEXT);
                     break; }


         case 3  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
					 layers[numberLayers].text->fontstyle = FOUTLINE;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = FALSE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Outline", TEXT, JAHTEXT);
                     break; }

         case 4  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
					 layers[numberLayers].text->fontstyle = FPOLYGON;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = FALSE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Polygon", TEXT, JAHTEXT);
                     break; }

         case 5  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
                     layers[numberLayers].text->extrude = 20.0;
					 layers[numberLayers].text->fontstyle = FEXTRUDE;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = TRUE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Extrude", TEXT, JAHTEXT);
                     break; }

         case 6  : { layers[numberLayers].addTextObj();
                     layers[numberLayers].text->text = "jahshaka";
                     layers[numberLayers].text->font = "fonts/arial.ttf";
					 layers[numberLayers].text->fontstyle = FTEXTURE;
                     layers[numberLayers].node->sx = layers[numberLayers].node->sy = layers[numberLayers].node->sz = 5.0; //layers[numberLayers].node->sc = 5.0;
                     layers[numberLayers].lighting = FALSE; layers[numberLayers].depth = TRUE;
                     createLayer(numberLayers,"Textured", TEXT, JAHTEXT);
                     break; }



         default  :  {  break; }

      }
    } else { added = FALSE;}


    delete menu;

   if (added) {  addSelection(); objectMenu(numberLayers); updateSliders(); }

}





void GLChar::changeFontDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Textured",  6,0 );
    menu->insertItem( "3d Extrude",5,0 );
    menu->insertItem( "Polygon",   4,0 );
    menu->insertItem( "Outline",   3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( textDraw->mapToGlobal( QPoint( 0, textDraw->height() + 1 ) ) );

    if ( id != -1 ) {
      switch(id) {
                case 3  :  layers[activeLayer].text->fontstyle = FOUTLINE;    break;
                case 4  :  layers[activeLayer].text->fontstyle = FPOLYGON;    break;
                case 5  :  layers[activeLayer].text->fontstyle = FEXTRUDE;    break;
                case 6  :  layers[activeLayer].text->fontstyle = FTEXTURE;    break;
                default :                                                     break;
      }
    }

    delete menu;
    updateGL();  //redraw scene
}















