/*******************************************************************************
**
** The source file for the Jahshaka jahdesktop code
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

////////////////////////////////////////////////////////////////
// This is the file that sets up  the desktop interface
// and connects it to the routines

#include "jahcreate.h"


void JahControl::CreateDesktopFeedbackBox(QFrame* frame) {

  QLabel * label = new QLabel(frame);

  label->setGeometry( QRect( 20, 10, 90, 25 ) );
  label->setText( "JahShaka 1.9" );
  //label->setAlignment( int( QLabel::AlignCenter ) );
  QFont label_font(  label->font() );
  label_font.setPointSize( 10 );
  label->setFont( label_font );

  //Create the feedback bar here
  TextView1_2 = new QTextView( frame, "TextView1_2" );
  TextView1_2->setGeometry( QRect( 130, 10, 600, 25 ) );
  TextView1_2->setResizePolicy( QTextView::Manual );
  TextView1_2->setDragAutoScroll( FALSE );
  TextView1_2->setHScrollBarMode( QTextView::AlwaysOff );
  TextView1_2->setVScrollBarMode( QTextView::AlwaysOff );
  TextView1_2->setText( tr( " Jahshaka Media Integrator"  ) );
  QFont TextView1_2_font(  TextView1_2->font() );
  TextView1_2_font.setPointSize( 10 );
  TextView1_2_font.setBold( TRUE );
  TextView1_2->setFont( TextView1_2_font );
  TextView1_2->setTextFormat( QTextView::RichText );

  //these buttons work in tandem for get and return of images from modules
  GetButton = new QPushButton( frame, "GetButton" );
  GetButton->setGeometry( QRect( 770, 10, 100, 25 ) );
  GetButton->setText( tr( "Get Desktop"  ) );
  connect( GetButton,  SIGNAL(clicked()), SLOT( GetDesktop())  );
  GetButton->hide();

  ReturnButton = new QPushButton( frame, "GetButton" );
  ReturnButton->setGeometry( QRect( 770, 10, 100, 25 ) );
  ReturnButton->setText( tr( "Return"  ) );
  ReturnButton->setPalette( QPalette( QColor(255, 25, 25) ) );
  connect( ReturnButton,  SIGNAL(clicked()), SLOT( ReturnDesktop())  );
  ReturnButton->hide();

}

void JahControl::CreateDesktopOptions(QHBox* frame) {

  desktopframe1 = new QFrame(frame);

  SubLoad = new QPushButton( desktopframe1, "Load" );
  SubLoad->setGeometry( QRect( 65, 10, 86, 25 ) );
  SubLoad->setText( tr( "Load"  ) );
  connect( SubLoad, SIGNAL(clicked()), thedesktop, SLOT( slotLoad()) );

  SubSave = new QPushButton( desktopframe1, "Save" );
  SubSave->setGeometry( QRect( 65, 40, 86, 25 ) );
  SubSave->setText( tr( "Save"  ) );
  connect( SubSave, SIGNAL(clicked()), thedesktop, SLOT( slotSave()) );

  SubPref = new QPushButton( desktopframe1, "Prefs" );
  SubPref->setGeometry( QRect( 65, 100, 86, 25 ) );
  SubPref->setText( tr( "Preferences"  ) );
  connect( SubPref,  SIGNAL(clicked()), SLOT(changeModePref())  );

  desktopframe2 = new QFrame(frame);

  SubImport = new QPushButton( desktopframe2, "Import" );
  SubImport->setGeometry( QRect( 65, 10, 86, 25 ) );
  SubImport->setText( tr( "Import"  ) );
  //connect( SubQuit, SIGNAL(clicked()), qApp, SLOT( quit()) );

  SubExport = new QPushButton( desktopframe2, "Export" );
  SubExport->setGeometry( QRect( 65, 40, 86, 25 ) );
  SubExport->setText( tr( "Export"  ) );
  //connect( SubQuit, SIGNAL(clicked()), qApp, SLOT( quit()) );

  SubVideo = new QPushButton( desktopframe2, "videoio" );
  SubVideo->setGeometry( QRect( 65, 100, 86, 25 ) );
  SubVideo->setText( tr( "Video I/O"  ) );
  //connect( SubVideo,  SIGNAL(clicked()), SLOT(changeModeVideoIO())  );

  desktopframe3 = new QFrame(frame);

  SubColor = new QPushButton( desktopframe3, "colormodule" );
  SubColor->setGeometry( QRect( 65, 10, 86, 25 ) );
  SubColor->setText( tr( "Colorize"  ) );
  connect( SubColor,  SIGNAL(clicked()), SLOT(changeModeColorize())  );

  Network = new QPushButton( desktopframe3, "Network" );
  Network->setGeometry( QRect( 65, 40, 86, 25 ) );
  Network->setText( tr( "Network"  ) );
  connect( Network,  SIGNAL(clicked()), SLOT(changeModeNetwork())  );

  // Library = new QPushButton( desktopframe3, "Library" );     //change button code name to paint
  // Library->setGeometry( QRect( 65, 100, 86, 25 ) );
  // Library->setText( tr( "Library"  ) );
  //connect( Network,  SIGNAL(clicked()), SLOT(changeModeNetwork())  );

  desktopframe4 = new QFrame(frame);

  SubLoadImg = new QPushButton( desktopframe4, "Delete" );
  SubLoadImg->setGeometry( QRect( 65, 10, 86, 25 ) );
  SubLoadImg->setText( tr( "Delete"  ) );
  connect( SubLoadImg, SIGNAL(clicked()), thedesktop, SLOT( clearItem()) );

  SubSaveImg = new QPushButton( desktopframe4, "Clear" );
  SubSaveImg->setGeometry( QRect( 65, 40, 86, 25 ) );
  SubSaveImg->setText( tr( "ClearAll"  ) );
  connect( SubSaveImg, SIGNAL(clicked()), thedesktop, SLOT( clearAll()) );

  SubQuit = new QPushButton( desktopframe4, "Quit" );
  SubQuit->setGeometry( QRect( 65, 100, 86, 25 ) );
  SubQuit->setText( tr( "Quit"  ) );
  connect( SubQuit, SIGNAL(clicked()), qApp, SLOT( quit()) );

}





void JahControl::CreateDesktopMiddleFrame(QHBox* frame) {

  page = new QWidget( frame, "page" );
  pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
  QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer );

  modeselectframe = new QFrame( page, "modeselectframe" );
  modeselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, modeselectframe->sizePolicy().hasHeightForWidth() ) );
  modeselectframe->setMinimumSize( QSize( 100, 20 ) );
  modeselectframe->setMaximumSize( QSize( 100, 20 ) );
  modeselectframe->setFrameShape( QFrame::StyledPanel );
  modeselectframe->setFrameShadow( QFrame::Raised );

  modeselectbutton = new QPushButton( modeselectframe, "modeselectbutton" );
  modeselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
  modeselectbutton->setMinimumSize( QSize( 100, 20 ) );
  modeselectbutton->setMaximumSize( QSize( 100, 20 ) );
  modeselectbutton->setText( tr( "Mode"  ) );
  connect( modeselectbutton,  SIGNAL(clicked()), SLOT( switchMode())  );

  pageLayout->addWidget( modeselectframe );
  QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_2 );

  buttonframe = new QFrame( page, "buttonframe" );
  buttonframe->setMinimumSize( QSize( 600, 30 ) );
  buttonframe->setMaximumSize( QSize( 600, 30 ) );
  buttonframe->setFrameShape( QFrame::NoFrame );
  buttonframe->setFrameShadow( QFrame::Plain );

  DesktopName = new QPushButton( ( QIconSet( QPixmap("Pixmaps/name.xpm")) ), "Name", buttonframe, "name" );
  DesktopName->setGeometry( QRect( 0, 2, 150, 28 ) );
  DesktopName->setMinimumSize( QSize( 150, 0 ) );
  DesktopName->setMaximumSize( QSize( 150, 32767 ) );
  connect ( DesktopName,    SIGNAL(clicked()), this, SLOT( nameClip()) );
  //nameClip connects DesktopName to the fancy popup...
  popup2 = new FancyPopup( buttonframe, "Enter Clipname",250,130 );  //send size and position as well
  connect ( popup2,      SIGNAL( returnText(QString)), this, SLOT( printnameClip(QString)) );

  DesktopLoad = new QPushButton( ( QIconSet( QPixmap("Pixmaps/open.xpm")) ), "Load Clip", buttonframe, "load" );
  DesktopLoad->setGeometry( QRect( 150, 2, 150, 28 ) );
  DesktopLoad->setMinimumSize( QSize( 150, 0 ) );
  DesktopLoad->setMaximumSize( QSize( 150, 32767 ) );
  connect( DesktopLoad,  SIGNAL(clicked()), thedesktop, SLOT(slotLoad())  );  //this slot is located in desktop.h

  DesktopPlay = new QPushButton( ( QIconSet( QPixmap("Pixmaps/play.xpm")) ), "Play Clip", buttonframe, "play" );
  DesktopPlay->setGeometry( QRect( 300, 2, 150, 28 ) );
  DesktopPlay->setMinimumSize( QSize( 150, 0 ) );
  DesktopPlay->setMaximumSize( QSize( 150, 32767 ) );
  connect( DesktopPlay,  SIGNAL(clicked()), SLOT(changeModePlayer())  );    //this is located in jahcontrol

  DeleteButton = new QPushButton( ( QIconSet( QPixmap("Pixmaps/delete.xpm")) ), "Delete", buttonframe, "play" );
  DeleteButton->setGeometry( QRect( 450, 2, 150, 28 ) );
  DeleteButton->setMinimumSize( QSize( 150, 0 ) );
  DeleteButton->setMaximumSize( QSize( 150, 32767 ) );
  connect ( DeleteButton,  SIGNAL(clicked()), thedesktop, SLOT( clearItem()) );

  pageLayout->addWidget( buttonframe );

  QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_3 );

  desktopselectframe = new QFrame( page, "desktopselectframe" );
  desktopselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, desktopselectframe->sizePolicy().hasHeightForWidth() ) );
  desktopselectframe->setMinimumSize( QSize( 100, 20 ) );
  desktopselectframe->setMaximumSize( QSize( 100, 20 ) );
  desktopselectframe->setFrameShape( QFrame::StyledPanel );
  desktopselectframe->setFrameShadow( QFrame::Raised );

  desktopselectbutton = new QPushButton( desktopselectframe, "desktopselectbutton" );
  desktopselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
  desktopselectbutton->setMinimumSize( QSize( 100, 20 ) );
  desktopselectbutton->setMaximumSize( QSize( 100, 20 ) );
  desktopselectbutton->setText( tr( "Desktop"  ) );
  connect( desktopselectbutton,  SIGNAL(clicked()), SLOT( switchDesktop())  );

  pageLayout->addWidget( desktopselectframe );
  QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_4 );

}

void JahControl::CreateDesktopPreferences(QHBox* frame) {

  prefframe1 = new QFrame(frame);

  QLabel * label = new QLabel(prefframe1);
  label->setGeometry( QRect( 65, 2, 200, 12 ) );
  label->setText( "INTERFACE" );
  label->setAlignment( int( QLabel::AlignCenter ) );
  QFont label_font(  label->font() );
  label_font.setPointSize( 10 );
  label->setFont( label_font );

  Pref1 = new QPushButton( prefframe1, "Platinum" );
  Pref1->setGeometry( QRect( 65, 20, 86, 25 ) );
  Pref1->setText( tr( "Platinum"  ) );
  connect( Pref1, SIGNAL(clicked()),  SLOT(stylePlatinum()) );

  Pref2 = new QPushButton( prefframe1, "SGI" );
  Pref2->setGeometry( QRect( 65, 50, 86, 25 ) );
  Pref2->setText( tr( "SGI"  ) );
  connect( Pref2, SIGNAL(clicked()),  SLOT(styleSgi()) );

  Pref3 = new QPushButton( prefframe1, "Motif" );
  Pref3->setGeometry( QRect( 65, 80, 86, 25 ) );
  Pref3->setText( tr( "CDE"  ) );
  connect( Pref3,  SIGNAL(clicked()), SLOT(styleCde()) );

  Pref4 = new QPushButton( prefframe1, "Windows" );
  Pref4->setGeometry( QRect( 65, 110, 86, 25 ) );
  Pref4->setText( tr( "Windows"  ) );
  connect( Pref4,  SIGNAL(clicked()), SLOT(styleWindows()) );

  PrefCol1 = new QPushButton( prefframe1, "Grey" );
  PrefCol1->setGeometry( QRect( 165, 20, 86, 25 ) );
  PrefCol1->setText( tr( "Grey"  ) );
  connect( PrefCol1, SIGNAL(clicked()),  SLOT(styleGrey()) );

  PrefCol2 = new QPushButton( prefframe1, "Blue" );
  PrefCol2->setGeometry( QRect( 165, 50, 86, 25 ) );
  PrefCol2->setText( tr( "Blue"  ) );
  connect( PrefCol2, SIGNAL(clicked()),  SLOT(styleBlue()) );

  PrefCol3 = new QPushButton( prefframe1, "Green" );
  PrefCol3->setGeometry( QRect( 165, 80, 86, 25 ) );
  PrefCol3->setText( tr( "Green"  ) );
  connect( PrefCol3,  SIGNAL(clicked()), SLOT(styleGreen()) );

  PrefCol4 = new QPushButton( prefframe1, "White" );
  PrefCol4->setGeometry( QRect( 165, 110, 86, 25 ) );
  PrefCol4->setText( tr( "White"  ) );
  connect( PrefCol4,  SIGNAL(clicked()), SLOT(styleWhite()) );  //change to signal...?

  prefframe2 = new QFrame(frame);

  QLabel * label2 = new QLabel(prefframe2);
  label2->setGeometry( QRect( 65, 2, 300, 12 ) );
  label2->setText( "SETTINGS" );
  label2->setAlignment( int( QLabel::AlignCenter ) );
  QFont label_font2(  label2->font() );
  label_font2.setPointSize( 10 );
  label2->setFont( label_font2 );

  QLabel * label3 = new QLabel(prefframe2);
  label3->setGeometry( QRect( 65, 20, 100, 15 ) );
  label3->setText( "Media Storage" );
  label3->setAlignment( int( QLabel::AlignLeft ) );
  QFont label_font3(  label3->font() );
  label_font3.setPointSize( 10 );
  label3->setFont( label_font2 );


  StorageBox	= new QLineEdit( prefframe2, "mediapath" );
  StorageBox->setGeometry( QRect( 65, 50, 220, 25) );
  StorageBox->setFocus();
  StorageBox->setText( JahBasePath );

  StorageButton = new QPushButton( prefframe2, "updatepath" );
  StorageButton->setGeometry( QRect( 65, 80, 86, 25 ) );
  StorageButton->setText( tr( "Set"  ) );
  connect( StorageButton, SIGNAL(clicked()),  SLOT(setStoragePath()) );

  QLabel * label4 = new QLabel(prefframe2);
  label4->setGeometry( QRect( 65, 110, 100, 15 ) );
  label4->setText( "Render Quality" );
  label4->setAlignment( int( QLabel::AlignLeft ) );
  QFont label_font4(  label4->font() );
  label_font4.setPointSize( 10 );
  label4->setFont( label_font2 );


  renderqualityslider = new QSlider( prefframe2, "renderqualityslider" );
  renderqualityslider->setStyle( new QPlatinumStyle );
  renderqualityslider->setGeometry( QRect( 65, 130, 220, 25 ) );
  renderqualityslider->setOrientation( QSlider::Horizontal );
  renderqualityslider->setTickmarks( QSlider::Right );
  renderqualityslider->setMinValue( 0 );
  renderqualityslider->setMaxValue( 2 );

  //check prefs and read in renderquality
  renderqualityslider->setValue   ( jahrenderquality );

  //connect( renderqualityslider,   SIGNAL(sliderMoved(int)),    SLOT(updateanimframe(int)) );
  //connect( renderqualityslider,   SIGNAL(sliderPressed()),     SLOT(sliderselected()) );
  //we only update when they release
  connect( renderqualityslider,   SIGNAL(sliderReleased()),    SLOT(setGlobalRenderQuality()) );


  prefframe3 = new QFrame(frame);

  QCheckBox * StartupScreen = new QCheckBox( prefframe3, "Grid" );
  StartupScreen->setGeometry( QRect( 65, 20, 200, 12 ) );
  StartupScreen->setText( "Startup Screen" );
  //connect( GridSelect,  SIGNAL(clicked()), this, SLOT(setGrid())  );


  PositionPrefs = new QCheckBox( prefframe3, "prefs" );
  PositionPrefs->setGeometry( QRect( 65, 60, 200, 12 ) );
  PositionPrefs->setText( "Remember Interface" );
  connect( PositionPrefs,  SIGNAL(clicked()), this, SLOT(setGlobalPositionSize())  );

  //update remember prefs setting
  PositionPrefs->setChecked(rememberprefs);

  PrefExit = new QPushButton( prefframe3, "Exit" );
  PrefExit->setGeometry( QRect( 65, 105, 86, 25 ) );
  PrefExit->setText( tr( "Return"  ) );
  connect( PrefExit,  SIGNAL(clicked()), SLOT(changeModeDesktop())  );


}



