/*******************************************************************************
**
** The source file for the Jahshaka Jahroutines module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

// These are all the routines used by the jahcontrol class

#include "jahcreate.h"


void JahControl::addImageToDesktop( videoData thedata ) {

if (JAHDEBUG) debug(">>adding image to desktop<<");

    thedesktop->addImage2(thedata);
    thedesktop->doRefresh();

    thedesktop->addImage2database(thedata);

}




void JahControl::checkClearPlayer() {    if (  (module == PLAYER) )  vidplayer->ClearOut();  }

void JahControl::changeModePref() {    optionals->raiseWidget(8); }

void JahControl::stopAnimation() {    //stop playback in other modules

     switch(module) {

        case ANIMATION    : { animation->stopanimation();   break; }
        case PLAYER       : { vidplayer->StopPlayer();
                              break; }
        case EDITING      : { editing->stopanimation();     break; }
        case EFFECTS      : { effects->stopanimation();     break; }
        case TEXTCG       : { text->stopanimation();        break; }

        default           : { debug("unknown module in JahRoutines:stopAnimation"); break; }

      }

 }

void JahControl::changeModeDesktop() {

	if (module != DESKTOP) stopAnimation();

  module = DESKTOP;      TextView1_2->setText( tr( " Jahshaka Media Integrator"  ) );
  checkClearPlayer();    checkDesktopButton(); GetButton->hide();

  WorldLayout->raiseWidget(0);        optionals->raiseWidget(0);
  MainControler->raiseWidget(0);
  MainLeftControler->raiseWidget(0);  MainRightControler->raiseWidget(0);         //raise the desktop controller on startup

}

void JahControl::changeModePlayer() {

  stopAnimation();

  //clear the player
  vidplayer->ClearOut();

  module = PLAYER;  QString name; name = " Jahshaka Video Player : ";

  name = name.append(thedesktop->getClipname());       //add clip name to title text
  TextView1_2->setText( name );

  videoData theclip = thedesktop->getVideoData();

  WorldLayout->raiseWidget(1);


  optionals->raiseWidget(1); MainControler->raiseWidget(1);

    if( !(theclip.Image.isNull() ) ) {                     //temp workaround for desktop images vs file based clips

      if(theclip.theCategory==IMAGE) { vidplayer->GrabImage(theclip.Image); }
     // if(theclip.theCategory==IMAGE) { vidplayer->LoadMySequence(theclip);  }
      if(theclip.theCategory==CLIP)  { vidplayer->LoadMySequence(theclip);  }
    }
}

//this was added for siggraph demo to refresh player on demand from a module
void JahControl::displayClipInPlayer(videoData thedata ) {
    vidplayer->ClearOut();
    if( !(thedata.Image.isNull() ) ) {                     //temp workaround for desktop images vs file based clips

      if(thedata.theCategory==IMAGE) { vidplayer->GrabImage(thedata.Image); }
     // if(theclip.theCategory==IMAGE) { vidplayer->LoadMySequence(theclip);  }
      if(thedata.theCategory==CLIP)  { vidplayer->LoadMySequence(thedata);  }
    }

}



void JahControl::changeModeNetwork() {

  module = NETWORK;
  optionals->raiseWidget(2);

}

void JahControl::changeModeAnimation() {

	if (module != ANIMATION) stopAnimation();

  module = ANIMATION;      TextView1_2->setText( tr( " Jahshaka Animation Module"  ) );
  checkClearPlayer();   checkDesktopButton();

  WorldLayout->raiseWidget(3);        optionals->raiseWidget(3);
  MainControler->raiseWidget(3);
  MainLeftControler->raiseWidget(3);  MainRightControler->raiseWidget(3);

  animation->makeCurrent();
  animation->updateGL();
}

void JahControl::changeModeEffects() {    // the effects module

	if (module != EFFECTS) stopAnimation();

  module = EFFECTS;  TextView1_2->setText( tr( " Jahshaka Effects Module"  ) );
  checkClearPlayer(); checkDesktopButton();

  WorldLayout->raiseWidget(4);        optionals->raiseWidget(4);
  MainControler->raiseWidget(4);
  MainLeftControler->raiseWidget(4);  MainRightControler->raiseWidget(4);

  effects->makeCurrent();
  effects->updateGL();
}

void JahControl::changeModeEditing() {

	if (module != EDITING) stopAnimation();

    module = EDITING; TextView1_2->setText( tr( " Jahshaka Editing Module"  ) );
    checkClearPlayer();   checkDesktopButton();

    WorldLayout->raiseWidget(5);     optionals->raiseWidget(5);
    MainControler->raiseWidget(5);
    MainLeftControler->raiseWidget(5);  MainRightControler->raiseWidget(5);

  editing->makeCurrent();
  editing->updateGL();
}

void JahControl::changeModePaint() {

	if (module != PAINT) stopAnimation();

    module = PAINT;  TextView1_2->setText( tr( " Jahshaka Paint Module"  ) );
    checkClearPlayer();  checkDesktopButton();

    WorldLayout->raiseWidget(6); optionals->raiseWidget(6);
    MainControler->raiseWidget(6);
    MainLeftControler->raiseWidget(6);  MainRightControler->raiseWidget(6);

    paint->refreshGL();

}

void JahControl::changeModeText() {

	if (module != TEXTCG) stopAnimation();

    module = TEXTCG;     TextView1_2->setText( tr( " Jahshaka Text Module"  ) );
    checkClearPlayer();  checkDesktopButton();

    WorldLayout->raiseWidget(7); optionals->raiseWidget(7);
    MainControler->raiseWidget(7);
    MainLeftControler->raiseWidget(7);  MainRightControler->raiseWidget(7);

  text->makeCurrent();
  text->updateGL();
}

void JahControl::changeModeColorize() {

	stopAnimation();

    module = COLORIZE;    TextView1_2->setText( tr( " Jahshaka Color Module"  ) );
    checkClearPlayer();  checkDesktopButton();

    WorldLayout->raiseWidget(10); optionals->raiseWidget(10);
    MainControler->raiseWidget(10);
    MainLeftControler->raiseWidget(10);  MainRightControler->raiseWidget(10);

  colorize->makeCurrent();
  colorize->updateGL();
}


//checks the get/return button on the desktops status
void JahControl::checkDesktopButton() {
	
	if (JAHDEBUG) { debug("checking button status"); }

	if ( desktopButtonStatus ) { ReturnButton->hide(); GetButton->show(); }
      else GetButton->show();

}


////////////////////////////////////////////////////////////
// routines to send clips from desktop to modules

void JahControl::GetDesktop() {
    if (module==DESKTOP) return;
    desktopButtonStatus = TRUE;
    GetButton->hide(); ReturnButton->show();

    WorldLayout->raiseWidget(0);    MainControler->raiseWidget(0);

}

void JahControl::ReturnDesktop() {
    desktopButtonStatus = TRUE; checkDesktopButton();

    //switch on module for the return    are we using mode or module?
      switch(module) {

         case ANIMATION :  { if (JAHDEBUG) debug("returnDesktop ANIMATION");
                           GrabClipAnim();
                           WorldLayout->raiseWidget(3); optionals->raiseWidget(3); MainControler->raiseWidget(3);
                           break; }

         case EFFECTS   :  { if (JAHDEBUG) debug("returnDesktop EFFECT");
                           GrabClipEffects();
                           WorldLayout->raiseWidget(4); optionals->raiseWidget(4); MainControler->raiseWidget(4);
                           break; }

         case EDITING   :  { if (JAHDEBUG) debug("returnDesktop EDITING");
                           GrabClipEdit();
                           WorldLayout->raiseWidget(5); optionals->raiseWidget(5); MainControler->raiseWidget(5);
                           break; }


        case TEXTCG     :  { if (JAHDEBUG) debug("returnDesktop TEXT");
                           GrabClipCG();
                           WorldLayout->raiseWidget(7); optionals->raiseWidget(7); MainControler->raiseWidget(7);
                           break; }

        case PAINT      :  { if (JAHDEBUG) debug("returnDesktop PAINT");
                           GrabClipPaint();
                           WorldLayout->raiseWidget(6); optionals->raiseWidget(6); MainControler->raiseWidget(6);
                           paint->refreshGL(); break; }

        case COLORIZE  : { if (JAHDEBUG) debug("returnDesktop Colorize");
                           GrabClipColorize();
                           WorldLayout->raiseWidget(10); optionals->raiseWidget(10); MainControler->raiseWidget(10);
                           break; }


        default  :       {  break; }

      }

}

//this is how we add the clip to the imaging module
void JahControl::GrabClipAnim()    {    videoData newclip = thedesktop->getVideoData();    animation->addClip(newclip);}

void JahControl::GrabClipEffects() {    videoData newclip = thedesktop->getVideoData();    effects->addClip(newclip); }

void JahControl::GrabClipEdit()    {    videoData newclip = thedesktop->getVideoData();    editing->addClip(newclip); }

void JahControl::GrabClipAnimKey() {    videoData newclip = thedesktop->getVideoData();    animation->addClipKey(newclip);}

void JahControl::GrabClipCG()      {    videoData newclip = thedesktop->getVideoData();    text->addClip(newclip);}

void JahControl::GrabClipColorize(){    videoData newclip = thedesktop->getVideoData();    colorize->addClip(newclip);}

void JahControl::GrabClipPaint()   {    videoData newclip = thedesktop->getVideoData();    paint->addClip(newclip); }

void JahControl::GrabClipNetwork() {    videoData newclip = thedesktop->getVideoData();    jahnetwork->addClip(newclip,globalclipnumber); }

void JahControl::nameClip() {  if (globalclipnumber>0) popup2->popup(DesktopName);}

//check to see if a clip is selected first or we crash!
void JahControl::printnameClip(QString item) {
  debug("naming clip:"+item);
	//grab the current desktop clip
	videoData data; data=thedesktop->getVideoData();

	//find out what is its number
	if (JAHDEBUG) data.printinfo();
	int clipnum = data.clipnumber;

	//if its a good number ie >0 continue
	if (clipnum>0) {
		thedesktop->setClipname(item);

		//then update the database
		thedesktop->renameImageindatabase( clipnum, item);

    //force a full refresh
    thedesktop->doRefresh();
	}

}


void JahControl::switchMode(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;
   //need a global mode variable to track the main mode...

   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Web",3,0 );
    menu->insertItem( "Audio",2,0 );
    menu->insertItem( "Video",1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( modeselectbutton->mapToGlobal( QPoint( 0, modeselectbutton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {
      //if (numberLayers==NUMBER_LAYERS) return;
      //numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {
         case 1  : { break; }
         case 2  : { break; }
         case 3  : { break; }
         default  :  {  break; }
      }
    } else { added = FALSE;}

    delete menu;

  // if (added) {  addSelection(); }

}


void JahControl::switchDesktop(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;
   //need a global mode variable to track the main mode...

   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( ">> add new",2,0 );
    menu->insertItem( "Desktop 1",1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( desktopselectbutton->mapToGlobal( QPoint( 0, desktopselectbutton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {
      //if (numberLayers==NUMBER_LAYERS) return;
      //numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {
         case 1  : { break; }
         case 2  : { break; }
         case 3  : { break; }
         default  :  {  break; }

      }
    } else { added = FALSE;}

    delete menu;

  // if (added) {  addSelection(); }

}













