/*******************************************************************************
**
** The source file for the Jahshaka Jahstyle module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "jahcreate.h"


////////////////////////////////////////////////
// application interface themes and colors

void JahControl::stylePlatinum() {

    qApp->setStyle( new QPlatinumStyle );
    QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
    qApp->flushX();
}

void JahControl::styleWindows()  {
    qApp->setStyle( new QWindowsStyle );
    QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
    qApp->flushX();
}

void JahControl::styleSgi()  {
    qApp->setStyle( new QSGIStyle );
    QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
    qApp->flushX();
}

void JahControl::styleMotif() {
    qApp->setStyle( new QMotifStyle );
   QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
   qApp->flushX();
}

void JahControl::styleCde()
{
   qApp->setStyle( new QCDEStyle );
   QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
   qApp->flushX();
}


/////////////////////////////////////////////////////////
//Color styles
//needs to be rewritten using commented out example below
//as we are using base colors

void JahControl::styleGrey() {
    QPalette p( QColor( 100, 100, 100 ) );
    emit emitStyleColor(p);
}


void JahControl::styleGreen() {
    QPalette p( QColor( 20, 200, 20 ) );
    emit emitStyleColor(p);

}

void JahControl::styleWhite() {
    QPalette p( QColor( 200, 200, 200 ) );
    emit emitStyleColor(p);
}

void JahControl::styleBlue() {
    QPalette p( QColor( 100, 100, 200 ) );
    emit emitStyleColor(p);
}

/*

//this uses pixmpas as well...
void JahControl::styleBlue() {


    QColor gold("#B9B9A5A54040"); //same as topgrad below
    QPixmap button( 1, 1 ); button.fill( gold );

    QPixmap background("/root/jahshaka/Pixmaps/light.xpm");
    QPixmap dark( 1, 1 ); dark.fill( red.dark() );
    QPixmap mid( "/root/jahshaka/Pixmaps/light.xpm" );
    QPixmap light( "/root/jahshaka/Pixmaps/light.xpm");//1, 1 ); light.fill( green );

    QPalette op = qApp->palette();

    QColor backCol( 227,227,227 );

    // QPalette op(white);
    QColorGroup active (op.active().foreground(),
                     QBrush(op.active().button(),button),
                     QBrush(op.active().light(), light),
                     QBrush(op.active().dark(), dark),
                     QBrush(op.active().mid(), mid),
                     op.active().text(),
                     Qt::white,
                     op.active().base(),//                   QColor(236,182,120),
                     QBrush(backCol, background)
                     );
    active.setColor( QColorGroup::ButtonText,  Qt::white  );
    active.setColor( QColorGroup::Shadow,  Qt::black  );
    QColorGroup disabled (op.disabled().foreground(),
                     QBrush(op.disabled().button(),button),
                     QBrush(op.disabled().light(), light),
                     op.disabled().dark(),
                     QBrush(op.disabled().mid(), mid),
                     op.disabled().text(),
                     Qt::white,
                     op.disabled().base(),//                 QColor(236,182,120),
                     QBrush(backCol, background)
                     );

    QPalette newPalette( active, disabled, active );
    emit emitStyleColor(newPalette);

}
*/








