
/*******************************************************************************
**              J A H S H A K A   I M A G E   I N T E G R A T O R              *
**                                                                             *
**                                                                             *
**                        http://www.jahshaka.com                              *
**                                                                             *
** Created:  Fri Dec 1 23:53:52 2000                                           *
**      by:  Jah Shaka                                                         *
**   email:  jahshaka@users.sourceforge.net                                    *
**                                                                             *
** Copyright (C) 2000-2003 VisualMedia, LLC.                                   *
**                                                                             *
** This program is free software which we release under the GNU General Public *
** License. You may redistribute and/or modify this program under the terms    *
** of that license as published by the Free Software Foundation; either        *
** version 2 of the License, or (at your option) any later version.            *
**                                                                             *
** This program is distributed in the hope that it will be useful,             *
** but WITHOUT ANY WARRANTY; without even the implied warranty of              *
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
** GNU General Public License for more details.                                *
**                                                                             *
** To get a copy of the GNU General Puplic License, write to the Free Software *
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
**                                                                             *
*******************************************************************************/

#include <qapplication.h>
#include <main.h>

extern int  X_RESOLUTION = 720;
extern int  Y_RESOLUTION = 486;

//for debugging purposes
extern bool JAHDEBUG     = 0;

//this is now the media path as base path is no longer needed
extern QString JahBasePath  = 0;

//uncomment for spaceball support
//#define SPACEBALL


int main(int argc, char** argv) {


  QApplication::setColorSpec( QApplication::ManyColor );

#ifdef SPACEBALL
  App app(argc,argv);
#else
  QApplication app(argc,argv);
#endif

  ///////////////////////////////////////////////
  // Check for OpenGL support before starting
  if ( !QGLFormat::hasOpenGL() ) {
      qWarning( "This system has no OpenGL support. Exiting." );
      return -1;
  };

  ///////////////////////////////////////////////
  // Create the Main object and Launch
  Jah jahshaka;

  //check to see if we can initialize spaceball
  #ifdef SPACEBALL
  if ( !MagellanInit( jahshaka.x11AppDisplay(), jahshaka.winId() ) ) {
         debug("No Spaceball Driver running.");
  };
  #endif

  app.setMainWidget(&jahshaka);
  jahshaka.show();

  return app.exec();


}

