/*******************************************************************************
**
** The source file for the Jahshaka desktop module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "desktop.h"

//#include "tga.h"

///////////////////////////////////////////////////////
// loader routine for the desktop
// loads images and image sequences(Clips)
// need to add support for quicktime and avi
// also need to add targe32 support via qt

void JahDesktop::slotLoad() {
//    QImageIO::defineIOHandler ( "TGA","^TGA",0, &kimgio_tga_read, &kimgio_tga_write );

  //necessary variables
  videoData thedata;

  int		maxFrames = 99999; //maximum number of frames allowed due to current extension filename limitations
  int		i,index;
  bool	ok;
  FILE	*check;
  QString extension, data1;

  QImage  image;
  QPixmap buffer;

  //ask user for file now
  QString filename = QFileDialog::getOpenFileName( JahBasePath+"media", "*.*" , this );
  filename=filename.stripWhiteSpace();

  //user didnt enter anything or cancelled
  if (!filename) { return; }

  const char *startfile = filename;
  static char	errorMessage[256];

  //tmpstring is full name of file
  QString tmpString(startfile);

  //figure out the extension here
  extension  = tmpString; //set to filename

	if (!getExtension(extension))
	{	sprintf (errorMessage, "Invalid filename:\n\'%s\'\n\nLooking for something like\n\'file0000.bmp\', \'file0000.BMP\', etc.", startfile);
			QMessageBox::information(this, "Jahshaka", errorMessage);
			return; }

	index = tmpString.findRev((const char*)extension);
	tmpString.truncate(index); //total path without .bmp extension

	QString	stillString;	stillString = (const char*)tmpString;
	QString	baseString;	    baseString = (const char*)tmpString;



	////////////////////////////////////////////////
	// this is where we deal with the p[adding

	debug(" >>>> PADDING <<<<");

    data1="tmpstring is now :" +tmpString; debug(data1);  //tmpString is now 0000 or startframe

	index = tmpString.length();

	//figure out how many zeros...
	int extcount=0;
	QString tempstring(tmpString);
	QString extchar;

	for (int ii=index; ii>=0; ii--) {
	
		extchar = tempstring.right(1);

		if (isanumber(extchar)) {	tempstring.truncate( tempstring.length()-1 );
									extcount++;
									debug(tempstring); }

	}

	index -= extcount;					//remove number of zeros in  sequence
	baseString.truncate(index);			//basestring is now total path without zeros or .bmp
	tmpString.remove(0, index);
    data1="tmpstring after remove :" +tmpString; debug(data1);  //tmpString is now 0000 or startframe
	
	QString theextension (tmpString);	//set theextension value, later to be videoext

	QString	stillName((const char*)stillString);
	int	slash = stillName.findRev('/');
	if(slash > 0) stillName.remove(0, slash+1);

	QString	shortName((const char*)baseString);
	slash = shortName.findRev('/');
	if(slash > 0) shortName.remove(0, slash+1);

    QString pathName;
    QString	pathString;	  pathString = (const char*)filename;
    int ras; ras = pathString.length() - (stillName.length()+extension.length() );
	pathString.truncate(ras);


	//////////////////////////////////////////////
	// its a still image there are no more frames

	//need a better way to work this out...
	debug(">>> startframe data");
	debug(tmpString);

	int	startFrame = tmpString.toInt(&ok);
	
    debug("startframe after conversion:"+data1.setNum(startFrame));  //tmpString is now 0000 or startframe

	if (!ok)
	{

		debug(">>> Its a still");

		int clipn; clipn = *clipnumber;
		clipn++;
		*clipnumber = clipn;

		QString temp;

		thedata.theCategory = IMAGE;
		thedata.cliptype    = STILL;

		thedata.clipname    = stillName;    //clipname is truncated filename
		thedata.clipnumber  = clipn;
		thedata.location    = pathString;    //the path without the filename...
		thedata.filename    = stillName;     //the filename on disk without extension
		thedata.extension   = extension; //we need to change this based on extension
		thedata.startframe  = 1;
		thedata.endframe    = 1;
		thedata.keyStatus   = FALSE;
		thedata.xpos        = 10;
		thedata.ypos        = 10;


	   if ( !filename.isEmpty() ) {

		 if ( !no_writing ) {       //thedata.extension needs to be set properly here according to extension

        QImageIO iio; iio.setFileName( filename );
        if (extension==".tga" || extension==".TGA") { iio.setFormat("TGA"); }
        if ( iio.read() )  buffer = iio.image();  // convert to pixmap

			thedata.Image = buffer;

			addImage2(thedata);
			addImage2database( thedata );

		 }
		}

	   canvas->update();
	   return;


	}

	//ok so we know its a sequence and not just a single image
	//so we need to findout how many frames...
	debug(">>> Its a sequence");

	int	numFrames	= 0;
	

	for (i = startFrame; i < (int)startFrame+maxFrames; i++)
	{

		//need to fix this here to account for varying sequences... its a rig for now...

		//QString pad; pad = "%s%04d%s";
		QString pad; pad = "%s%"; pad += "0";
		QString extc; extc.setNum(extcount);
		pad+=extc; pad += "d%s";

		tmpString.sprintf(pad, (const char*)baseString, i, (const char*)extension);
		
		//debug("trying to open"+tmpString);

		check = fopen((const char*)tmpString, "r");
		if (!check)
		{
			if (i == 0)
			{
				warning ("File \'%s\' not found. Sequence aborted.", (const char*)tmpString);
        return;
//				return -1;
			}
			maxFrames = i-startFrame;
			break;
		}
		else
			fclose(check);
	}
    int numberFrames =  startFrame + maxFrames;
    debug("numberFrames  :" +data1.setNum(numberFrames) );

	//update desktop clip number

    int clipn; clipn = *clipnumber;
    clipn++;
    *clipnumber = clipn;

	//clipnumber++;

    QString temp;
//    videoData thedata;

    thedata.theCategory = CLIP;
	thedata.cliptype    = SEQUENCE;

	//figure out what this is and make it dynamic
	thedata.videoext    = theextension;

    thedata.clipname    = shortName;
    thedata.clipnumber  = clipn;
    thedata.location    = pathString;
    thedata.filename    = shortName;
    thedata.extension   = extension;
    thedata.startframe  = startFrame;
    thedata.endframe    = numberFrames-1; //minus startframe
    thedata.keyStatus   = FALSE;
    thedata.xpos        = 10;
    thedata.ypos        = 10;

   if ( !filename.isEmpty() ) {

     if ( !no_writing ) {

        QImageIO iio; iio.setFileName( filename );
        if (extension==".tga" || extension==".TGA") { iio.setFormat("TGA"); }
        if ( iio.read() )  buffer = iio.image();  // convert to pixmap

        //buffer.load( filename );   //this needs to be exactly whats in filename

        thedata.Image = buffer;

        addImage2(thedata);
        addImage2database( thedata );
     }
    }

   canvas->update();
   return;

}


/////////////////////////////////////////////////
// save doesnt do much right now
// later on it will export clips etc to mpeg etc

void JahDesktop::slotSave() {
    // we are saving the globalimage here
    QString format = "BMP";
    QImage  theclip = editor->globalimage;

    QPixmap buffer;
    buffer = theclip;

    QString filename = QFileDialog::getSaveFileName( JahBasePath+"/images",  QString( "*.%1" ).arg( format.lower() ), this );
    if ( !filename.isEmpty() ) {

     if ( !no_writing )
        buffer.save( filename, format.upper() );
    }
}

bool JahDesktop::getExtension(QString & string) {

	QString ext;
	bool ok;

	string = string.right(4);
	ext    = string.lower();

	if (ext==".bmp")	{ ok = true; } else
	if (ext==".jpg")	{ ok = true; } else
	if (ext==".png")	{ ok = true; } else
	if (ext==".gif")	{ ok = true; } else
	if (ext==".tga")	{ ok = true; } else
						{ ok = false;}

	return ok;

}

bool JahDesktop::isanumber(QString & string) {

	bool ok;

	if (string=="0")	{ ok = true; } else
	if (string=="1")	{ ok = true; } else
	if (string=="2")	{ ok = true; } else
	if (string=="3")	{ ok = true; } else
	if (string=="4")	{ ok = true; } else
	if (string=="5")	{ ok = true; } else
	if (string=="6")	{ ok = true; } else
	if (string=="7")	{ ok = true; } else
	if (string=="8")	{ ok = true; } else
	if (string=="9")	{ ok = true; } else
						{ ok = false;}

	return ok;

}

		
	
