/*******************************************************************************
**
** The header file for the Jahshaka widget module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/


#ifndef VIDEODATA_H
#define VIDEODATA_H

#include "qstring.h"
#include "qimage.h"

enum VideoCategory     { IMAGE, KEY, CLIP, CLIPKEY };

enum VideoType         { STILL, SEQUENCE, QUICKTIME, AVI, MPEG };


//we should store clip size data in here as well for easy access


struct mediaSize {

    int         width;
    int         height;

};

struct videoData {

    VideoCategory theCategory;
	  VideoType     cliptype;


    QString     clipname;
    int         clipnumber;
    QImage      Image;
    QString     location,filename;
    QString     extension;
    int         startframe, endframe;
	  QString		  videoext, videoextkey;

    QImage      KeyImage;
    QString     keylocation,keyfilename;
    QString     keyextension;
    int         keystartframe, keyendframe;

    bool        keyStatus;
    double      xpos;
    double      ypos;

public:

    void        printinfo(void) {

		QString data1;
		debug("--------------------------------");
		if (theCategory == IMAGE) { data1 = "Type Image :"; }
		if (theCategory == CLIP ) { data1 = "Type Clip  :"; }
		debug(data1+ " clipname :" + clipname + " Clipnumber :" + data1.setNum(clipnumber) );
		debug( "File :" + location + filename +extension );
		debug( "Start :" + data1.setNum(startframe) + " End :" + data1.setNum(endframe) );
		debug( "Xpos  :" + data1.setNum(xpos) + " Ypos :" + data1.setNum(ypos) );
		debug("--------------------------------");

	};

    const char* getFileName() {

        QString loadfile,temp,blank;

        loadfile = location + filename + videoext + extension;

        const char* text1=loadfile;
        int   text1len = loadfile.length();
        char* rere = new char[text1len];
        strcpy(rere,text1);

        return rere;
    };

    int  getMaxFrames() {

        int max = endframe - startframe;
        if (max == 0) { max = 1; }
        return max;
    };

};


#endif






