/*******************************************************************************
**
** The header file for the Jahshaka network server module header
** The Jahshaka Project
** Copyright (C) 2000-2003 Visual Media, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include <qsocket.h>
#include <qserversocket.h>
#include <qapplication.h>
#include <qvbox.h>
#include <qtextview.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtextstream.h>
#include <qimage.h>
#include <qfile.h>

#include <stdlib.h>
#include <videodata.h>

#include <qhostaddress.h>

extern QString JahBasePath;

class ClientSocket : public QSocket
{
    Q_OBJECT
public:
  ClientSocket( int sock, QObject *parent=0, int theport=4242, const char *name=0 ) :
	      QSocket( parent, name ),senttext (false), sentdata (false)
  {
    line = 0;
    servport = theport;

    connect( this, SIGNAL(readyRead()), SLOT(readClient() ) );
    connect( this, SIGNAL(connectionClosed()), SLOT(connectionClosed()) );
    connect( this, SIGNAL(sendtext(QString)), parent, SLOT( socketText(QString)) );

    connect( this, SIGNAL(updateDesktop(videoData)), parent, SLOT( socketUpdateDesktop(videoData)) );

    setSocket( sock );
    thesocket = sock;

  }

  ~ClientSocket() {  }



  int thesocket,servport;
  bool senttext,sentdata;
  videoData * datafile;

  void readClientData();
  void readClientMedia();

private slots:
  void readClient();
  void connectionClosed();

signals:
  void sendtext(QString);
  void updateDesktop( videoData );

private:
  int line;

};

// The SimpleServer class handles new connections to the server. For every
// client that connects, it creates a new ClientSocket -- that instance is now
// responsible for the communication with that client.

class SimpleServer : public QServerSocket
{
    Q_OBJECT
public:
  SimpleServer( int port=4242, QObject* parent=0 ) : QServerSocket( port, 1, parent )
  {
    QString theport; theport.setNum(port);
    if ( !ok() ) { debug("Failed to bind to port "+theport);   }
      else       { debug("Jahserver bound to port "+theport);  }
    portnumber = port;

    connect( this, SIGNAL(sendupdateDesktop(videoData)), parent, SLOT( updatetheDesktop(videoData)) );

  }

  ~SimpleServer()  { }

  void newConnection( int socket );

  int portnumber;
  QHostAddress  * address;

  int lastPortNum( void);

public slots:
  void socketText(QString);
  void socketUpdateDesktop(videoData);

signals:
  void newConnect();
  void copyText(QString);
  void sendupdateDesktop(videoData);
  void recipConnect(QHostAddress);

};




