/*******************************************************************************
**
** The source file for the Jahshaka editing interface module
** The Jahshaka Project
** Copyright (C) 2000-2001 Bedagi, Inc.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "networking.h"

void JahNet::buildInterface( QHBox* qtinterface ) {

///////////////////////////This is the interface////////////////////////////////

    LayersFrame = new QFrame( qtinterface, "EffectsFrame" );
    LayersFrame->setGeometry( QRect( 0, 0, 80, 140 ) );
    LayersFrame->setMinimumSize( QSize( 80, 140 ) );  //was 960
    LayersFrame->setMaximumSize( QSize( 80, 140 ) );

    //////////////////// layer options /////////////////////////
    AddClient = new QPushButton( LayersFrame, "client" );
    AddClient->setGeometry( QRect( 0, 5, 75, 25 ) );
    AddClient->setText( tr( "Chat"  ) );
    connect( AddClient,  SIGNAL(clicked()), this, SLOT( clientinterface())  );

    AddServer = new QPushButton( LayersFrame, "server" );
    AddServer->setGeometry( QRect( 0, 30, 75, 25 ) );
    AddServer->setText( tr( "Server"  ) );
    connect( AddServer,  SIGNAL(clicked()), this, SLOT( serverinterface())  );

    AddGnutella = new QPushButton( LayersFrame, "Gnutella" );
    AddGnutella->setGeometry( QRect( 0, 55, 75, 25 ) );
    AddGnutella->setText( tr( "Gnutella"  ) );
    //connect( AddGnutella,  SIGNAL(clicked()), this, SLOT( gnutellainterface())  );

    AddSfs = new QPushButton( LayersFrame, "sfs" );
    AddSfs->setGeometry( QRect( 0, 80, 75, 25 ) );
    AddSfs->setText( tr( "SfS"  ) );
    //connect( AddSfs,  SIGNAL(clicked()), this, SLOT( sfsinterface())  );


    //////////////////////////////////////////////////////////////

    NetInterface = new QWidgetStack(qtinterface);
    NetInterface->setGeometry( QRect( 0, 0, 855, 140) );

    ClientBox   = new QHBox(NetInterface); NetInterface->addWidget(ClientBox,0);
    ServerBox = new QVBox(NetInterface); NetInterface->addWidget(ServerBox,1);

    NetInterface->raiseWidget(0);

    ////////////////// serverinterface and options
  QString itext = "Welcome to the Jahshaka File Server";
	QLabel *lb = new QLabel( itext, ServerBox );
	lb->setAlignment( AlignHCenter );

	infoText = new QTextView( ServerBox );
	QPushButton *quit = new QPushButton( "close connection" , ServerBox );


    clientframe = new QFrame( ClientBox, "clientframe" );
    clientframe->setGeometry( QRect( 0, 0, 620, 140 ) );
    clientframe->setFrameShape( QFrame::StyledPanel );
    clientframe->setFrameShadow( QFrame::Raised );

    ClientLabel = new QLabel( clientframe, "ClientLabel" );
    ClientLabel->setGeometry( QRect( 70, 0, 170, 20 ) );
    ClientLabel->setText( tr( "Jahshaka Http Network Client" ) );

    serverlabel = new QLabel( clientframe, "serverlabel" );
    serverlabel->setGeometry( QRect( 330, 0, 60, 20 ) );
    serverlabel->setText( tr( "Server IP" ) );

    serveredit = new QLineEdit( clientframe, "serveredit" );
    serveredit->setGeometry( QRect( 330, 20, 140, 26 ) );
    serveredit->setText( "localhost" );

    texteditbox = new QLineEdit( clientframe, "texteditbox" );
    texteditbox->setGeometry( QRect( 330, 60, 200, 70 ) );

    connectbutton = new QPushButton( clientframe, "connectbutton" );
    connectbutton->setGeometry( QRect( 540, 20, 70, 30 ) );
    connectbutton->setText( tr( "Connect" ) );

    sendbutton = new QPushButton( clientframe, "sendbutton" );
    sendbutton->setGeometry( QRect( 540, 60, 70, 30 ) );
    sendbutton->setText( tr( "Send" ) );

    sendimagebutton = new QPushButton( clientframe, "sendbutton" );
    sendimagebutton->setGeometry( QRect( 640, 60, 90, 30 ) );
    sendimagebutton->setText( tr( "Send Clip" ) );

    closebutton = new QPushButton( clientframe, "closebutton" );
    closebutton->setGeometry( QRect( 540, 100, 70, 30 ) );
    closebutton->setText( tr( "Close" ) );

    clienttextfeedback = new QTextView( clientframe, "clienttextfeedback" );
    clienttextfeedback->setGeometry( QRect( 10, 24, 300, 110 ) );


}


void JahNet::clientinterface(void) { NetInterface->raiseWidget(0); }

void JahNet::serverinterface(void) { NetInterface->raiseWidget(1); }



void JahNet::buildController( QHBox* controller) { }





























